#include "QtMainWindow.h"
#include "ui_QtMainWindow.h"

KODatUNO Kodatuno;	// KODatUNONX̃CX^XO[o錾

// CEBhE
QtMainWindow::QtMainWindow(QWidget *parent): QMainWindow(parent), ui(new Ui::QtMainWindow)
{
    ui->setupUi(this);
    
    // INIt@CC^[tF[X̃CX^X
    setting = new QSettings("kodatuno.ini", QSettings::IniFormat);

    // GUȈ
    initGUI();

    // Kodatunȍ
    Kodatuno.InitializeWin(ui->describeWidget->width(), ui->describeWidget->height());

    // INIt@CR}h擾
    QStringList cmdList = setting->value("cmd_history").toStringList();
    if(cmdList.length() != 0){
        for(int i = 0; i < cmdList.length(); i++){
            Kodatuno.SetConsoleHistory(cmdList[i].toStdString());
        }
    }

    // INIt@CUserStatus擾
    int mode = setting->value("user_stat_mode").toInt();
    double prop[USERPROPNUM];
    QStringList propList = setting->value("user_stat_prop").toStringList();
    if(propList.length() != 0){
        for(int i=0;i<USERPROPNUM;i++){
            prop[i] = propList[i].toDouble();
        }
    }
    Kodatuno.AcceptUserStat(mode,prop);
}

// Initializing GUI
void QtMainWindow::initGUI()
{
    // INIt@CǂݍŁCEBWFbgɔf
    restoreGeometry(setting->value("geometry").toByteArray());
    restoreState(setting->value("dock").toByteArray());
    
    // GUĨCX^XC^[tF[XɃZbg
    GuiIF.SetConsoleObject(ui->consoleText);            // R\[pGUĨIuWFNg̃CX^XZbg
    GuiIF.SetBodyListObject(ui->bodyList);              // BODYXgpGUĨIuWFNg̃CX^XZbg
    GuiIF.SetOpenFileActionObject(ui->actionOpenBody);	// t@CI[vpGUĨIuWFNg̃CX^XZbg
    GuiIF.SetDelBodyActionObject(ui->actionDeleteBody);	// BODY폜pGUĨIuWFNg̃CX^XZbg
    GuiIF.SetDescribeWidget(ui->describeWidget);        // OpenGL`pGUĨIuWFNg̃CX^XZbg
    GuiIF.SetStatusBarObject(ui->statusBar);            // Xe[^Xo[pGUĨIuWFNg̃CX^XZbg
    GuiIF.SetUserFunc1Action(ui->actionUserFunc1);      // UserFunc1̃xZbg
    GuiIF.SetUserFunc2Action(ui->actionUserFunc2);      // UserFunc2̃xZbg
    GuiIF.SetUserFunc3Action(ui->actionUserFunc3);      // UserFunc3̃xZbg
    GuiIF.SetUserFunc4Action(ui->actionUserFunc4);      // UserFunc4̃xZbg
    GuiIF.SetUserFunc5Action(ui->actionUserFunc5);      // UserFunc5̃xZbg
    GuiIF.SetUserFunc6Action(ui->actionUserFunc6);      // UserFunc6̃xZbg
    GuiIF.SetUserFunc7Action(ui->actionUserFunc7);      // UserFunc7̃xZbg
    GuiIF.SetUserFunc8Action(ui->actionUserFunc8);      // UserFunc8̃xZbg
}

QtMainWindow::~QtMainWindow()
{
    Kodatuno.DeleteWin();
    delete ui;
}

// KodatunoGUIN[ỸCxg
void QtMainWindow::closeEvent(QCloseEvent *event)
{
    /* R}h擾 */
    int cmdNum = Kodatuno.GetConsoleHistoryNum();
    std::string cmdTemp;
    QStringList cmdList;
    if(cmdNum != 0){
        for(int i = 0; i < cmdNum; i++){
            Kodatuno.GetUpperConsoleHistory(&cmdTemp);
            cmdList.append(QString(cmdTemp.c_str()));
        }
    }

    // UserStatus擾
    int mode;
    double prop[USERPROPNUM];
    Kodatuno.GetUserStat(&mode,prop);
    QStringList uslist;
    for(int i=0;i<USERPROPNUM;i++)
        uslist.append(QString::number(prop[i]));


    // INIt@CփR}hUserStatus
    setting->setValue("geometry",saveGeometry());
    setting->setValue("dock",saveState());
    setting->setValue("cmd_history",cmdList);
    setting->setValue("user_stat_mode",mode);
    setting->setValue("user_stat_prop",uslist);
    setting->sync();

    // N[YCxg
    QMainWindow::closeEvent(event);
}

// j[FCreate->NURBS Rotation
void QtMainWindow::on_actionRotationSurface_triggered()
{
    QtRotSurfDialog* dlg = new QtRotSurfDialog(this);
    dlg->exec();
    ui->describeWidget->repaint();
}

// j[FCreate->Sweep
void QtMainWindow::on_actionSweepSurface_triggered()
{
    QtSweepSurfDialog* dlg = new QtSweepSurfDialog (this);
    dlg->exec();
    ui->describeWidget->repaint();
}

// j[FCreate->NURBS Curve
void QtMainWindow::on_actionNURBSCurve_triggered()
{
    QtNurbsCurveDialog* dlg = new QtNurbsCurveDialog(this);
    dlg->exec();
    ui->describeWidget->repaint();
}

// j[FCreate->NURBS Surface
void QtMainWindow::on_actionNURBSSarface_triggered()
{
    QtNurbsSurfDialog* dlg = new QtNurbsSurfDialog (this);
    dlg->exec();
    ui->describeWidget->repaint();
}

// j[FFile->Open File
void QtMainWindow::on_actionOpenBody_triggered()
{
    Kodatuno.OpenFile();		// t@CI[v
    Kodatuno.OpenDelBtn();      // OpenCDelete{^̕\̕ύX
    ui->describeWidget->repaint();
}

// j[FEdit->Delete BODY
void QtMainWindow::on_actionDeleteBody_triggered()
{
    Kodatuno.DeleteBody();  	// IĂBODY
    Kodatuno.OpenDelBtn();      // OpenCDelete{^̕\̕ύX
    ui->describeWidget->repaint();
}

// c[o[FX-View
void QtMainWindow::on_actionViewOnX_triggered()
{
    Kodatuno.ChangeViewX();
    ui->describeWidget->repaint();
}

// c[o[FY-View
void QtMainWindow::on_actionViewOnY_triggered()
{
    Kodatuno.ChangeViewY();
    ui->describeWidget->repaint();
}

// c[o[FZ-View
void QtMainWindow::on_actionViewOnZ_triggered()
{
    Kodatuno.ChangeViewZ();
    ui->describeWidget->repaint();
}

// c[o[FAC\View
void QtMainWindow::on_actionViewOnXYZ_triggered()
{
    Kodatuno.ChangeViewXYZ();
    ui->describeWidget->repaint();
}

// c[o[FʂɃtBbg
void QtMainWindow::on_actionViewFit_triggered()
{
    Kodatuno.FitView();
    ui->describeWidget->repaint();
}

// c[o[F\bh\
void QtMainWindow::on_actionViewSolid_triggered()
{
    Kodatuno.SolidView();
    ui->describeWidget->repaint();
}

// c[o[F\bhiO`Ȃj\
void QtMainWindow::on_actionViewNoEdge_triggered()
{
    Kodatuno.NoEdgeView();
    ui->describeWidget->repaint();
}

// c[o[FC[t[\
void QtMainWindow::on_actionViewWireFlame_triggered()
{
    Kodatuno.WireFlameView();
    ui->describeWidget->repaint();
}

// c[o[F\
void QtMainWindow::on_actionViewVoid_triggered()
{
    Kodatuno.VoidView();
    ui->describeWidget->repaint();
}

// c[o[FSđI
void QtMainWindow::on_actionSelectAll_triggered()
{
    Kodatuno.SelectAll();
    ui->describeWidget->repaint();
}

// c[o[FSĂ̑ILZ
void QtMainWindow::on_actionSelect_Cancel_triggered()
{
    Kodatuno.SelectionCancel();
    ui->describeWidget->repaint();
}

// c[o[F[U[ɂ`w߂LZ
void QtMainWindow::on_actionViewErase_triggered()
{
    Kodatuno.UserViewCanncel();
    ui->describeWidget->repaint();
}

// c[o[F\
void QtMainWindow::on_actionViewBlend_triggered()
{
    Kodatuno.ViewBlending();
    ui->describeWidget->repaint();
}

// j[FView->Show Console
void QtMainWindow::on_actionShowConsole_triggered()
{
    ui->consoleDock->setVisible(true);
}

// j[FView->Show Body List
void QtMainWindow::on_actionShowBodyList_triggered()
{
    ui->bodyListDock->setVisible(true);
}

// BODY List̃ACeI
void QtMainWindow::on_bodyList_itemClicked(QListWidgetItem *item)
{
    Kodatuno.BodyListSelect();
}

// j[FUser->User Status
void QtMainWindow::on_actionUserStatus_triggered()
{
    // UserStatus_CAO\
    QtUserStatDialog* dlg = new QtUserStatDialog(this);
    dlg->show();
}

// j[FUser->User Status->User Func1
void QtMainWindow::on_actionUserFunc1_triggered()
{
    Kodatuno.ExecuteUserFuncMain(0);
    Kodatuno.ReDrawUserFunc();			// UserFuncɂ`w߂s
}

// j[FUser->User Status->User Func2
void QtMainWindow::on_actionUserFunc2_triggered()
{
    Kodatuno.ExecuteUserFuncMain(1);
    Kodatuno.ReDrawUserFunc();			// UserFuncɂ`w߂s
}

// j[FUser->User Status->User Func3
void QtMainWindow::on_actionUserFunc3_triggered()
{
    Kodatuno.ExecuteUserFuncMain(2);
    Kodatuno.ReDrawUserFunc();			// UserFuncɂ`w߂s
}

// j[FUser->User Status->User Func4
void QtMainWindow::on_actionUserFunc4_triggered()
{
    Kodatuno.ExecuteUserFuncMain(3);
    Kodatuno.ReDrawUserFunc();			// UserFuncɂ`w߂s
}

// j[FUser->User Status->User Func5
void QtMainWindow::on_actionUserFunc5_triggered()
{
    Kodatuno.ExecuteUserFuncMain(4);
    Kodatuno.ReDrawUserFunc();			// UserFuncɂ`w߂s
}

// j[FUser->User Status->User Func6
void QtMainWindow::on_actionUserFunc6_triggered()
{
    Kodatuno.ExecuteUserFuncMain(5);
    Kodatuno.ReDrawUserFunc();			// UserFuncɂ`w߂s
}

// j[FUser->User Status->User Func7
void QtMainWindow::on_actionUserFunc7_triggered()
{
    Kodatuno.ExecuteUserFuncMain(6);
    Kodatuno.ReDrawUserFunc();			// UserFuncɂ`w߂s
}

// j[FUser->User Status->User Func8
void QtMainWindow::on_actionUserFunc8_triggered()
{
    Kodatuno.ExecuteUserFuncMain(7);
    Kodatuno.ReDrawUserFunc();			// UserFuncɂ`w߂s
}

// j[FHelp->About Kodatuno
void QtMainWindow::on_actionAboutKodatuno_triggered()
{
    QMessageBox::information(   this,
                                tr("About Kodatuno"),
                                tr("Kodatuno R%1.%2").arg(KODATUNO_MAJOR_VER).arg(KODATUNO_MINOR_VER)
                                );
}
