#include "NURBS_Func.h"

// NurbsȐ̃[m
//   *nurb:[mۂNurbsȐւ̃|C^AK:Rg[|Cg̐AN:mbgxNg̐
int NURBS_Func::New_NurbsC(NURBSC *nurb,int K, int N)
{
	if((nurb->T = (double *)malloc(sizeof(double)*N)) == NULL)
		return KOD_ERR;
	if((nurb->W = (double *)malloc(sizeof(double)*K)) == NULL){
		free(nurb->T);
		return KOD_ERR;
	}
	if((nurb->cp = (Coord *)malloc(sizeof(Coord)*K)) == NULL){
		free(nurb->T);
		free(nurb->W);
		return KOD_ERR;
	}

	return KOD_TRUE;
}

// NURBSȐz̃[
void NURBS_Func::Free_NurbsC_1DArray(NURBSC *a,int num)
{
	for(int i=0;i<num;i++)
		Free_NurbsC(&a[i]);
}

// 1{NURBSȐ̃[
void NURBS_Func::Free_NurbsC(NURBSC *a)
{
	free(a->T);
	free(a->W);
	free(a->cp);
}

// NURBSȖʂ̃[m
//   *nurb:[mۂNurbsȖʂւ̃|C^AK[2]:u,vRg[|Cg̐AN[2]:u,vmbgxNg̐
int NURBS_Func::New_NurbsS(NURBSS *nurb,int K[2],int N[2])
{
	int KOD_ERRflag = 0;

	if((nurb->S = (double *)malloc(sizeof(double)*N[0])) == NULL)
		goto EXIT;
	KOD_ERRflag++;	// 1
	if((nurb->T = (double *)malloc(sizeof(double)*N[1])) == NULL)
		goto EXIT;
	KOD_ERRflag++;	// 2
	if((nurb->W = NewMatrix(K[0],K[1])) == NULL)
		goto EXIT;
	KOD_ERRflag++; // 3
	if((nurb->cp = NewCoord2(K[0],K[1])) == NULL)
		goto EXIT;

	return KOD_TRUE;

EXIT:
	if(KOD_ERRflag == 3){
		FreeMatrix(nurb->W,nurb->K[0]);
		KOD_ERRflag--;
	}
	if(KOD_ERRflag == 2){
		free(nurb->T);
		KOD_ERRflag--;
	}
	if(KOD_ERRflag == 1){
		free(nurb->S);
	}

	return KOD_ERR;
}

// NURBSȖʔz̃[
void NURBS_Func::Free_NurbsS_1DArray(NURBSS *a,int num)
{
	for(int i=0;i<num;i++)
		Free_NurbsS(&a[i]);
}

// NURBSȖʂ̃[
void NURBS_Func::Free_NurbsS(NURBSS *a)
{
	free(a->S);
	free(a->T);
	FreeMatrix(a->W,a->K[0]);
	FreeCoord2(a->cp,a->K[0]);
}

// gʂ̃[m
int NURBS_Func::New_TrmS(TRMS *trms,int num)
{
	if((trms->pTI = (CONPS **)malloc(sizeof(CONPS *)*num)) == NULL){
		return KOD_ERR;
	}

	return KOD_TRUE;
}

// gʔz̃[
void NURBS_Func::Free_TrmS_1DArray(TRMS *a,int num)
{
	for(int i=0;i<num;i++)
		Free_TrmS(&a[i]);
}

// gʂ̃[
void NURBS_Func::Free_TrmS(TRMS *a)
{
	free(a->pTI);
}

// Ȑ̃[m
int NURBS_Func::New_CompC(COMPC *compc,int num)
{
	if((compc->DEType = (int *)malloc(sizeof(int)*num)) == NULL){
		return KOD_ERR;
	}
	
	if((compc->pDE = (COMPELEM **)malloc(sizeof(COMPELEM *)*num)) == NULL){
		free(compc->DEType);
		return KOD_ERR;
	}

	compc->N = num;

	return KOD_TRUE;
}

// Ȑz̃[
void NURBS_Func::Free_CompC_1DArray(COMPC *a,int num)
{
	for(int i=0;i<num;i++)
		Free_CompC(&a[i]);
}

// Ȑ̃[
void NURBS_Func::Free_CompC(COMPC *a)
{
	free(a->DEType);
	free(a->pDE);
}


// 1NurbsȐ𐶐
int NURBS_Func::GenNurbsC(NURBSC *Nurbs,int K,int M,int N,double T[],double W[],Coord cp[],double V[],int prop[],int euflag)
{
	int i;

	Nurbs->K = K;
	Nurbs->M = M;
	Nurbs->N = N;
	Nurbs->V[0] = V[0];
	Nurbs->V[1] = V[1];
	Nurbs->T = (double *)malloc(sizeof(double)*Nurbs->N);
	Nurbs->W = (double *)malloc(sizeof(double)*Nurbs->K);
	Nurbs->cp = (Coord *)malloc(sizeof(Coord)*Nurbs->K);
	Nurbs->EntUseFlag = euflag;
	
	for(i=0;i<4;i++){
		Nurbs->prop[i] = prop[i];
	}
	for(i=0;i<N;i++){
		Nurbs->T[i] = T[i];
	}
	for(i=0;i<K;i++){
		Nurbs->W[i] = W[i];
		Nurbs->cp[i] = SetCoord(cp[i]);
	}
	Nurbs->Dstat.Color[0] = Nurbs->Dstat.Color[1] = Nurbs->Dstat.Color[2] = 1.0;
	Nurbs->Dstat.Color[3] = 0.5;

	return KOD_TRUE;
}

// 1NurbsȐ𐶐(NURBSȐ̃Rs[)(I[o[[h)
// @*Nurbs:VɐNURBSȐ@nurb:
int NURBS_Func::GenNurbsC(NURBSC *Nurbs,NURBSC nurb)
{
	int i;

	Nurbs->K = nurb.K;
	Nurbs->M = nurb.M;
	Nurbs->N = nurb.N;
	Nurbs->V[0] = nurb.V[0];
	Nurbs->V[1] = nurb.V[1];
	
	Nurbs->T = (double *)malloc(sizeof(double)*Nurbs->N);
	Nurbs->W = (double *)malloc(sizeof(double)*Nurbs->K);
	Nurbs->cp = (Coord *)malloc(sizeof(Coord)*Nurbs->K);
	for(i=0;i<nurb.N;i++){
		Nurbs->T[i] = nurb.T[i];
	}
	for(i=0;i<nurb.K;i++){
		Nurbs->W[i] = nurb.W[i];
		Nurbs->cp[i] = SetCoord(nurb.cp[i]);
	}

	return KOD_TRUE;
}

// GenNurbsC()ɂĐꂽNURBSȐ폜
void NURBS_Func::DelNurbsC(NURBSC *Nurbs)
{
	
	NURBS_Func hbody;
	hbody.Free_NurbsC(Nurbs);
}

// 1NurbsȖʂ𐶐(NURBSȖʂ̃Rs[)
// @Mu,Mv:K  Ku,Kv:Rg[|Cg̐  *S,*T:u,vmbgxNg  **W:EGCg
// **Cp:Rg[|Cg  U_s,U_e,V_s,V_e:umbgxNg̊Jnl,Il
int NURBS_Func::GenNurbsS(NURBSS *Nurbs,int Mu,int Mv,int Ku,int Kv,double *S,double *T,double **W,Coord **Cp,double U_s,double U_e,double V_s,double V_e)
{
	Nurbs->K[0] = Ku;
	Nurbs->K[1] = Kv;
	Nurbs->M[0] = Mu;
	Nurbs->M[1] = Mv;
	Nurbs->U[0] = U_s;
	Nurbs->U[1] = U_e;
	Nurbs->V[0] = V_s;
	Nurbs->V[1] = V_e;
	Nurbs->N[0] = Mu+Ku;
	Nurbs->N[1] = Mv+Kv;

	for(int i=0;i<5;i++)
		Nurbs->prop[i] = 0;

	Nurbs->Dstat.Color[0] = Nurbs->Dstat.Color[1] = Nurbs->Dstat.Color[2] = 0.2;
	Nurbs->Dstat.Color[3] = 0.5;

	if(New_NurbsS(Nurbs,Nurbs->K,Nurbs->N) == KOD_ERR){
        GuiIF.SetMessage("NURBS_Func KOD_ERROR:fail to allocate memory");
		return KOD_ERR;
	}

	//Nurbs->S = (double *)malloc(sizeof(double)*Nurbs->N[0]);
	//Nurbs->T = (double *)malloc(sizeof(double)*Nurbs->N[1]);
	//Nurbs->W = NewMatrix(Nurbs->K[0],Nurbs->K[1]);
	//Nurbs->cp = NewCoord2(Nurbs->K[0],Nurbs->K[1]);

	for(int i=0;i<Nurbs->N[0];i++)
		Nurbs->S[i] = S[i];

	for(int i=0;i<Nurbs->N[1];i++)
		Nurbs->T[i] = T[i];

	for(int i=0;i<Nurbs->K[0];i++){
		for(int j=0;j<Nurbs->K[1];j++){
			Nurbs->W[i][j] = W[i][j];
			Nurbs->cp[i][j] = SetCoord(Cp[i][j]);
		}
	}

	return KOD_TRUE;
}


// 1NurbsȖʂ𐶐(NURBSȖʂ̃Rs[)
// @*Nurbs:VɐNURBSȖʁ@nurb:
int NURBS_Func::GenNurbsS(NURBSS *Nurbs,NURBSS nurb)
{
	NURBS_Func hbody;
	int i,j;

	for(i=0;i<2;i++){
		Nurbs->K[i] = nurb.K[i];
		Nurbs->M[i] = nurb.M[i];
		Nurbs->N[i] = nurb.N[i];
		Nurbs->U[i] = nurb.U[i];
		Nurbs->V[i] = nurb.V[i];
	}
	for(i=0;i<5;i++)
		Nurbs->prop[i] = nurb.prop[i];

	Nurbs->Dstat = nurb.Dstat;

	// [m
	if(hbody.New_NurbsS(Nurbs,Nurbs->K,Nurbs->N) == KOD_ERR){
        GuiIF.SetMessage("NURBS_Func KOD_ERROR:fail to allocate memory");
		return KOD_ERR;
	}

	for(i=0;i<Nurbs->N[0];i++)
		Nurbs->S[i] = nurb.S[i];
	for(i=0;i<Nurbs->N[1];i++)
		Nurbs->T[i] = nurb.T[i];
	for(i=0;i<Nurbs->K[0];i++){
		for(j=0;j<Nurbs->K[1];j++){
			Nurbs->W[i][j] = nurb.W[i][j];
			Nurbs->cp[i][j] = SetCoord(nurb.cp[i][j]);
		}
	}

	return KOD_TRUE;
}

// NurbsC_ʂAxisdeg]]T[tFXNurbsS𐶐
// Axis͒PʃxNgƂ
int NURBS_Func::GenRotNurbsS(NURBSS *NurbsS,NURBSC NurbsC,Coord Axis,double deg)
{
	// 360xȊO͖
	if(deg != 360){
        GuiIF.SetMessage("Unsupported");
		return KOD_ERR;
	}

	Axis = NormalizeVec(Axis);		// K

	// NurbsS𐶐
	double S[12] = {0,0,0,0.25,0.25,0.5,0.5,0.75,0.75,1,1,1};		// umbgxNg
	double **W;			// EGCg
	Coord  **Cp;		// Rg[|Cg
	if((W = NewMatrix(9,NurbsC.K)) == NULL){
        GuiIF.SetMessage("NURBS_Func KOD_ERROR:fail to allocate memory");
		return KOD_ERR;
	}
	if((Cp = NewCoord2(9,NurbsC.K)) == NULL){
        GuiIF.SetMessage("NURBS_Func KOD_ERROR:fail to allocate memory");
		FreeMatrix(W,9);
		return KOD_ERR;
	}
	for(int i=0;i<9;i++){		// u
		for(int j=0;j<NurbsC.K;j++){		// v
			Coord Q_ = CalcRotVec(NurbsC.cp[j],Axis,(double)i*PI/4);		// XNURBSȐ̃Rg[|CgAxis45x]
			Coord P = CalcNormalLine(NurbsC.cp[j],SetCoord(0,0,0),Axis);	// Axis̉]S̍W
			Coord PQ_ = SubCoord(Q_,P);										// PQ_xNg𐶐
			if(i%2 == 0){													// i=0,2,4,6̂Ƃ
				W[i][j] = 1;												// EGCg1
				Cp[i][j] = SetCoord(Q_);									// Q_̂܂܃Rg[|CgɂȂ
			}
			else{															// i=1,3,5,7̂Ƃ
				W[i][j] = cos(PI/4);										// EGCgvZ
				Cp[i][j] = AddCoord(MulCoord(PQ_,1/cos(PI/4)),P);			// Rg[|CgvZ
			}
		}
	}

	GenNurbsS(NurbsS,3,NurbsC.M,9,NurbsC.K,S,NurbsC.T,W,Cp,0,1,0,1);		// NURBSȖʐ

	FreeMatrix(W,2);
	FreeCoord2(Cp,2);

	return KOD_TRUE;
}

// 1NURBSȐ炠鎲ɂ鋗XC[vXC[vT[tFX𐶐
int NURBS_Func::GenSweepNurbsS(NURBSS *NurbsS,NURBSC NurbsC,Coord Axis,double Len)
{
	Axis = NormalizeVec(Axis);		// K

	// NurbsS𐶐
	double T[4] = {0,0,1,1};		// vmbgxNg
	double **W;			// EGCg
	Coord  **Cp;		// Rg[|Cg
	if((W = NewMatrix(NurbsC.K,2)) == NULL){
        GuiIF.SetMessage("NURBS_Func KOD_ERROR:fail to allocate memory");
		return KOD_ERR;
	}
	if((Cp = NewCoord2(NurbsC.K,2)) == NULL){
        GuiIF.SetMessage("NURBS_Func KOD_ERROR:fail to allocate memory");
		FreeMatrix(W,2);
		return KOD_ERR;
	}

	for(int i=0;i<NurbsC.K;i++){
		for(int j=0;j<2;j++){
			W[i][j] = NurbsC.W[i];	// EGCgvZ
			if(j==0)
				Cp[i][j] = SetCoord(NurbsC.cp[i]);		// Rg[|CgvZ
			else
				Cp[i][j] = SetCoord(AddCoord(NurbsC.cp[i],MulCoord(Axis,Len)));		// Rg[|CgvZ
		}
	}

	GenNurbsS(NurbsS,NurbsC.M,2,NurbsC.K,2,NurbsC.T,T,W,Cp,0,1,NurbsC.V[0],NurbsC.V[1]);	// NURBSȖʐ

	FreeMatrix(W,2);
	FreeCoord2(Cp,2);

	return KOD_TRUE;
}

// NURBSȖʏup[^lŒ肵Ƃ̃AC\pgbNNURBSȐ𐶐
//     *P:AC\pgbNȐNURBSȖ   u:ǔŒp[^   *C:ꂽAC\pgbNȐ
// Ԓl    KOD_ERR:u*Pup[^͈͊O
int NURBS_Func::GenIsoparamCurveU(NURBSS *P,double u,NURBSC *C)
{
	if(u < P->U[0] || u > P->U[1])	return KOD_ERR;

	double V[2] = {P->V[0],P->V[1]};	// mbgxNg͈̔
	int prop[4] = {0,0,1,0};		// p[^

	Coord *Q = NewCoord1(P->K[1]);	// Rg[|Cg
	double *W = NewVector(P->K[1]);	// EFCg

	for(int i=0;i<P->K[1];i++){
		InitCoord(&Q[i]);
		W[i] = 0;
		for(int j=0;j<P->K[0];j++){
			double bs = CalcBSbasis(u,P->S,P->N[0],j,P->M[0]);
			Q[i] = AddCoord(Q[i],MulCoord(P->cp[j][i],bs));
			W[i] += bs*P->W[j][i]; 
		}
	}

	GenNurbsC(C,P->K[1],P->M[1],P->N[1],P->T,W,Q,V,prop,0);

	FreeCoord1(Q);
	FreeVector(W);

	return KOD_TRUE;
}

// NURBSȖʏvp[^lŒ肵Ƃ̃AC\pgbNNURBSȐ𐶐
//     *S:AC\pgbNȐNURBSȖ   v:v̌Œp[^   *C:ꂽAC\pgbNȐ
// Ԓl    KOD_ERR:v*Pup[^͈͊O
int NURBS_Func::GenIsoparamCurveV(NURBSS *P,double v,NURBSC *C)
{
	if(v < P->V[0] || v > P->V[1])	return KOD_ERR;

	double V[2] = {P->U[0],P->U[1]};	// mbgxNg͈̔
	int prop[4] = {0,0,1,0};		// p[^

	Coord *Q = NewCoord1(P->K[0]);	// Rg[|Cg
	double *W = NewVector(P->K[0]);	// EFCg

	for(int i=0;i<P->K[0];i++){
		InitCoord(&Q[i]);
		W[i] = 0;
		for(int j=0;j<P->K[1];j++){
			double bs = CalcBSbasis(v,P->T,P->N[1],j,P->M[1]);
			Q[i] = AddCoord(Q[i],MulCoord(P->cp[i][j],bs));
			W[i] += bs*P->W[i][j]; 
		}
	}

	GenNurbsC(C,P->K[0],P->M[0],P->N[0],P->S,W,Q,V,prop,0);

	FreeCoord1(Q);
	FreeVector(W);

	return KOD_TRUE;
}

// GenNurbsS()ɂĐꂽNURBSȖʂ폜
void NURBS_Func::DelNurbsS(NURBSS *Nurbs)
{
	NURBS_Func hbody;
	hbody.Free_NurbsS(Nurbs);
}

// gʂLNURBSȖʂ𐶐
int NURBS_Func::GenTrimdNurbsS(TRIMD_NURBSS *TNurbs,TRIMD_NURBSS  tnurb)
{
	NURBSS *nurbsS;
	NURBSC *nurbsC;
	CONPS *conps_o,*conps_i;
	COMPC *compc_o,*compc_i;
	int curve_num=0;

	nurbsS = (NURBSS *)malloc(sizeof(NURBSS));		// NURBSȖʂ̃[m
	conps_o = (CONPS *)malloc(sizeof(CONPS));		// Og\ʏ̃[m
	compc_o = (COMPC *)malloc(sizeof(COMPC));		// Og\镡Ȑ̃[m

	// gʂ\NURBSȐ̑JEg
	for(int i=0;i<tnurb.n2;i++){
		for(int j=0;j<tnurb.pTI[i]->pB->CompC.N;j++){
			curve_num++;
		}
	}
	curve_num += tnurb.pTO->pB->CompC.N;

	nurbsC = (NURBSC *)malloc(sizeof(NURBSC)*curve_num);	// gʂ\NURBSȐ̐NURBSȐ̃[m

	GenNurbsS(nurbsS,*tnurb.pts);							// VNURBSȖʂ1
	TNurbs->pts = nurbsS;									// NURBSȖʂgʂɊ֘At

	New_TrmS(TNurbs,tnurb.n2);						// gʂ̃[m

	conps_i = (CONPS *)malloc(sizeof(CONPS)*tnurb.n2);		// \ʏ̃[m
	compc_i = (COMPC *)malloc(sizeof(COMPC)*tnurb.n2);		// \镡Ȑ̃[m

	// NURBSȐg\NURBSȐɊ֘At
	// Og
	TNurbs->pTO = conps_o;
	New_CompC(compc_o,tnurb.pTO->pB->CompC.N);
	for(int i=0;i<tnurb.pTO->pB->CompC.N;i++){
		GenNurbsC(&nurbsC[i],tnurb.pTO->pB->CompC.pDE[i]->NurbsC);
		compc_o->pDE[i] = (COMPELEM *)(&nurbsC[i]);
		compc_o->DEType[i] = tnurb.pTO->pB->CompC.DEType[i];
	}
	TNurbs->pTO->pB = (CURVE *)compc_o;
	TNurbs->pTO->BType = tnurb.pTO->BType;
	TNurbs->pTO->pB->CompC.DegeFlag = tnurb.pTO->pB->CompC.DegeFlag;
	TNurbs->pTO->pB->CompC.DegeNurbs = tnurb.pTO->pB->CompC.DegeNurbs;

	// g
	curve_num = 0;
	for(int i=0;i<tnurb.n2;i++){
		TNurbs->pTI[i] = &(conps_i[i]);
		New_CompC(&compc_i[i],tnurb.pTI[i]->pB->CompC.N);
		for(int j=0;j<tnurb.pTI[i]->pB->CompC.N;j++){
			GenNurbsC(&nurbsC[tnurb.pTO->pB->CompC.N+curve_num],tnurb.pTI[i]->pB->CompC.pDE[j]->NurbsC);
			compc_i[i].pDE[j] = (COMPELEM *)(&nurbsC[tnurb.pTO->pB->CompC.N+curve_num]);
			compc_i[i].DEType[j] = tnurb.pTI[i]->pB->CompC.DEType[j];
			curve_num++;
		}
		TNurbs->pTI[i]->pB = (CURVE *)(&(compc_i[i]));
		TNurbs->pTI[i]->BType = tnurb.pTI[i]->BType;
		TNurbs->pTI[i]->pB->CompC.DegeFlag = tnurb.pTI[i]->pB->CompC.DegeFlag;
		TNurbs->pTI[i]->pB->CompC.DegeNurbs = tnurb.pTI[i]->pB->CompC.DegeNurbs;
	}

	TNurbs->n1 = tnurb.n1;
	TNurbs->n2 = tnurb.n2;

	return KOD_TRUE;
}

// GenTrimdNurbsS()ɂĐꂽgʂ폜
int NURBS_Func::DelTrimdNurbsS(TRIMD_NURBSS *TNurbs)
{
	NURBS_Func hbody;
	int curve_num = 0;

	// gʂ\SĂNURBSȐ̖{𒲂ׂ
	for(int i=0;i<TNurbs->n2;i++){
		for(int j=0;j<TNurbs->pTI[i]->pB->CompC.N;j++){
			curve_num++;
		}
	}
	curve_num += TNurbs->pTO->pB->CompC.N;

	hbody.Free_NurbsC_1DArray((NURBSC *)TNurbs->pTO->pB->CompC.pDE[0],curve_num);		// gʂ\SĂNURBSȐp[^̃[

	hbody.Free_NurbsS(TNurbs->pts);						// gʂ\NURBSȖʃp[^̃[
	free(TNurbs->pts);								// gʂ\NURBSȖʂ̃[

	hbody.Free_NurbsC(&TNurbs->pTO->pB->CompC.DegeNurbs);	// gʊO\镡Ȑ\kޗpNURBSȐ̃[
	hbody.Free_CompC((COMPC *)TNurbs->pTO->pB);			// gʊO\镡Ȑ\NURBSȐ̃[
	free(TNurbs->pTO->pB);							// gʊO\镡Ȑ̃[
	free(TNurbs->pTO);								// gʊO\ʏ̃[

	for(int i=0;i<TNurbs->n2;i++){
		hbody.Free_NurbsC(&TNurbs->pTI[i]->pB->CompC.DegeNurbs);	// gʓ\镡Ȑ\kޗpNURBSȐ̃[
		hbody.Free_CompC((COMPC *)TNurbs->pTI[i]->pB);	// gʓ\镡Ȑ\NURBSȐ̃[
		free(TNurbs->pTI[i]->pB);					// gʓ\镡Ȑ̃[
	}
	hbody.Free_TrmS(TNurbs);								// gʃp[^̃[

	return KOD_TRUE;
}

// w肵mbgtłNURBSȐ̍Wl߂
Coord NURBS_Func::CalcNurbsCCoord(NURBSC *NurbsC,double t)
{
	Coord p;
	Coord bscpw;
	double bsw=0;
	double bs=0;
	int i;

	InitCoord(&bscpw);	// 

	for(i=0;i<NurbsC->K;i++){
		bs = CalcBSbasis(t,NurbsC->T,NurbsC->N,i,NurbsC->M);		// BXvC֐߂
		bsw += bs*NurbsC->W[i];							// 
		bscpw = AddCoord(bscpw,MulCoord(NurbsC->cp[i],bs*NurbsC->W[i]));	// q
	}
	
	p = DivCoord(bscpw,bsw);	// Wl߂

	return p;
}

// w肵mbgtQłNURBSȐ̍Wl߂
//    *NurbsS:NURBSȖʂւ̃|C^   Ptnum:߂_Q̐   *T:tp[^Qi[z
//        *Pt:Wli[
void NURBS_Func::CalcNurbsCCoords(NURBSC *NurbsC,int Ptnum,double *T,Coord *Pt)
{
	for(int i=0;i<Ptnum;i++){
		Pt[i] = CalcNurbsCCoord(NurbsC,T[i]);
	}
}

// w肵mbgu,vłNURBSȖʂ̍Wl߂
Coord NURBS_Func::CalcNurbsSCoord(NURBSS *NurbsS,double div_u,double div_v)
{
	int i,j;
	double bs_u,bs_v;		// u,vBXvC֐
	double bsw=0;			// 
	Coord bscpw;			// q

	InitCoord(&bscpw);		// 

	for(i=0;i<NurbsS->K[0];i++){
		bs_u = CalcBSbasis(div_u,NurbsS->S,NurbsS->N[0],i,NurbsS->M[0]);			// uBXvC֐߂
		for(j=0;j<NurbsS->K[1];j++){
			bs_v = CalcBSbasis(div_v,NurbsS->T,NurbsS->N[1],j,NurbsS->M[1]);		// vBXvC֐߂
			bsw += bs_u*bs_v*NurbsS->W[i][j];
			bscpw = AddCoord(bscpw,MulCoord(NurbsS->cp[i][j],bs_u*bs_v*NurbsS->W[i][j]));
		}
	}
	//if(fabs(bsw) < APPROX_ZERO)
		//return(SetCoord(0,0,0));

	return(DivCoord(bscpw,bsw));
}

// w肵mbgu,vQłNURBSȖʂ̍WlQ߂
//    *NurbsS:NURBSȖʂւ̃|C^   Ptnum:߂_Q̐   *UV:u,vp[^Qi[Coord^z(UV[].xuAUV[].Ṽp[^i[Ă)
//        *Pt:Wli[
void NURBS_Func::CalcNurbsSCoords(NURBSS *NurbsS,int Ptnum,Coord *UV,Coord *Pt)
{
	for(int i=0;i<Ptnum;i++){
		Pt[i] = CalcNurbsSCoord(NurbsS,UV[i].x,UV[i].y);
	}
}

// BXvC֐vZAvZʂԂ
// t:mbg@knot[]:mbgxNg  N:mbgxNg̐  I:Bspl֐Y1(0`)  M:K(Bspl֐Y2)  
// N_I,M(t)
double NURBS_Func::CalcBSbasis(double t, double knot[],int N,int I,int M)
{
	// K(order)1̎
	if(M == 1){
		// ڒ̃mbg̒lmbgxNg̏I[lƓꍇA֐1肤͈͂knot[I+1]܂ނ悤ɂ
		// ȂƁÂƂSĂ̊֐l0ɂȂĂ܂B
		if(t==knot[N-1]){
			if(knot[I] <= t && t <= knot[I+1])	return 1.0;
			else		return 0.0;
		}
		else{
			if(knot[I] <= t && t < knot[I+1])	return 1.0;
			else	return 0.0;
		}
	}

	// ȊO̎
	else{
		double n1=0.0;
		double n2=0.0;
		double denom;

		denom = knot[I+M-1] - knot[I];	// 
		if(denom > 0.0){
			n1 = (t-knot[I])/denom * CalcBSbasis(t,knot,N,I,M-1);		// 1
		}

		denom = knot[I+M] - knot[I+1];
		if(denom > 0.0){
			n2 = (knot[I+M]-t)/denom * CalcBSbasis(t,knot,N,I+1,M-1);	// 2
		}

		return(n1+n2);
	}
}


// BXvC֐1KW߂
// t:mbg@knot[]:mbgxNg  N:mbgxNg̐  I:ڒ̃Rg[|Cg  M:K
double NURBS_Func::CalcDiffBSbasis(double t,double knot[],int N,int I,int M)
{
	double n1 = knot[I+M-1]-knot[I];
	double n2 = knot[I+M]-knot[I+1];

	if(n1 != 0.0) n1 = (M-1)/n1*CalcBSbasis(t,knot,N,I,M-1);
	
	if(n2 != 0.0) n2 = (M-1)/n2*CalcBSbasis(t,knot,N,I+1,M-1);
	
	return(n1-n2);
}

// BXvC֐NKW߂
// t:mbg@knot[]:mbgxNg  N:mbgxNg̐  I:ڒ̃Rg[|Cg  M:K  Dn:K
double NURBS_Func::CalcDiffBSbasisN(double t,double knot[],int N,int I,int M, int Dn)
{
	double n1 = knot[I+M-1]-knot[I];
	double n2 = knot[I+M]-knot[I+1];

	if(Dn==0){
		return(CalcBSbasis(t,knot,N,I,M));
	}
	if(Dn==1){
		return(CalcDiffBSbasis(t,knot,N,I,M));
	}
	if(n1 != 0) n1 = (M-1)/n1*CalcDiffBSbasisN(t,knot,N,I,M-1,Dn-1);
	if(n2 != 0) n2 = (M-1)/n2*CalcDiffBSbasisN(t,knot,N,I+1,M-1,Dn-1);

	return(n1-n2);
}


// NURBSȐ1KW߂
Coord NURBS_Func::CalcDiffNurbsC(NURBSC *NurbsC,double t)
{
	Coord Ft,diff_Ft;		// NURBSȐ̕q
	double Gt,diff_Gt;		// NURBSȐ̕
	double bs,diff_bs;		// BXvC֐
	Coord p;
	int i;

	InitCoord(&Ft);
	InitCoord(&diff_Ft);
	Gt = 0;
	diff_Gt = 0;

	// eWZo
	for(i=0;i<NurbsC->K;i++){
		bs = CalcBSbasis(t,NurbsC->T,NurbsC->N,i,NurbsC->M);
		diff_bs = CalcDiffBSbasis(t,NurbsC->T,NurbsC->N,i,NurbsC->M);

		Ft = AddCoord(Ft,MulCoord(NurbsC->cp[i],bs*NurbsC->W[i]));
		diff_Ft = AddCoord(diff_Ft,MulCoord(NurbsC->cp[i],diff_bs*NurbsC->W[i]));

		Gt += bs*NurbsC->W[i];
		diff_Gt += diff_bs*NurbsC->W[i];
	}
	if(fabs(Gt) < APPROX_ZERO)	return(SetCoord(0,0,0));

	// 1K߂
	p = SubCoord(DivCoord(diff_Ft,Gt),DivCoord(MulCoord(Ft,diff_Gt),Gt*Gt));

	return p;
}

// NURBSȐ2KW߂
Coord NURBS_Func::CalcDiff2NurbsC(NURBSC *NurbsC,double t)
{
	double w0=0;
	double w1=0;
	double w2=0;
	Coord  A2=SetCoord(0,0,0);
	Coord  P0=SetCoord(0,0,0);
	Coord  P1=SetCoord(0,0,0);

	P0 = CalcNurbsCCoord(NurbsC,t);
	P1 = CalcDiffNurbsC(NurbsC,t);

	for(int i=0;i<NurbsC->K;i++){
		w0 += CalcBSbasis(t,NurbsC->T,NurbsC->N,i,NurbsC->M) * NurbsC->W[i];
		w1 += CalcDiffBSbasis(t,NurbsC->T,NurbsC->N,i,NurbsC->M) * NurbsC->W[i];
		w2 += CalcDiffBSbasisN(t,NurbsC->T,NurbsC->N,i,NurbsC->M,2) * NurbsC->W[i];
		A2 = AddCoord(A2,MulCoord(NurbsC->cp[i],CalcDiffBSbasisN(t,NurbsC->T,NurbsC->N,i,NurbsC->M,2) * NurbsC->W[i]));
	}

	return DivCoord(SubCoord(A2,AddCoord(MulCoord(P1,2*w1),MulCoord(P0,2*w2))),w0);
}

// NURBSȐrKW߂
Coord NURBS_Func::CalcDiffNNurbsC(NURBSC *NurbsC,int r,double t)
{
	if(!r)
		return CalcNurbsCCoord(NurbsC,t);

	Coord Ar = InitCoord();
	double W = 0;
	for(int i=0;i<NurbsC->K;i++){
		double bsr = CalcDiffBSbasisN(t,NurbsC->T,NurbsC->N,i,NurbsC->M,r);
		Ar = AddCoord(Ar,MulCoord(NurbsC->cp[i],bsr*NurbsC->W[i]));
		W += NurbsC->W[i]*CalcBSbasis(t,NurbsC->T,NurbsC->N,i,NurbsC->M);
	}

	Coord Br = InitCoord();
	for(int i=1;i<=r;i++){
		double Wi = 0;
		for(int j=0;j<NurbsC->K;j++){
			double bsi = CalcDiffBSbasisN(t,NurbsC->T,NurbsC->N,j,NurbsC->M,i);
			Wi += bsi*NurbsC->W[j];
		}
		if(Wi == 0.0)  return(InitCoord());
		Br = AddCoord(Br,MulCoord(CalcDiffNNurbsC(NurbsC,r-i,t),(double)nCr(r,i)*Wi));	// A
	}

	return (DivCoord(SubCoord(Ar,Br),W));
}

// NURBSȖʂu1KW𓾂
Coord NURBS_Func::CalcDiffuNurbsS(NURBSS *NurbsS,double div_u,double div_v)
{
	int i,j;
	Coord Ft,diff_Ft;
	double Gt,diff_Gt;
	double bs_u,bs_v;		// u,vBXvC֐
	double diff_bs_u;
	Coord p;

	InitCoord(&Ft);
	InitCoord(&diff_Ft);
	Gt = 0;
	diff_Gt = 0;

	for(i=0;i<NurbsS->K[0];i++){
		bs_u = CalcBSbasis(div_u,NurbsS->S,NurbsS->N[0],i,NurbsS->M[0]);				// uBXvC֐߂
		diff_bs_u = CalcDiffBSbasis(div_u,NurbsS->S,NurbsS->N[0],i,NurbsS->M[0]);	// uBXvC֐1K߂
		for(j=0;j<NurbsS->K[1];j++){
			bs_v = CalcBSbasis(div_v,NurbsS->T,NurbsS->N[1],j,NurbsS->M[1]);			// vBXvC֐߂
			Ft = AddCoord(Ft,MulCoord(NurbsS->cp[i][j],bs_u*bs_v*NurbsS->W[i][j]));
			diff_Ft = AddCoord(diff_Ft,MulCoord(NurbsS->cp[i][j],diff_bs_u*bs_v*NurbsS->W[i][j]));
			Gt += bs_u*bs_v*NurbsS->W[i][j];
			diff_Gt += diff_bs_u*bs_v*NurbsS->W[i][j];
		}
	}

	if(fabs(Gt) < APPROX_ZERO_H)	return(SetCoord(0,0,0));

	// 1K߂
	p = SubCoord(DivCoord(diff_Ft,Gt),DivCoord(MulCoord(Ft,diff_Gt),Gt*Gt));

	return p;
}

// NURBSȖʂv1KW𓾂
Coord NURBS_Func::CalcDiffvNurbsS(NURBSS *NurbsS,double div_u,double div_v)
{
	int i,j;
	Coord Ft,diff_Ft;
	double Gt,diff_Gt;
	double bs_u,bs_v;		// u,vBXvC֐
	double diff_bs_v;
	Coord p;

	InitCoord(&Ft);
	InitCoord(&diff_Ft);
	Gt = 0;
	diff_Gt = 0;

	for(i=0;i<NurbsS->K[0];i++){
		bs_u = CalcBSbasis(div_u,NurbsS->S,NurbsS->N[0],i,NurbsS->M[0]);				// uBXvC֐߂
		for(j=0;j<NurbsS->K[1];j++){
			bs_v = CalcBSbasis(div_v,NurbsS->T,NurbsS->N[1],j,NurbsS->M[1]);				// vBXvC֐߂
			diff_bs_v = CalcDiffBSbasis(div_v,NurbsS->T,NurbsS->N[1],j,NurbsS->M[1]);	// vBXvC֐1K߂
			Ft = AddCoord(Ft,MulCoord(NurbsS->cp[i][j],bs_u*bs_v*NurbsS->W[i][j]));
			diff_Ft = AddCoord(diff_Ft,MulCoord(NurbsS->cp[i][j],bs_u*diff_bs_v*NurbsS->W[i][j]));
			Gt += bs_u*bs_v*NurbsS->W[i][j];
			diff_Gt += bs_u*diff_bs_v*NurbsS->W[i][j];
		}
	}

	if(fabs(Gt) < APPROX_ZERO_H)	return(SetCoord(0,0,0));

	// 1K߂
	p = SubCoord(DivCoord(diff_Ft,Gt),DivCoord(MulCoord(Ft,diff_Gt),Gt*Gt));

	return p;
}

// NURBSȖʂ̊eCӊKƂ̔W߂
//    *S:NURBSȖʂւ̃|C^   k:u̔K    l:v̔K   u,v:uvꂼ̃p[^
Coord NURBS_Func::CalcDiffNNurbsS(NURBSS *S,int k,int l,double u,double v)
{
	double w = CalcDiffNurbsSDenom(S,0,0,u,v);
	Coord  A = CalcDiffNurbsSNumer(S,k,l,u,v);
	Coord  B = SetCoord(0,0,0);
	Coord  C = SetCoord(0,0,0);
	Coord  D = SetCoord(0,0,0);

	if(!k && !l)
		return(CalcNurbsSCoord(S,u,v));
		
	for(int i=1;i<=k;i++)
		B = AddCoord(B,MulCoord(CalcDiffNNurbsS(S,k-i,l,u,v),nCr(k,i)*CalcDiffNurbsSDenom(S,i,0,u,v)));
	for(int j=1;j<=l;j++)
		C = AddCoord(C,MulCoord(CalcDiffNNurbsS(S,k,l-j,u,v),nCr(l,j)*CalcDiffNurbsSDenom(S,0,j,u,v)));
	for(int i=1;i<=k;i++){
		for(int j=1;j<=l;j++){
			D = AddCoord(D,MulCoord(CalcDiffNNurbsS(S,k-i,l-j,u,v),nCr(l,j)*CalcDiffNurbsSDenom(S,i,j,u,v)));
		}
		D = MulCoord(D,nCr(k,i));
	}
	return(DivCoord(SubCoord(A,AddCoord(B,AddCoord(C,D))),w));

}

// NURBSȖʕ̊eCӊKƂ̔W߂
//    *S:NURBSȖʂւ̃|C^   k:u̔K    l:v̔K   u,v:uvꂼ̃p[^
double NURBS_Func::CalcDiffNurbsSDenom(NURBSS *S,int k,int l,double u,double v)
{
	double w=0;
	for(int i=0;i<S->K[0];i++){
		double Nk = CalcDiffBSbasisN(u,S->S,S->N[0],i,S->M[0],k);		// ukK
		for(int j=0;j<S->K[1];j++){
			double Nl = CalcDiffBSbasisN(v,S->T,S->N[1],j,S->M[1],l);	// vlK
			w += Nk*Nl*S->W[i][j];
		}
	}
	return w;
}

// NURBSȖʕq̊eCӊKƂ̔W߂
//    *S:NURBSȖʂւ̃|C^   k:u̔K    l:v̔K   u,v:uvꂼ̃p[^
Coord NURBS_Func::CalcDiffNurbsSNumer(NURBSS *S,int k,int l,double u,double v)
{
	Coord A=SetCoord(0,0,0);
	for(int i=0;i<S->K[0];i++){
		double Nk = CalcDiffBSbasisN(u,S->S,S->N[0],i,S->M[0],k);		// ukK
		for(int j=0;j<S->K[1];j++){
			double Nl = CalcDiffBSbasisN(v,S->T,S->N[1],j,S->M[1],l);	// vlK
			A = AddCoord(A,MulCoord(S->cp[i][j],Nk*Nl*S->W[i][j]));
		}
	}
	return A;
}


// NURBSȖʏ(u,v)ɂ@xNgƂ߂
Coord NURBS_Func::CalcNormVecOnNurbsS(NURBSS *nurb,double u,double v)
{
	Coord a = CalcDiffuNurbsS(nurb,u,v);
	Coord b = CalcDiffvNurbsS(nurb,u,v);

	return(NormalizeVec(CalcOuterProduct(a,b)));
}

// NURBSȐtɂPʐڃxNgƂ߂
Coord NURBS_Func::CalcTanVecOnNurbsC(NURBSC *C,double t)
{
    return NormalizeVec(CalcDiffNurbsC(C,t));
}

// NURBSȖʏ(u,v)ɂ@xNgu1KƂ߂
// Nu = Suu~Sv + Su~Suv
Coord NURBS_Func::CalcDiffuNormVecOnNurbsS(NURBSS *nurb,double u,double v)
{
	Coord Suu = CalcDiffNNurbsS(nurb,2,0,u,v);
	Coord Suv = CalcDiffNNurbsS(nurb,1,1,u,v);
	Coord Su = CalcDiffuNurbsS(nurb,u,v);
	Coord Sv = CalcDiffvNurbsS(nurb,u,v);

	return (NormalizeVec(AddCoord(CalcOuterProduct(Suu,Sv),CalcOuterProduct(Su,Suv))));
}

// NURBSȖʏ(u,v)ɂ@xNgv1KƂ߂
// Nv = Suv~Sv + Su~Svv
Coord NURBS_Func::CalcDiffvNormVecOnNurbsS(NURBSS *nurb,double u,double v)
{
	Coord Suv = CalcDiffNNurbsS(nurb,1,1,u,v);
	Coord Svv = CalcDiffNNurbsS(nurb,0,2,u,v);
	Coord Su = CalcDiffuNurbsS(nurb,u,v);
	Coord Sv = CalcDiffvNurbsS(nurb,u,v);

	return (NormalizeVec(AddCoord(CalcOuterProduct(Suv,Sv),CalcOuterProduct(Su,Svv))));
}

// NURBSȖʏ(u,v)ɂ镽ϋȗ߂
double NURBS_Func::CalcMeanCurvature(NURBSS *nurb,double u,double v)
{
	Coord du = CalcDiffuNurbsS(nurb,u,v);			// u1K
	Coord dv = CalcDiffvNurbsS(nurb,u,v);			// v1K
	double E = CalcInnerProduct(du,du);				// 1{
	double F = CalcInnerProduct(du,dv);				// 1{
	double G = CalcInnerProduct(dv,dv);				// 1{
	Coord duu = CalcDiffNNurbsS(nurb,2,0,u,v);		// u2K
	Coord dvv = CalcDiffNNurbsS(nurb,0,2,u,v);		// v2K
	Coord duv = CalcDiffNNurbsS(nurb,1,1,u,v);		// u,ve1K
	Coord n = CalcNormVecOnNurbsS(nurb,u,v);		// @xNg
	double L = CalcInnerProduct(duu,n);				// 2{
	double M = CalcInnerProduct(duv,n);				// 2{
	double N = CalcInnerProduct(dvv,n);				// 2{
	double H = -(G*L+E*N-2*F*M)/(E*G-F*F)/2;		// ϋȗ

	return H;
}
double NURBS_Func::CalcMeanCurvature(SFQuant q)
{
	return -(q.G*q.L+q.E*q.N-2*q.F*q.M)/(q.E*q.G-q.F*q.F)/2;		// ϋȗ
}

// NURBSȖʏ(u,v)ɂ镽ϋȗ@xNgƂ߂
Coord NURBS_Func::CalcMeanCurvatureNormVec(NURBSS *nurb,double u,double v)
{
	Coord n = CalcNormVecOnNurbsS(nurb,u,v);				// @xNg
	Coord Hn = MulCoord(n,CalcMeanCurvature(nurb,u,v));		// ϋȗ@xNg

	return Hn;
}

// NURBSȖʏ(u,v)ɂKEXȗ߂
double NURBS_Func::CalcGaussCurvature(NURBSS *nurb,double u,double v)
{
	Coord du = CalcDiffuNurbsS(nurb,u,v);			// u1K
	Coord dv = CalcDiffvNurbsS(nurb,u,v);			// v1K
	double E = CalcInnerProduct(du,du);				// 1{
	double F = CalcInnerProduct(du,dv);				// 1{
	double G = CalcInnerProduct(dv,dv);				// 1{
	Coord duu = CalcDiffNNurbsS(nurb,2,0,u,v);		// u2K
	Coord dvv = CalcDiffNNurbsS(nurb,0,2,u,v);		// v2K
	Coord duv = CalcDiffNNurbsS(nurb,1,1,u,v);		// u,ve1K
	Coord n = CalcNormVecOnNurbsS(nurb,u,v);		// @xNg
	double L = CalcInnerProduct(duu,n);				// 2{
	double M = CalcInnerProduct(duv,n);				// 2{
	double N = CalcInnerProduct(dvv,n);				// 2{
	double K = (L*N-M*M)/(E*G-F*F);					// KEXȗ

	return K;
}
double NURBS_Func::CalcGaussCurvature(SFQuant q)
{
	return (q.L*q.N-q.M*q.M)/(q.E*q.G-q.F*q.F);					// KEXȗ
}


// NURBSȖʏ(u,v)ɂKEXȗ@xNgƂ߂
Coord NURBS_Func::CalcGaussCurvatureNormVec(NURBSS *nurb,double u,double v)
{
	SFQuant q(nurb,u,v);
	return MulCoord(q.n,CalcGaussCurvature(q));	// KEXȗ@xNg
}

// NURBSȐ̋ȗ߂
double NURBS_Func::CalcCurvatureNurbsC(NURBSC *C,double t)
{
	Coord p_ = CalcDiffNurbsC(C,t);
	Coord p__ = CalcDiff2NurbsC(C,t);

	return(CalcEuclid(CalcOuterProduct(p_,p__))/pow(CalcEuclid(p_),3));
}

// NURBSȖS(u,v)NURBSȖR(w,t)̊o(g)
//   *nurbS:NURBSȖS(u,v) *nurbR:NURBSȖR(w,t) divnum:p[^
// Ԓl  ̗L(L:KOD_TRUE :KOD_FALSE)
int NURBS_Func::DetectInterfereNurbsS(NURBSS *nurbR,NURBSS *nurbS,int divnum)
{
	// eȖʂw̕uvA̓_ɂ⏕ʂ𐶐Č̔Cӂ1_Ɏ
	for(int w=0;w<divnum;w++){
		for(int t=0;t<divnum;t++){
			for(int u=0;u<divnum;u++){
				for(int v=0;v<divnum;v++){
					// eȖʂɕ_𐶐
					double w0 = nurbR->U[0] + (nurbR->U[1] - nurbR->U[0])*(double)w/(double)divnum;
					double t0 = nurbR->V[0] + (nurbR->V[1] - nurbR->V[0])*(double)t/(double)divnum;
					double u0 = nurbS->U[0] + (nurbS->U[1] - nurbS->U[0])*(double)u/(double)divnum;
					double v0 = nurbS->V[0] + (nurbS->V[1] - nurbS->V[0])*(double)v/(double)divnum;
					for(int i=0;i<10;i++){
						// ep[^Zo
						Coord p0 = CalcNurbsSCoord(nurbR,w0,t0);					// R(w0,t0)ƂȂ_(_)̍W
						Coord q0 = CalcNurbsSCoord(nurbS,u0,v0);					// S(u0,v0)ƂȂ_(_)̍W
						Coord rw = CalcDiffuNurbsS(nurbR,w0,t0);					// _R(w0,t0)uΔ({xNg)
						Coord rt = CalcDiffvNurbsS(nurbR,w0,t0);					// _R(w0,t0)vΔ({xNg)
						double rwt = CalcEuclid(CalcOuterProduct(rw,rt));
						if(rwt==0.0) break;
						Coord np = DivCoord(CalcOuterProduct(rw,rt),rwt);			// _R(w0,t0)̒Pʖ@xNg
						Coord su = CalcDiffuNurbsS(nurbS,u0,v0);					// _S(u0,v0)uΔ({xNg)
						Coord sv = CalcDiffvNurbsS(nurbS,u0,v0);					// _S(u0,v0)vΔ({xNg)
						double suv = CalcEuclid(CalcOuterProduct(su,sv));
						if(suv==0.0) break;
						Coord nq = DivCoord(CalcOuterProduct(su,sv),CalcEuclid(CalcOuterProduct(su,sv)));	// _S(u0,v0)̒Pʖ@xNg
						double npq = CalcEuclid(CalcOuterProduct(np,nq));
						if(npq==0.0) break;
						Coord nn = DivCoord(CalcOuterProduct(np,nq),CalcEuclid(CalcOuterProduct(np,nq)));	// FpƕFqɒ镽Fn̒Pʖ@xNg
						double dp = CalcInnerProduct(p0,np);						// _畽Fp܂ł̋
						double dq = CalcInnerProduct(q0,nq);						// _畽Fq܂ł̋
						double dn = CalcInnerProduct(p0,nn);						// _畽Fn܂ł̋
						Coord cross_nqn = CalcOuterProduct(nq,nn);					// Pʖ@xNgnq,nñxNg
						Coord cross_nnp = CalcOuterProduct(nn,np);					// Pʖ@xNgnn,np̃xNg
						Coord cross_npq = CalcOuterProduct(np,nq);					// Pʖ@xNgnp,nq̃xNg
						Coord nume_p_sub =  AddCoord(MulCoord(cross_nqn,dp),MulCoord(cross_nnp,dq));	// 3Fp,Fq,Fň_p̕q̍ŏ2vZ
						Coord nume_p = AddCoord(nume_p_sub,MulCoord(cross_npq,dn));			// p̕qZo
						double denom_p = CalcScalarTriProduct(np,nq,nn);				// p̕Zo
						Coord p = DivCoord(nume_p,denom_p);						// pZo
						Coord deltap0 = SubCoord(p,p0);							// _pƓ_p0̍xNgZo
						Coord deltaq0 = SubCoord(p,q0);							// _pƓ_q0̍xNgZo
						Coord rw_sub = CalcOuterProduct(rw,np);						// {xNgrwƖ@xNgnpɒxNg
						Coord rt_sub = CalcOuterProduct(rt,np);						// {xNgrtƖ@xNgnpɒxNg
						Coord su_sub = CalcOuterProduct(su,nq);						// {xNgsuƖ@xNgnqɒxNg
						Coord sv_sub = CalcOuterProduct(sv,nq);						// {xNgsvƖ@xNgnqɒxNg
						double dw = CalcInnerProduct(rt_sub,deltap0)/CalcInnerProduct(rt_sub,rw);	// V_r(w0+dw,t0+dt)^邽߂dwZo
						double dt = CalcInnerProduct(rw_sub,deltap0)/CalcInnerProduct(rw_sub,rt);	// V_r(w0+dw,t0+dt)^邽߂dtZo
						double du = CalcInnerProduct(sv_sub,deltaq0)/CalcInnerProduct(sv_sub,su);	// V_r(w0+dw,t0+dt)^邽߂dwZo
						double dv = CalcInnerProduct(su_sub,deltaq0)/CalcInnerProduct(su_sub,sv);	// V_r(w0+dw,t0+dt)^邽߂dtZo
						w0 += dw;									// V_wp[^𓾂
						t0 += dt;									// V_tp[^𓾂
						u0 += du;									// V_up[^𓾂
						v0 += dv;									// V_vp[^𓾂
						
						// Ȗʂ͈̔͊OɏoĂ܂烋[v𔲂
						if(!CheckRange(nurbR->U[0],nurbR->U[1],w0,1) || !CheckRange(nurbR->V[0],nurbR->V[1],t0,1)){
							break;
						}
						if(!CheckRange(nurbS->U[0],nurbS->U[1],u0,1) || !CheckRange(nurbS->V[0],nurbS->V[1],v0,1)){
							break;
						}
						
						Coord deltapq = SubCoord(p0,q0);						// _p0Ɠ_q0̍xNgZo
						double deltapq_dis = CalcEuclid(deltapq);					// |p0-q0|̋Zo
											
						// \_݂邽ߊL
						if(deltapq_dis < CONVERG_GAP){
                            //GuiIF.SetMessage("Interference with the NURBS surface was detected");
							return KOD_TRUE;
						}
					}
				}
			}
		}
	}
	
    //GuiIF.SetMessage("Interference with the NURBS surface was not detected");
	return KOD_FALSE;
}

// NURBSȖS(u,v)NURBSȖR(w,t)̊o(gL)
//   *tNurbS:NURBSȖS(u,v)(gL) *tNurbR:NURBSȖR(w,t)(gL) divnum:p[^
// Ԓl  ̗L(L:KOD_TRUE :KOD_FALSE)
int NURBS_Func::DetectInterfereTrmS(TRIMD_NURBSS *tNurbR,TRIMD_NURBSS *tNurbS,int divnum)
{
	int count=0;

	// eȖʂw̕uvA̓_ɂ⏕ʂ𐶐Č̔Cӂ1_Ɏ
	for(int w=0;w<divnum;w++){
		for(int t=0;t<divnum;t++){
			for(int u=0;u<divnum;u++){
				for(int v=0;v<divnum;v++){
					// eȖʂɕ_𐶐
					double w0 = tNurbR->pts->U[0] + (tNurbR->pts->U[1] - tNurbR->pts->U[0])*(double)w/(double)divnum;
					double t0 = tNurbR->pts->V[0] + (tNurbR->pts->V[1] - tNurbR->pts->V[0])*(double)t/(double)divnum;
					double u0 = tNurbS->pts->U[0] + (tNurbS->pts->U[1] - tNurbS->pts->U[0])*(double)u/(double)divnum;
					double v0 = tNurbS->pts->V[0] + (tNurbS->pts->V[1] - tNurbS->pts->V[0])*(double)v/(double)divnum;
					for(int i=0;i<10;i++){
						// ep[^Zo
						Coord p0 = CalcNurbsSCoord(tNurbR->pts,w0,t0);					// R(w0,t0)ƂȂ_(_)̍W
						Coord q0 = CalcNurbsSCoord(tNurbS->pts,u0,v0);					// S(u0,v0)ƂȂ_(_)̍W
						Coord rw = CalcDiffuNurbsS(tNurbR->pts,w0,t0);					// _R(w0,t0)uΔ({xNg)
						Coord rt = CalcDiffvNurbsS(tNurbR->pts,w0,t0);					// _R(w0,t0)vΔ({xNg)
						double rwt = CalcEuclid(CalcOuterProduct(rw,rt));
						if(rwt==0.0) break;
						Coord np = DivCoord(CalcOuterProduct(rw,rt),rwt);				// _R(w0,t0)̒Pʖ@xNg
						Coord su = CalcDiffuNurbsS(tNurbS->pts,u0,v0);					// _S(u0,v0)uΔ({xNg)
						Coord sv = CalcDiffvNurbsS(tNurbS->pts,u0,v0);					// _S(u0,v0)vΔ({xNg)
						double suv = CalcEuclid(CalcOuterProduct(su,sv));
						if(suv==0.0) break;
						Coord nq = DivCoord(CalcOuterProduct(su,sv),suv);	// _S(u0,v0)̒Pʖ@xNg
						double npq = CalcEuclid(CalcOuterProduct(np,nq));
						if(npq==0.0) break;
						Coord nn = DivCoord(CalcOuterProduct(np,nq),CalcEuclid(CalcOuterProduct(np,nq)));	// FpƕFqɒ镽Fn̒Pʖ@xNg
						double dp = CalcInnerProduct(p0,np);						// _畽Fp܂ł̋
						double dq = CalcInnerProduct(q0,nq);						// _畽Fq܂ł̋
						double dn = CalcInnerProduct(p0,nn);						// _畽Fn܂ł̋
						Coord cross_nqn = CalcOuterProduct(nq,nn);					// Pʖ@xNgnq,nñxNg
						Coord cross_nnp = CalcOuterProduct(nn,np);					// Pʖ@xNgnn,np̃xNg
						Coord cross_npq = CalcOuterProduct(np,nq);					// Pʖ@xNgnp,nq̃xNg
						Coord nume_p_sub =  AddCoord(MulCoord(cross_nqn,dp),MulCoord(cross_nnp,dq));	// 3Fp,Fq,Fň_p̕q̍ŏ2vZ
						Coord nume_p = AddCoord(nume_p_sub,MulCoord(cross_npq,dn));			// p̕qZo
						double denom_p = CalcScalarTriProduct(np,nq,nn);				// p̕Zo
						Coord p = DivCoord(nume_p,denom_p);						// pZo
						Coord deltap0 = SubCoord(p,p0);							// _pƓ_p0̍xNgZo
						Coord deltaq0 = SubCoord(p,q0);							// _pƓ_q0̍xNgZo
						Coord rw_sub = CalcOuterProduct(rw,np);						// {xNgrwƖ@xNgnpɒxNg
						Coord rt_sub = CalcOuterProduct(rt,np);						// {xNgrtƖ@xNgnpɒxNg
						Coord su_sub = CalcOuterProduct(su,nq);						// {xNgsuƖ@xNgnqɒxNg
						Coord sv_sub = CalcOuterProduct(sv,nq);						// {xNgsvƖ@xNgnqɒxNg
						double dw = CalcInnerProduct(rt_sub,deltap0)/CalcInnerProduct(rt_sub,rw);	// V_r(w0+dw,t0+dt)^邽߂dwZo
						double dt = CalcInnerProduct(rw_sub,deltap0)/CalcInnerProduct(rw_sub,rt);	// V_r(w0+dw,t0+dt)^邽߂dtZo
						double du = CalcInnerProduct(sv_sub,deltaq0)/CalcInnerProduct(sv_sub,su);	// V_r(w0+dw,t0+dt)^邽߂dwZo
						double dv = CalcInnerProduct(su_sub,deltaq0)/CalcInnerProduct(su_sub,sv);	// V_r(w0+dw,t0+dt)^邽߂dtZo
						w0 += dw;									// V_wp[^𓾂
						t0 += dt;									// V_tp[^𓾂
						u0 += du;									// V_up[^𓾂
						v0 += dv;									// V_vp[^𓾂
						
						// Ȗʂ͈̔͊OɏoĂ܂烋[v𔲂
						if(!CheckRange(tNurbR->pts->U[0],tNurbR->pts->U[1],w0,1) || !CheckRange(tNurbR->pts->V[0],tNurbR->pts->V[1],t0,1)){
							break;
						}
						if(!CheckRange(tNurbS->pts->U[0],tNurbS->pts->U[1],u0,1) || !CheckRange(tNurbS->pts->V[0],tNurbS->pts->V[1],v0,1)){
							break;
						}
						
						Coord deltapq = SubCoord(p0,q0);						// _p0Ɠ_q0̍xNgZo
						double deltapq_dis = CalcEuclid(deltapq);					// |p0-q0|̋Zo
										
						// \_݂邽ߊL
						if(deltapq_dis < CONVERG_GAP){
							if(DetermPtOnTRMSurf(tNurbR,w0,t0) >= KOD_TRUE && DetermPtOnTRMSurf(tNurbS,u0,v0) >= KOD_TRUE){	// gȂ
                                //GuiIF.SetMessage("Interference with the trimmed NURBS surface was detected");
								return KOD_TRUE;
							}
						}
					}
				}
			}
		}
	}
	
    //GuiIF.SetMessage("Interference with the trimmed NURBS surface was not detected");
	return KOD_FALSE;
}

// 3ȉNURBSȖʂƕʂƂ̌_Q㐔@ɂċ߂(vp[^)
//   *nurb:NURBSȖ  pt:ʏ̈_  nvec:ʂ̖@xNg  v_divnum:vp[^
//       *ans:Zoꂽ_u,vp[^lꂼans.x,ans.yɊi[,  ans_size:ans̔z
// Ԓl  _̌(_̐ans_size𒴂FKOD_ERR)
int NURBS_Func::CalcIntersecPtsPlaneV3(NURBSS *nurb,Coord pt,Coord nvec,int v_divnum,Coord *ans,int ans_size)
{
	double v_const;			// 萔ƒuƂvp[^
	double *N;				// BXvC֐̌vZli[
	double *A;
	Coord  *B;
	double **coef;
	double Q[4];
	Coord  P[4];
	double a[4];
	double t[3];
	int ansnum;
	int allansnum=0;

	N = (double *)malloc(sizeof(double)*nurb->K[1]);
	A = (double *)malloc(sizeof(double)*nurb->K[0]);
	B = (Coord *)malloc(sizeof(Coord)*nurb->K[0]);
	coef = NewMatrix(nurb->M[0],nurb->M[0]);

	// vp[^ԓŕAevp[^NURBSȐC(u)ƕ(pt,nvec)Ƃ̌_߂
	for(int v=0;v<=v_divnum;v++){
		v_const = (nurb->V[1] - nurb->V[0])*(double)v/(double)v_divnum;		// Kvp[^ݒ
		for(int i=0;i<nurb->K[1];i++){
			N[i] = CalcBSbasis(v_const,nurb->T,nurb->N[0],i,nurb->M[1]);		// v_constBXvC֐߂
		}
		for(int i=0;i<nurb->K[0];i++){
			A[i] = 0;
			InitCoord(&B[i]);
			for(int j=0;j<nurb->K[1];j++){
				A[i] += N[j]*nurb->W[i][j];			// v_constNURBSȐC(u)̌̕W
				B[i] = AddCoord(B[i],MulCoord(nurb->cp[i][j],N[j]*nurb->W[i][j]));		// v_constNURBSȐC(u)̕q̌W
			}
		}
		for(int i=0;i<nurb->K[0]-nurb->M[0]+1;i++){						// iԖڂ̋Ȑɑ΂
			InitMatrix(coef,nurb->M[0],nurb->M[0]);
			InitVector(a,4);
			InitCoord(P,4);
			InitVector(Q,4);
			InitVector(t,3);
			if(nurb->M[0]-1 == 3){										// 3
				GetBSplCoef3(nurb->M[0],nurb->K[0],i,nurb->S,coef);		// 3BXvC֐̌W߂
			}
			else if(nurb->M[0]-1 == 2){									// 2
				GetBSplCoef2(nurb->M[0],nurb->K[0],i,nurb->S,coef);		// 2BXvC֐̌W߂
			}
			else if(nurb->M[0]-1 == 1){									// 1
				GetBSplCoef1(nurb->M[0],nurb->K[0],i,nurb->S,coef);		// 1BXvC֐̌W߂
			}
			GetNurbsSCoef(nurb->M[0],coef,A,B,i,P,Q);					// Œ肳ꂽvp[^NURBSȐC(u)̌W߂
			GetIntersecEquation(nurb->M[0],P,Q,pt,nvec,a);				// 𓱏o
			ansnum = CalcEquation(a,t,nurb->M[0]-1);					// 
			int hitnum = 0;						// ɓK̐JEg
			for(int j=0;j<ansnum;j++){			// 3̉ꂼɑ΂
				if(t[j] >= nurb->S[i+nurb->M[0]-1] && t[j] <= nurb->S[i+nurb->M[0]]){	// ڒ̃mbgxNg͈͓̔Ȃ
					ans[allansnum+hitnum] = SetCoord(t[j],v_const,0);		// Ƃēo^
					hitnum++;
				}
			}
			allansnum += hitnum;				// K̐𐔂JEgAbv
			if(allansnum >= ans_size){
                GuiIF.SetMessage("NURBS KOD_ERR:Intersection points exceeded the allocated array length");
				allansnum = KOD_ERR;
				goto EXIT;
			}
		}
	}

EXIT:
	free(N);
	free(A);
	free(B);
	FreeMatrix(coef,nurb->M[0]);

	return allansnum;
}

// 3ȉNURBSȖʂƕʂƂ̌_Q㐔@ɂċ߂(up[^)
//   *nurb:NURBSȖ  pt:ʏ̈_  nvec:ʂ̖@xNg  u_divnum:up[^
//       *ans:Zoꂽ_u,vp[^lꂼans.x,ans.yɊi[,  ans_size:ans̔z
// Ԓl  _̌(_̐ans_size𒴂FKOD_ERR)
int NURBS_Func::CalcIntersecPtsPlaneU3(NURBSS *nurb,Coord pt,Coord nvec,int u_divnum,Coord *ans,int ans_size)
{
	double u_const;			// 萔ƒuƂvp[^
	double *N;				// BXvC֐̌vZli[
	double *A;
	Coord  *B;
	double **coef;
	double Q[4];
	Coord  P[4];
	double a[4];
	double t[3];
	int ansnum;
	int allansnum=0;

	N = (double *)malloc(sizeof(double)*nurb->K[0]);
	A = (double *)malloc(sizeof(double)*nurb->K[1]);
	B = (Coord *)malloc(sizeof(Coord)*nurb->K[1]);
	coef = NewMatrix(nurb->M[1],nurb->M[1]);

	// up[^ԓŕAeup[^NURBSȐC(v)ƕ(pt,nvec)Ƃ̌_߂
	for(int u=0;u<=u_divnum;u++){
		u_const = (nurb->U[1] - nurb->U[0])*(double)u/(double)u_divnum;		// Kup[^ݒ
		for(int i=0;i<nurb->K[0];i++){
			N[i] = CalcBSbasis(u_const,nurb->S,nurb->N[0],i,nurb->M[0]);		// u_constBXvC֐߂
		}
		for(int j=0;j<nurb->K[1];j++){
			A[j] = 0;
			InitCoord(&B[j]);
			for(int i=0;i<nurb->K[0];i++){
				A[j] += N[i]*nurb->W[i][j];			// u_constNURBSȐC(v)̌̕W
				B[j] = AddCoord(B[j],MulCoord(nurb->cp[i][j],N[i]*nurb->W[i][j]));		// u_constNURBSȐC(v)̕q̌W
			}
		}
		for(int i=0;i<nurb->K[1]-nurb->M[1]+1;i++){						// iԖڂ̋Ȑɑ΂
			if(nurb->M[1]-1 == 3){										// 3
				GetBSplCoef3(nurb->M[1],nurb->K[1],i,nurb->T,coef);		// 3BXvC֐̌W߂
			}
			else if(nurb->M[1]-1 == 2){									// 2
				GetBSplCoef2(nurb->M[1],nurb->K[1],i,nurb->T,coef);		// 2BXvC֐̌W߂
			}
			else if(nurb->M[1]-1 == 1){									// 1
				GetBSplCoef1(nurb->M[1],nurb->K[1],i,nurb->T,coef);		// 1BXvC֐̌W߂
			}
			GetNurbsSCoef(nurb->M[1],coef,A,B,i,P,Q);					// Œ肳ꂽup[^NURBSȐC(v)̌W߂
			GetIntersecEquation(nurb->M[1],P,Q,pt,nvec,a);				// 𓱏o
			ansnum = CalcEquation(a,t,nurb->M[1]-1);					// 

			int hitnum = 0;						// ɓK̐JEg
			for(int j=0;j<ansnum;j++){			// 3̉ꂼɑ΂
				if(t[j] >= nurb->T[i+nurb->M[1]-1] && t[j] <= nurb->T[i+nurb->M[1]]){	// ڒ̃mbgxNg͈͓̔Ȃ
					ans[allansnum+hitnum] = SetCoord(u_const,t[j],0);		// Ƃēo^
					hitnum++;
				}
			}
			allansnum += hitnum;				// K̐𐔂JEgAbv
			if(allansnum >= ans_size){
                GuiIF.SetMessage("NURBS KOD_ERR:Intersection points exceeded the allocated array length");
				allansnum = KOD_ERR;
				goto EXIT;
			}
		}
	}

EXIT:
	free(N);
	free(A);
	free(B);
	FreeMatrix(coef,nurb->M[1]);

	return allansnum;
}

// ṼAC\pȐw肵ŐCeȐNURBSȖʂƂ̌_Zo
//   *nurb:NURBSȖ  pt:ʏ̈_  nvec:ʂ̖@xNg  v_divnum:vp[^
//       *ans:Zoꂽ_u,vp[^lꂼans.x,ans.yɊi[,  ans_size:ans̔z
// Ԓl  _̌(_̐ans_size𒴂FKOD_ERR)
int NURBS_Func::CalcIntersecPtsPlaneV(NURBSS *nurbss,Coord pt,Coord nvec,int v_divnum,Coord *ans,int ans_size)
{
	double v_const;			// 萔ƒuƂvp[^
	int ansnum;				// 1̃AC\pȐƋȖʂ̌_Q̐
	int allansnum=0;		// S_JEg
	int ansbufsize = 2*(nurbss->M[0]-1)*((nurbss->K[0]>nurbss->K[1]?nurbss->K[0]:nurbss->K[1])-nurbss->M[0]+1);	// 1̃AC\pȐƋȖʂ̌_Qi[z̔z
	double *ansbuf;			// 1̃AC\pȐƋȖʂ̌_Qi[z
	NURBSC nurbsc;			// 1̃AC\pȐ

	ansbuf = NewVector(ansbufsize);

	// vp[^ԓŕAevp[^NURBSȐC(u)ƕ(pt,nvec)Ƃ̌_߂
	for(int v=0;v<=v_divnum;v++){
		v_const = (nurbss->V[1] - nurbss->V[0])*(double)v/(double)v_divnum;			// Kvp[^ݒ
		ansnum = CalcIntersecIsparaCurveU(nurbss,v_const,pt,nvec,v_divnum,ansbuf,ansbufsize);		// AC\pȐƋȖʂ̌_QZo
		if(ansnum == KOD_ERR)	goto EXIT;
		for(int i=0;i<ansnum;i++){
			Coord a = CalcNurbsSCoord(nurbss,ansbuf[i],v_const);
			ans[allansnum+i] = SetCoord(ansbuf[i],v_const,0);					// o^
		}
		allansnum += ansnum;
	}

EXIT:
	FreeVector(ansbuf);
	return allansnum;
}

// ŨAC\pȐw肵ŐCeȐNURBSȖʂƂ̌_Zo
//   *nurb:NURBSȖ  pt:ʏ̈_  nvec:ʂ̖@xNg  u_divnum:up[^
//       *ans:Zoꂽ_u,vp[^lꂼans.x,ans.yɊi[,  ans_size:ans̔z
// Ԓl  _̌(_̐ans_size𒴂FKOD_ERR)
int NURBS_Func::CalcIntersecPtsPlaneU(NURBSS *nurbss,Coord pt,Coord nvec,int u_divnum,Coord *ans,int ans_size)
{
	double u_const;			// 萔ƒuƂvp[^
	int ansnum;				// 1̃AC\pȐƋȖʂ̌_Q̐
	int allansnum=0;		// S_JEg
	int ansbufsize = 2*(nurbss->M[0]-1)*((nurbss->K[0]>nurbss->K[1]?nurbss->K[0]:nurbss->K[1])-nurbss->M[0]+1);	// 1̃AC\pȐƋȖʂ̌_Qi[z̔z
	double *ansbuf;			// 1̃AC\pȐƋȖʂ̌_Qi[z
	NURBSC nurbsc;			// 1̃AC\pȐ

	ansbuf = NewVector(ansbufsize);

	// up[^ԓŕAeup[^̃AC\pȐC(v)ƕ(pt,nvec)Ƃ̌_߂
	for(int u=0;u<=u_divnum;u++){
		u_const = (nurbss->U[1] - nurbss->U[0])*(double)u/(double)u_divnum;			// Kup[^ݒ
		ansnum = CalcIntersecIsparaCurveV(nurbss,u_const,pt,nvec,u_divnum,ansbuf,ansbufsize);		// AC\pȐƋȖʂ̌_QZo
		if(ansnum == KOD_ERR)	goto EXIT;
		for(int i=0;i<ansnum;i++){
			ans[allansnum+i] = SetCoord(u_const,ansbuf[i],0);					// o^
		}
		allansnum += ansnum;
	}

EXIT:
	FreeVector(ansbuf);
	return allansnum;
}

// NURBSȖʂƕʂƂ̌_Q􉽊wIɋ߂(⏕ʂp@)
//   *nurb:NURBSȖ  pt:ʏ̈_  nf:ʂ̖@xNg@u_divnum:up[^@v_divnum:vp[^
//       *ans:Zoꂽ_u,vp[^lꂼans.x,ans.yɊi[,  ans_size:ans̔z
// Ԓl  _̌(_̐ans_size𒴂FERR)
int NURBS_Func::CalcIntersecPtsPlaneGeom(NURBSS *nurb,Coord pt,Coord nf,int u_divnum,int v_divnum,Coord *ans,int ans_size)
{
	Coord init_pt;
	int ansnum=0;

	for(int u=0;u<=u_divnum;u++){
		for(int v=0;v<=v_divnum;v++){
			double u0 = nurb->U[0] + (nurb->U[1] - nurb->U[0])*(double)u/(double)u_divnum;
			double v0 = nurb->V[0] + (nurb->V[1] - nurb->V[0])*(double)v/(double)v_divnum;
			for(int i=0;i<LOOPCOUNTMAX;i++){
				Coord p0 = CalcNurbsSCoord(nurb,u0,v0);						// S(u0,v0)ƂȂ_(_)̍W
				Coord su = CalcDiffuNurbsS(nurb,u0,v0);						// _S(u0,v0)uΔ({xNg)
				Coord sv = CalcDiffvNurbsS(nurb,u0,v0);						// _S(u0,v0)vΔ({xNg)
				if(ZoroCoord(su) == KOD_FALSE || ZoroCoord(sv) == KOD_FALSE) break;
				Coord nt = DivCoord(CalcOuterProduct(su,sv),CalcEuclid(CalcOuterProduct(su,sv)));	// _S(u0,v0)̒Pʖ@xNg
				Coord nn = DivCoord(CalcOuterProduct(nf,nt),CalcEuclid(CalcOuterProduct(nf,nt)));	// FƕFtɒ镽Fn̒Pʖ@xNg
				if(ZoroCoord(nt) == KOD_FALSE || ZoroCoord(nn) == KOD_FALSE) break;
				double df = CalcInnerProduct(pt,nf);						// _畽F܂ł̋
				double dt = CalcInnerProduct(p0,nt);						// _畽Ft܂ł̋
				double dn = CalcInnerProduct(p0,nn);						// _畽Fn܂ł̋
				Coord cross_ntn = CalcOuterProduct(nt,nn);					// Pʖ@xNgnt,nñxNg
				Coord cross_nnf = CalcOuterProduct(nn,nf);					// Pʖ@xNgnn,nf̃xNg
				Coord cross_nft = CalcOuterProduct(nf,nt);					// Pʖ@xNgnf,nt̃xNg
				Coord nume_p1_sub =  AddCoord(MulCoord(cross_ntn,df),MulCoord(cross_nnf,dt));	// 3F,Ft,Fň_p1̕q̍ŏ2vZ
				Coord nume_p1 = AddCoord(nume_p1_sub,MulCoord(cross_nft,dn));					// p1̕qZo
				double denom_p1 = CalcScalarTriProduct(nf,nt,nn);			// p1̕Zo
				Coord p1 = DivCoord(nume_p1,denom_p1);						// p1Zo
				Coord deltap = SubCoord(p1,p0);								// _p1Ɠ_p0̋Zo
				double deltap_dis = CalcEuclid(deltap);						// p̋Zo
				double tri_su = CalcScalarTriProduct(su,sv,nf);
				double tri_sv = CalcScalarTriProduct(su,sv,nf);
				if(CheckZero(tri_sv,HIGH_ACCURACY) || CheckZero(tri_su,HIGH_ACCURACY)) break;
				double du = CalcScalarTriProduct(deltap,sv,nf)/CalcScalarTriProduct(su,sv,nf);	// V_s(u0+du,v0+dv)^邽߂duZo
				double dv = -CalcScalarTriProduct(deltap,su,nf)/CalcScalarTriProduct(su,sv,nf);	// V_s(u0+du,v0+dv)^邽߂dvZo
				u0 += du;													// V_up[^𓾂
				v0 += dv;													// V_vp[^𓾂
				if(u0 < nurb->U[0] || u0 > nurb->U[1] || v0 < nurb->V[0] || v0 > nurb->V[1]){	// ǐՓ_p[^̈Oɏo
				//	fprintf(stderr,"NURBS ERROR:ȖR̃p[^̈Oɏo܂\n");
					break;
				}
				if(deltap_dis < APPROX_ZERO_H){//CONVERG_GAP){								// p
					// fprintf(stderr,"   %d:%lf,%lf\n",ansnum,u0,v0);		// debug
					ans[ansnum] = SetCoord(u0,v0,0);						// Ƃēo^
					ansnum++;												// JEg
					//if(ansnum == ans_size)								// ̐z
						//return ansnum;
					break;
				}
			}
		}
	}
	
	return ansnum;
}

// ItZbgNURBSȖʂƕʂƂ̌_Q_ǐՖ@ɂċ߂
// @NURBSS:NURBSȖ  os:ItZbg  pt:ʏ1_  nvec:ʂ̖@xNg  ds:(_Q)̑e(0.1`2a)  initdivnum:_T̍r(10`1a)
//       ans:  ans_size:̐
// Ԓl@KOD_FALSE:NURBSȖʂƕʂĂȂ@KOD_ERR:ٓ_܂͔Uɂ菈𒆒f
int NURBS_Func::CalcIntersecPtsOffsetPlaneSearch(NURBSS *nurb,double os,Coord pt,Coord nvec,double ds,int initdivnum,Coord *ans,int ans_size)
{
	pt.dmy = os;
	return CalcIntersecPtsPlaneSearch(nurb,pt,nvec,ds,initdivnum,ans,ans_size,CALC_OFFSET);
}

// ʂƃItZbgNURBSȖʂƂ̌_⏕ʂpĐ_߂
int NURBS_Func::CalcIntersecPtsOffsetPlaneGeom(NURBSS *S,double d,Coord pt,Coord nf,int divnum,Coord *ans,int ans_size)
{
	int ansnum = 0;

	for(int u=0;u<=divnum;u++){
		for(int v=0;v<=divnum;v++){
			double u0 = S->U[0] + (S->U[1] - S->U[0])*(double)u/(double)divnum;
			double v0 = S->V[0] + (S->V[1] - S->V[0])*(double)v/(double)divnum;
			for(int i=0;i<LOOPCOUNTMAX;i++){
				Coord Su = CalcDiffuNurbsS(S,u0,v0);
				Coord Sv = CalcDiffvNurbsS(S,u0,v0);
				SFQuant sfq(S,u0,v0);					// S(u0,v0)̋Ȗʊ{ʂ𓾂
				double H = sfq.E*sfq.G-sfq.F*sfq.F;
				double H2 = H*H;
				if(CheckZero(H,HIGH_ACCURACY) == KOD_TRUE){		// 0֎~
                    //GuiIF.SetMessage("NURBS KOD_ERROR:The process is stoped by detecting singular point.");
					//return KOD_ERR;		
					break;
				}
				Coord nu = AddCoord(MulCoord(Su,(sfq.M*sfq.F-sfq.L*sfq.G)/H2),MulCoord(Sv,(sfq.L*sfq.F-sfq.M*sfq.E)/H2));	// S̖@xNgu
				Coord nv = AddCoord(MulCoord(Su,(sfq.N*sfq.F-sfq.M*sfq.G)/H2),MulCoord(Sv,(sfq.M*sfq.F-sfq.N*sfq.E)/H2));	// S̖@xNgv
				Coord Su_ = AddCoord(Su,MulCoord(nu,d));	// S̃ItZbgȖS_u
				Coord Sv_ = AddCoord(Sv,MulCoord(nv,d));	// S̃ItZbgȖS_v
				Coord nt = CalcNormVecOnNurbsS(S,u0,v0);
				Coord nn = DivCoord(CalcOuterProduct(nf,nt),CalcEuclid(CalcOuterProduct(nf,nt)));	// FƕFtɒ镽Fn̒Pʖ@xNg
				Coord p0 = AddCoord(CalcNurbsSCoord(S,u0,v0),MulCoord(nt,d));						// S(u0,v0)̍Wl
				double d = nf&pt;
				double dt = nt&p0;
				double dn = nn&p0;
				Coord p1 = ((((nt&&nn)*d) + ((nn&&nf)*dt)) + ((nf&&nt)*dn))/CalcScalarTriProduct(nf,nt,nn);
				Coord dp = p1 - p0;
				double denom = CalcScalarTriProduct(Su_,Sv_,nf);
				double du = CalcScalarTriProduct(dp,Sv_,nf)/denom;
				double dv = CalcScalarTriProduct(dp,Su_,nf)/denom;
				u0 += du;
				v0 += dv;
				if(CalcEuclid(dp) < CONVERG_GAP){
					ans[ansnum].x = u0;
					ans[ansnum].y = v0;
					ansnum++;
					break;
				}
			}
		}
	}

	return ansnum;
}

// NURBSȖʂƕʂƂ̌_Q_ǐՖ@ɂċ߂
// @NURBSS:NURBSȖ  pt:ʏ1_  nvec:ʂ̖@xNg  ds:(_Q)̑e(0.1`2a)  initdivnum:_T̍r(10`1a)
//       ans:  ans_size:̐   method:_Zo̐l͖@̑I(Runge-Kutta or Bulirsch-Stoer)
// Ԓl@KOD_FALSE:NURBSȖʂƕʂĂȂ@KOD_ERR:ٓ_܂͔Uɂ菈𒆒f
int NURBS_Func::CalcIntersecPtsPlaneSearch(NURBSS *nurb,Coord pt,Coord nvec,double ds,int initdivnum,Coord *ans,int ans_size,int method)
{
	int loop_count=0;		// vZ̃[v
	int pcount=0;
	int anscount=0;
	Coord oldp;
	Coord newp;
	Coord init_pt[INTERSECPTNUMMAX];		// _(u,vp[^l)
	Coord init_pt_buf[INTERSECPTNUMMAX];	// _uobt@(u,vp[^l)
	Coord init_pt_Coord[INTERSECPTNUMMAX];	// _(x,y,zWl)
	bool  init_pt_flag[INTERSECPTNUMMAX];	// e_ʂI𔻕ʂtO
	bool  init_allpt_flag=KOD_FALSE;			// _SĒʂI𔻕ʂtO
	int   init_pt_num=0;						// _̐
	int   init_pt_flag_count=0;
	double u,v;								// ǐՒu,vp[^Ԓl
	double dist;							// [vEopɒǐՓ_ԋ臒lƂ
	int loopbreak_flag = KOD_FALSE;				// _vtO
	int  search_flag = KOD_TRUE;				// ǐՕtO(KOD_TRUE:,KOD_FALSE:t)
	int  inverse_flag = KOD_FALSE;				// ǐՕt]tO
	double color[3] = {0,1,1};
	double *hdid,*hnext;

	//FILE *fp = fopen("debug.csv","w");

	// _ʉߔʃtO
	for(int i=0;i<INTERSECPTNUMMAX;i++){
		init_pt_flag[i] = KOD_FALSE;
	}
	init_pt_flag[0] = KOD_TRUE;

	// ܂ǐՖ@̏_ƂČ_߂
	if(method == CALC_OFFSET)
		init_pt_num = CalcIntersecPtsOffsetPlaneGeom(nurb,pt.dmy,pt,nvec,initdivnum,init_pt,INTERSECPTNUMMAX);
	else{
		// _2ŃT[`
		init_pt_num = CalcIntersecPtsPlaneU(nurb,pt,nvec,initdivnum,init_pt,INTERSECPTNUMMAX);
		int num = CalcIntersecPtsPlaneV(nurb,pt,nvec,initdivnum,init_pt_buf,INTERSECPTNUMMAX);
		init_pt_num = CatCoord(init_pt,init_pt_buf,INTERSECPTNUMMAX,init_pt_num,num);
		if(!init_pt_num)
			init_pt_num = CalcIntersecPtsPlaneGeom(nurb,pt,nvec,initdivnum,initdivnum,init_pt,INTERSECPTNUMMAX);	// ȂCT[`@ςăgC
	}
	init_pt_num = CheckTheSamePoints(init_pt,init_pt_num);		// _͏
	if(!init_pt_num){		// Ȃꍇ́AĂȂƂ݂Ȃ
        GuiIF.SetMessage("NURBS KOD_ERROR:Init intersection point is noexistence");
		return KOD_FALSE;					
	}
	else if(init_pt_num == KOD_ERR) return KOD_ERR;			// init_pt_numinit_pt̔z񒷂𒴂

	for(int i=0;i<init_pt_num;i++){
		init_pt_Coord[i] = CalcNurbsSCoord(nurb,init_pt[i].x,init_pt[i].y);		// _uvp[^xyzWlɕϊ̂ێĂ
		//fprintf(fp,"%d,%lf,%lf,%lf,%lf,%lf\n",i,init_pt[i].x,init_pt[i].y,init_pt_Coord[i].x,init_pt_Coord[i].y,init_pt_Coord[i].z);	// debug
		//DrawPoint(init_pt_Coord[i],1,3,color);	// debug
	}

	// _SĒʉ߂܂ŌǐՖ@JԂ
	while(init_allpt_flag == KOD_FALSE){
		//fprintf(fp,"Init%d,%lf,%lf,%lf,%lf,%lf\n",pcount+1,init_pt[pcount].x,init_pt[pcount].y,init_pt_Coord[pcount].x,init_pt_Coord[pcount].y,init_pt_Coord[pcount].z);		// debug
		// ǐՂ̂߂̎n_(u,v)Zbg
		u = oldp.x = init_pt[pcount].x;
		v = oldp.y = init_pt[pcount].y;
		ans[anscount] = SetCoord(init_pt[pcount]);
		anscount++;
		init_pt_flag[pcount] = KOD_TRUE;
		init_pt_flag_count++;
		//if(init_pt_flag_count == init_pt_num && init_pt_num > 1)	break;

		if(inverse_flag == KOD_TRUE){	// tւ̌ǐՂIĂ
			inverse_flag = KOD_FALSE;	// ǐՕɖ߂
		}

		// ǐՊJn
		loop_count = 0;
		while(loop_count < ans_size){
			// Ɍǐ
			if(inverse_flag == KOD_FALSE){
				if(method == RUNGE_KUTTA)	search_flag = SearchIntersectPt_RKM(nurb,pt,nvec,ds,&u,&v,FORWARD);	// ̌_Zo
				else if(method == BULIRSH_STOER)	search_flag = SearchIntersectPt_BS(nurb,pt,nvec,ds,&u,&v,FORWARD);
				else search_flag = SearchIntersectPt_OS(nurb,pt,nvec,ds,&u,&v,FORWARD);
				if(search_flag == KOD_ERR){							// ǐՂɎsꍇ
					inverse_flag = KOD_TRUE;						// tǐՃtOON
					//fprintf(fp,"a,%d,%d,%lf,%lf\n",search_flag,inverse_flag,u,v);	// for debug	
					u = init_pt[pcount].x;							// _ǐՂ̏_ZbgȂ
					v = init_pt[pcount].y;
				}
				//fprintf(fp,"e,%d,%d,%lf,%lf\n",search_flag,inverse_flag,u,v);	// for debug
			}
			// tǐՃtOONȂ
			if(inverse_flag == KOD_TRUE){
				if(method == RUNGE_KUTTA)	search_flag = SearchIntersectPt_RKM(nurb,pt,nvec,ds,&u,&v,INVERSE);	// ť_Zo
				else if(method == BULIRSH_STOER)	search_flag = SearchIntersectPt_BS(nurb,pt,nvec,ds,&u,&v,INVERSE);
				else search_flag = SearchIntersectPt_OS(nurb,pt,nvec,ds,&u,&v,INVERSE);
				if(search_flag == KOD_ERR){					// ٓ_oɂ菈płȂꍇ
					//fprintf(fp,"b,%d,%d,%lf,%lf\n",search_flag,inverse_flag,u,v);	// for debug
					GuiIF.SetMessage("NURBS_FUNC CAUTION: Singler point was ditected.");
					break;
				}
				//fprintf(fp,"f,%d,%d,%lf,%lf\n",search_flag,inverse_flag,u,v);	// for debug
			}

			// p[^͈͊Ȍꍇ
			if(search_flag == KOD_FALSE){
				newp = CalcIntersecPtsPlaneSearch_Sub(nurb,u,v,pt,nvec);		// ʂяo(u,v)Qlɖʂ̃GbW(new_u,new_v)𓾂
				//fprintf(fp,"c,%d,%d,%.12lf,%.12lf\n",search_flag,inverse_flag,newp.x,newp.y);	// for debug
				ans[anscount] = SetCoord(newp);		// ꂽu,v(_Q)Ƃēo^
				anscount++;							// _Q̐CNg
				// _ǐՖ@ɂđSĒʉ߂ׂ
				for(int i=0;i<init_pt_num;i++){
					if(CheckClossedPoints(nurb,oldp,newp,init_pt[i]) == KOD_TRUE){ // VɎZoꂽ_1Ǒ_ΊpƂ闧̂̒ɏ_܂܂Ă
						if(init_pt_flag[i] == KOD_FALSE){		// ܂ʉ߂ĂȂ_Ō_u,v͈͓
							init_pt_flag[i] = KOD_TRUE;			// ʉ߂ƂƂēo^
							init_pt_flag_count++;				// ʉߍςݏ_JEgAbv
							//fprintf(fp,"%d OK!\n",i);			// debug
						}
					}
				}
				if(inverse_flag == KOD_FALSE){		// Ȃ
					inverse_flag = KOD_TRUE;		// ̃T[`͋tɂ
					u = init_pt[pcount].x;			// _ǐՂ̏_ZbgȂ
					v = init_pt[pcount].y;
					oldp = SetCoord(init_pt[pcount]);
					continue;						// t[v
				}
				break;								// tȂ烋[vI
			}

			// OȂŉꂽ
			else{
				Coord cd = CalcNurbsSCoord(nurb,u,v);
				//fprintf(fp,"d,%d,%d,%.12lf,%.12lf,%lf,%lf,%lf,%d\n",search_flag,inverse_flag,u,v,cd.x,cd.y,cd.z,anscount);			// for debug
				newp.x = u;					
				newp.y = v;
			}

			// _ǐՖ@ɂđSĒʉ߂ׂ
			for(int i=0;i<init_pt_num;i++){
				// VɎZoꂽ_1Ǒ_ΊpƂ闧̂̒ɏ_܂܂Ă
				if(int asdf = CheckClossedPoints(nurb,oldp,newp,init_pt[i]) == KOD_TRUE){
					if(loop_count && i==pcount && inverse_flag == KOD_FALSE){	// [vɑ΂ĈĖ߂Ăꍇ̓[v𔲂
						loopbreak_flag = KOD_TRUE;	
						//fprintf(fp,"%d loop break OK\n",i);		// debug
						break;					
					}
					if(init_pt_flag[i] == KOD_FALSE && search_flag == KOD_TRUE){		// ܂ʉ߂ĂȂ_Ō_u,v͈͓
						init_pt_flag[i] = KOD_TRUE;					// ʉ߂ƂƂēo^
						init_pt_flag_count++;						// ʉߍςݏ_JEgAbv
						//fprintf(fp,"%d OK\n",i);				// debug
					}
				}
			}

			// [vɑ΂ĈĂꍇ̓[v𔲂
			if(loopbreak_flag == KOD_TRUE){
				loopbreak_flag = KOD_FALSE;
				break;
			}

			ans[anscount] = SetCoord(newp);	// ꂽu,v(_Q)Ƃēo^
			anscount++;				// _Q̐CNg

			// _̐wTCY𒴂ꍇ͂܂łŋ^[
			if(anscount >= ans_size){
                GuiIF.SetMessage("NURBS KOD_ERROR:Intersection points exceeded the allocated array length");
                GuiIF.SetMessage("There is a possibility that you set large ds.");
				return anscount;
			}

			oldp = SetCoord(newp);	// ̃[vŎZoꂽ_͎̃[vł1Ǒ_ƂȂ

			loop_count++;		// [v񐔂CNg
		}// ǐՂ܂

		// c_΁Aʂ̌̂ŁA̓_n_ƂčēxǐՂs
		init_allpt_flag = KOD_TRUE;
		for(int i=0;i<init_pt_num;i++){
			//fprintf(fp,"%d,",i);			// debug
			if(init_pt_flag[i] == KOD_FALSE){
				init_allpt_flag = KOD_FALSE;
				pcount = i;
				break;
			}
		}
		//fprintf(fp,"%d:loop count:%d\n",init_allpt_flag,loop_count);	// debug
	}
	anscount = RemoveTheSamePoints(nurb,ans,anscount);
	//anscount = CheckTheSamePoints(ans,anscount);

	//fclose(fp);

	return anscount;
}

// w肵_2_ΊpƂ闧̂̒ɑ݂邩𒲂ׂ
int NURBS_Func::CheckClossedPoints(NURBSS *nurb,Coord A,Coord B,Coord P)
{
	int ap = LOW_LOW_ACCURACY;

	if((CheckMag(A.x,P.x,ap) != KOD_LARGE) && (CheckMag(P.x,B.x,ap) != KOD_LARGE) && 
		(CheckMag(A.y,P.y,ap) != KOD_LARGE) && (CheckMag(P.y,B.y,ap) != KOD_LARGE))
		return KOD_TRUE;

	else if((CheckMag(A.x,P.x,ap) != KOD_LARGE) && (CheckMag(P.x,B.x,ap) != KOD_LARGE) && 
		(CheckMag(B.y,P.y,ap) != KOD_LARGE) && (CheckMag(P.y,A.y,ap) != KOD_LARGE))
		return KOD_TRUE;

	else if((CheckMag(B.x,P.x,ap) != KOD_LARGE) && (CheckMag(P.x,A.x,ap) != KOD_LARGE) && 
		(CheckMag(A.y,P.y,ap) != KOD_LARGE) && (CheckMag(P.y,B.y,ap) != KOD_LARGE))
		return KOD_TRUE;

	else if((CheckMag(B.x,P.x,ap) != KOD_LARGE) && (CheckMag(P.x,A.x,ap) != KOD_LARGE) && 
		(CheckMag(B.y,P.y,ap) != KOD_LARGE) && (CheckMag(P.y,A.y,ap) != KOD_LARGE))
		return KOD_TRUE;


	//Coord a = CalcNurbsSCoord(nurb,A.x,A.y);
	//Coord b = CalcNurbsSCoord(nurb,B.x,B.y);
	//Coord p = CalcNurbsSCoord(nurb,P.x,P.y);
	//int ap = LOW_ACCURACY;

	//if((CheckMag(a.x,p.x,ap) != KOD_LARGE) && (CheckMag(p.x,b.x,ap) != KOD_LARGE) && (CheckMag(a.y,p.y,ap) != KOD_LARGE)
	//	&& (CheckMag(p.y,b.y,ap) != KOD_LARGE) && (CheckMag(a.z,p.z,ap) != KOD_LARGE) && (CheckMag(p.z,b.z,ap) != KOD_LARGE))
	//	return KOD_TRUE;

	//else if((CheckMag(b.x,p.x,ap) != KOD_LARGE) && (CheckMag(p.x,a.x,ap) != KOD_LARGE) && (CheckMag(b.y,p.y,ap) != KOD_LARGE)
	//	&& (CheckMag(p.y,a.y,ap) != KOD_LARGE) && (CheckMag(a.z,p.z,ap) != KOD_LARGE) && (CheckMag(p.z,b.z,ap) != KOD_LARGE))
	//	return KOD_TRUE;

	//else if((CheckMag(a.x,p.x,ap) != KOD_LARGE) && (CheckMag(p.x,b.x,ap) != KOD_LARGE) && (CheckMag(b.y,p.y,ap) != KOD_LARGE)
	//	&& (CheckMag(p.y,a.y,ap) != KOD_LARGE) && (CheckMag(a.z,p.z,ap) != KOD_LARGE) && (CheckMag(p.z,b.z,ap) != KOD_LARGE))
	//		return KOD_TRUE;

	//else if((CheckMag(b.x,p.x,ap) != KOD_LARGE) && (CheckMag(p.x,a.x,ap) != KOD_LARGE) && (CheckMag(a.y,p.y,ap) != KOD_LARGE)
	//	&& (CheckMag(p.y,b.y,ap) != KOD_LARGE) && (CheckMag(a.z,p.z,ap) != KOD_LARGE) && (CheckMag(p.z,b.z,ap) != KOD_LARGE))
	//		return KOD_TRUE;

	//else if((CheckMag(a.x,p.x,ap) != KOD_LARGE) && (CheckMag(p.x,b.x,ap) != KOD_LARGE) && (CheckMag(a.y,p.y,ap) != KOD_LARGE)
	//	&& (CheckMag(p.y,b.y,ap) != KOD_LARGE) && (CheckMag(b.z,p.z,ap) != KOD_LARGE) && (CheckMag(p.z,a.z,ap) != KOD_LARGE))
	//		return KOD_TRUE;

	//else if((CheckMag(b.x,p.x,ap) != KOD_LARGE) && (CheckMag(p.x,a.x,ap) != KOD_LARGE) && (CheckMag(b.y,p.y,ap) != KOD_LARGE)
	//	&& (CheckMag(p.y,a.y,ap) != KOD_LARGE) && (CheckMag(b.z,p.z,ap) != KOD_LARGE) && (CheckMag(p.z,a.z,ap) != KOD_LARGE))
	//		return KOD_TRUE;

	//else if((CheckMag(a.x,p.x,ap) != KOD_LARGE) && (CheckMag(p.x,b.x,ap) != KOD_LARGE) && (CheckMag(b.y,p.y,ap) != KOD_LARGE)
	//	&& (CheckMag(p.y,a.y,ap) != KOD_LARGE) && (CheckMag(b.z,p.z,ap) != KOD_LARGE) && (CheckMag(p.z,a.z,ap) != KOD_LARGE))
	//		return KOD_TRUE;

	//else if((CheckMag(b.x,p.x,ap) != KOD_LARGE) && (CheckMag(p.x,a.x,ap) != KOD_LARGE) && (CheckMag(a.y,p.y,ap) != KOD_LARGE)
	//	&& (CheckMag(p.y,b.y,ap) != KOD_LARGE) && (CheckMag(b.z,p.z,ap) != KOD_LARGE) && (CheckMag(p.z,a.z,ap) != KOD_LARGE))
	//		return KOD_TRUE;


	return KOD_FALSE;
}

// ʂяo(u,v)Qlɖʂ̃GbW(new_u,new_v)𓾂
Coord NURBS_Func::CalcIntersecPtsPlaneSearch_Sub(NURBSS *nurb,double u, double v,Coord pt,Coord nvec)
{
	Coord old = SetCoord(u,v,0);
	Coord min;
	double a[INTERSECPTNUMMAX];
	Coord cod_a[INTERSECPTNUMMAX];
	int n;
	bool uflag = false;
	bool vflag = false;

	// ǂяoׂ
	if(u < nurb->U[0]){
		uflag = true;
		u = nurb->U[0];			// GbWuƂ
	}
	else if(u > nurb->U[1]){
		uflag = true;
		u = nurb->U[1];
	}

	if(v < nurb->V[0]){
		vflag = true;
		v = nurb->V[0];
	}
	else if(v > nurb->V[1]){
		vflag = true;
		v = nurb->V[1];
		//fprintf(stderr,"a\n");
	}

	if(uflag == true && vflag == false){
		n = CalcIntersecIsparaCurveV(nurb,u,pt,nvec,5,a,INTERSECPTNUMMAX);	// uŒ肵AC\pȐɑ΂ĕʂƂ̌_𓾂
		for(int i=0;i<n;i++)
			cod_a[i] = SetCoord(u,a[i],0);
	}
	else if(uflag == false && vflag == true){
		n = CalcIntersecIsparaCurveU(nurb,v,pt,nvec,5,a,INTERSECPTNUMMAX);	// vŒ肵AC\pȐɑ΂ĕʂƂ̌_𓾂
		for(int i=0;i<n;i++)
			cod_a[i] = SetCoord(a[i],v,0);
	}
	else if(uflag == true && vflag == true){
		n = CalcIntersecIsparaCurveV(nurb,u,pt,nvec,5,a,INTERSECPTNUMMAX);		// uŒ肵AC\pȐɑ΂ĕʂƂ̌_𓾂
		if(n > 0){
			for(int i=0;i<n;i++)
				cod_a[i] = SetCoord(u,a[i],0);
		}
		if(n <= 0){
			n = CalcIntersecIsparaCurveU(nurb,v,pt,nvec,5,a,INTERSECPTNUMMAX);	// vŒ肵AC\pȐɑ΂ĕʂƂ̌_𓾂
			for(int i=0;i<n;i++)
				cod_a[i] = SetCoord(a[i],v,0);
		}
	}

	min = GetMinDistance(old,cod_a,n);

	return min;
}

// Bulirsch-Stoer@ɂ_(NURBSȖʂƕ)
// Ԓl@@̃CfbNX
int NURBS_Func::SearchIntersectPt_BS(NURBSS *S,Coord pt,Coord nvec,double H,double *u0,double *v0,int direction)
{
	// w~X
	if(direction != FORWARD && direction != INVERSE){
		GuiIF.SetMessage("NURBS ERROR: selected wrong direction");
		return KOD_ERR;
	}

	int    n[BS_DIV] = {2,4,6,8,12,16,24,32,48,64,96};	// B-S@̕Qw
	Coord  z[97];										// C_@̒Ԓli[(z.x = u, z.y = v)
	Coord  f;											// f.x = fu(u,v), f.y = fv(u,v)
	Coord  D[BS_DIV][BS_DIV],C[BS_DIV][BS_DIV];			// B-S@̒ԃp[^
	double h[BS_DIV];									// B-S@̍ݕ
	Coord wek,wek_;										// h=0̊O}l

	for(int lpnum=0;lpnum<4;lpnum++){

		// eɂ鍏ݕ߂Ă
		for(int i=0;i<BS_DIV;i++)
			h[i] = H/n[i];

		// ݕ珇ɕύXȂAB-S@ɂO}lvZĂ
		for(int i=0;i<BS_DIV;i++){
			bool  divzero_flag = false;							// [ĎtO

			// ܂Au(s+H), v(s+H)̒lC_@ɂvZ
			z[0] = SetCoord(*u0,*v0,1);										// z0z1̎Zo͕ʏ
			if(GetSIPParam1(S,*u0,*v0,pt,nvec,direction,&f) == KOD_ERR){	// z0ł̔̉EӂvZ
				break;
			}
			z[1] = AddCoord2D(z[0],MulCoord2D(f,h[i]));							// z0z1̎Zo͕ʏ
			for(int j=1;j<n[i];j++){
				if(GetSIPParam1(S,z[j].x,z[j].y,pt,nvec,direction,&f) == KOD_ERR){	// zjł̔̉EӂvZ
					wek = SetCoord(z[j]);
					divzero_flag = true;
					break;
				}
				z[j+1] = AddCoord2D(z[j-1],MulCoord2D(f,2*h[i]));				// z2`zn܂łZo
			}
			if(divzero_flag == true)	break;						// [ɂȂꍇbreakC̃Xebv
			if(GetSIPParam1(S,z[n[i]].x,z[n[i]].y,pt,nvec,direction,&f) == KOD_ERR){	// znł̔̉EӂvZ
				wek = SetCoord(z[n[i]]);
				break;
			}
			C[i][0] = DivCoord(AddCoord2D(AddCoord2D(z[n[i]],z[n[i]-1]),MulCoord2D(f,h[i])),2);		// u(s+H)
			D[i][0] = SetCoord(C[i][0]);
			if(i==0){
				wek_ = SetCoord(D[i][0]);
				continue;
			}

			// B-S@̍\߂Ă
			wek = SetCoord(D[i][0]);
			for(int k=1;k<=i;k++){
				double xa = h[i-k]*h[i-k];
				double xb = h[i]*h[i];
				double x = xa/xb;
				Coord denom = SubCoord2D(MulCoord2D(D[i-k][k-1],x),C[i-k+1][k-1]);
				C[i-k][k] = DivCoord2D(MulCoord2D(MulCoord2D(D[i-k][k-1],SubCoord2D(C[i-k+1][k-1],D[i-k][k-1])),x),denom);
				D[i-k][k] = DivCoord2D(MulCoord2D(C[i-k][k-1],SubCoord2D(C[i-k+1][k-1],D[i-k][k-1])),denom);
				//fprintf(stderr,"    %lf,%lf\n",D[i-k][k-1].y,C[i-k+1][k-1].y);
				wek = AddCoord2D(wek,D[i-k][k]);
			}
			if(fabs(wek.x-wek_.x) < APPROX_ZERO_L && fabs(wek.y-wek_.y) < APPROX_ZERO_L){
				*u0 = wek.x;
				*v0 = wek.y;
				return KOD_TRUE;
			}

			wek_ = SetCoord(wek);
		}
	
		// ܂ŗꍇCݕH1/4ƂăgC
		H *= 0.25;
		
		if(lpnum==3){
			*u0 = wek.x;
			*v0 = wek.y;
		}
	}

	// ܂ŗꍇCŌɎZoꂽ(*u0,*v0)͈͊OȂKOD_FALSE^[
	if(*u0 < S->U[0] || *u0 > S->U[1] || *v0 < S->V[0] || *v0 > S->V[1]){
		return KOD_FALSE;
	}
	// ȊO͓ٓ_ƂKOD_ERR^[
	return KOD_ERR;
}

// Ȗʂƕʂ̌_\̉Eӂ̒l𓾂
int NURBS_Func::GetSIPParam1(NURBSS *S,double u,double v,Coord pt,Coord nvec,int direction,Coord *f)
{
	NURBS_Func NFunc;

	Coord Su = CalcDiffuNurbsS(S,u,v);
	Coord Sv = CalcDiffvNurbsS(S,u,v);
	double fu = CalcInnerProduct(nvec,Su);	// nfESu
	double fv = CalcInnerProduct(nvec,Sv);	// nfESv
	if(CheckZero(fu,HIGH_ACCURACY) == KOD_TRUE && CheckZero(fv,HIGH_ACCURACY) == KOD_TRUE){			// ٓ_
		//GuiIF.SetMessage("NURBS KOD_ERROR:The process is stoped by detected singular point.");
		return KOD_ERR;				
	}
	double E = CalcInnerProduct(Su,Su);		// 1Ki
	double F = CalcInnerProduct(Su,Sv);		// 1Ki
	double G = CalcInnerProduct(Sv,Sv);		// 1Ki
	double f_ = 1/sqrt(E*fv*fv - 2*F*fu*fv + G*fu*fu);
	*f = SetCoord(f_*fv*(double)direction, -f_*fu*(double)direction, 0);

	return KOD_TRUE;
}

// 4̃QNb^@ɂ_𓱏o(NURBSȖʂƕ)
// du(s)/ds = g(u,v),   dv(s)/ds = h(u,v)
// u(s+delta) = u(s) + (p1+2p2+2p3+p4)/6
// v(s+delta) = v(s) + (q1+2q2+2q3+q4)/6
// p1 = delta*g(u,v),   q1 = delta*h(u,v)
// p2 = delta*g(u+p1/2,v+q1/2),   q2 = delta*h(u+p1/2,v+q1/2)
// p3 = delta*g(u+p2/2,v+q2/2),   q3 = delta*h(u+p2/2,v+q2/2)
// p4 = delta*g(u+p3,v+q3),   q4 = delta*h(u+p3,v+q3)
int NURBS_Func::SearchIntersectPt_RKM(NURBSS *S,Coord pt,Coord n,double delta,double *u,double *v,int direction)
{
	double u0 = *u;
	double v0 = *v;
	double p[4]={0,0,0,0};
	double q[4]={0,0,0,0};

	for(int i=0;i<4;i++){
		if(i==1 || i==2){
			*u = u0 + p[i-1]/2;
			*v = v0 + q[i-1]/2;
		}
		else if(i==3){
			*u = u0 + p[i-1];
			*v = v0 + q[i-1];
		}
		if(*u < S->U[0] || *u > S->U[1] || *v < S->V[0] || *v > S->V[1])	// p[^͈͊O
			return KOD_FALSE;

		Coord Su = CalcDiffuNurbsS(S,*u,*v);
		Coord Sv = CalcDiffvNurbsS(S,*u,*v);
		double fu = CalcInnerProduct(n,Su);
		double fv = CalcInnerProduct(n,Sv);
		double fuu = fu*fu;
		double fuv = fu*fv;
		double fvv = fv*fv;
		if(CheckZero(fu,HIGH_ACCURACY) == KOD_TRUE && CheckZero(fv,HIGH_ACCURACY) == KOD_TRUE){			// ٓ_
            //GuiIF.SetMessage("NURBS KOD_ERROR:The process is stoped by detected singular point.");
			return KOD_ERR;				
		}
		double E = CalcInnerProduct(Su,Su);		// 1Ki
		double F = CalcInnerProduct(Su,Sv);		// 1Ki
		double G = CalcInnerProduct(Sv,Sv);		// 1Ki
		double f_ = 1/sqrt(E*fvv - 2*F*fuv + G*fuu);
		p[i] = -delta*fv*f_*(double)direction;
		q[i] = delta*fu*f_*(double)direction;
	}
	*u = u0+(p[0]+2*p[1]+2*p[2]+p[3])/6;
	*v = v0+(q[0]+2*q[1]+2*q[2]+q[3])/6;

	if(*u < S->U[0] || *u > S->U[1] || *v < S->V[0] || *v > S->V[1])	// p[^͈͊O
		return KOD_FALSE;

	return KOD_TRUE;
}

// 4̃QNb^@ɂ_𓱏o(ItZbgNURBSȖʂƕ)
// du(s)/ds = g(u,v),   dv(s)/ds = h(u,v)
// u(s+delta) = u(s) + (p1+2p2+2p3+p4)/6
// v(s+delta) = v(s) + (q1+2q2+2q3+q4)/6
// p1 = delta*g(u,v),   q1 = delta*h(u,v)
// p2 = delta*g(u+p1/2,v+q1/2),   q2 = delta*h(u+p1/2,v+q1/2)
// p3 = delta*g(u+p2/2,v+q2/2),   q3 = delta*h(u+p2/2,v+q2/2)
// p4 = delta*g(u+p3,v+q3),   q4 = delta*h(u+p3,v+q3)
int NURBS_Func::SearchIntersectPt_OS(NURBSS *S,Coord pt,Coord n,double delta,double *u,double *v,int direction)
{
	double u0 = *u;
	double v0 = *v;
	double p[4]={0,0,0,0};
	double q[4]={0,0,0,0};
	double d = pt.dmy;

	for(int i=0;i<4;i++){
		if(i==1 || i==2){
			*u = u0 + p[i-1]/2;
			*v = v0 + q[i-1]/2;
		}
		else if(i==3){
			*u = u0 + p[i-1];
			*v = v0 + q[i-1];
		}

		Coord Su = CalcDiffuNurbsS(S,*u,*v);
		Coord Sv = CalcDiffvNurbsS(S,*u,*v);

		SFQuant sfq(S,*u,*v);
		double H = sfq.E*sfq.G-sfq.F*sfq.F;
		if(CheckZero(H,HIGH_ACCURACY) == KOD_TRUE){			// ٓ_
			//GuiIF.SetMessage("NURBS KOD_ERROR:The process is stoped by detected singular point.");
			return KOD_ERR;				
		}
		Coord nu = MulCoord(Su,(sfq.N*sfq.F-sfq.M*sfq.G)/(H*H));
		Coord nv = MulCoord(Sv,(sfq.L*sfq.F-sfq.M*sfq.E)/(H*H));

		double fut = CalcInnerProduct(n,AddCoord(Su,MulCoord(nu,d)));
		double fvt = CalcInnerProduct(n,AddCoord(Sv,MulCoord(nv,d)));
		
		double fuut = fut*fut;
		double fuvt = fut*fvt;
		double fvvt = fvt*fvt;
		if(CheckZero(fut,HIGH_ACCURACY) == KOD_TRUE && CheckZero(fvt,HIGH_ACCURACY) == KOD_TRUE){			// ٓ_
			//GuiIF.SetMessage("NURBS KOD_ERROR:The process is stoped by detected singular point.");
			return KOD_ERR;				
		}
		double Kg = CalcGaussCurvature(sfq);
		double Km = CalcMeanCurvature(sfq);
		double nunu = -Kg*sfq.E+2*Km*sfq.L;
		double nunv = -Kg*sfq.G+2*Km*sfq.N;
		double nvnv = -Kg*sfq.F+2*Km*sfq.M;
		double Et = sfq.E-2*sfq.L*d+nunu*d*d;		// 1Ki
		double Ft = sfq.F-2*sfq.M*d+nunv*d*d;		// 1Ki
		double Gt = sfq.G-2*sfq.N*d+nvnv*d*d;		// 1Ki
		double denom = Et*fvvt - 2*Ft*fuvt + Gt*fuut;
		if(denom <= 0)
			return KOD_ERR;
		double gt_ = 1/sqrt(denom);
		p[i] = -delta*fvt*gt_*(double)direction;
		q[i] = delta*fut*gt_*(double)direction;
	}
	*u = u0+(p[0]+2*p[1]+2*p[2]+p[3])/6;
	*v = v0+(q[0]+2*q[1]+2*q[2]+q[3])/6;
	
	if(*u < S->U[0] || *u > S->U[1] || *v < S->V[0] || *v > S->V[1])	// p[^͈͊O
		return KOD_FALSE;

	return KOD_TRUE;
}

// j[g@ɂ_^lɎ(NURBSȖʂƕ)
int NURBS_Func::SearchIntersectPt(NURBSS *nurb,Coord pt,Coord nvec,double ds,double *u,double *v,int direction)
{
	double d = CalcInnerProduct(pt,nvec);	// _畽ʂ܂ł̋

	// ܂lƂĂdu,dv߂
	Coord pu = CalcDiffuNurbsS(nurb,*u,*v);
	Coord pv = CalcDiffvNurbsS(nurb,*u,*v);
	double phi = CalcInnerProduct(nvec,CalcNurbsSCoord(nurb,*u,*v));
	double phi_u = CalcInnerProduct(nvec,pu);
	double phi_v = CalcInnerProduct(nvec,pv);
	double E = CalcInnerProduct(pu,pu);
	double F = CalcInnerProduct(pu,pv);
	double G = CalcInnerProduct(pv,pv);
	double f = sqrt(E*phi_v*phi_v - 2*F*phi_u*phi_v + G*phi_u*phi_u); 
	//fprintf(stderr,"%lf , %lf\n",phi_u,phi_v);
	if(CheckZero(phi_u,MID_ACCURACY) == KOD_TRUE && CheckZero(phi_v,MID_ACCURACY) == KOD_TRUE){			// ٓ_
        //GuiIF.SetMessage("NURBS KOD_ERROR:The process is stoped by detected singular point.");
		return KOD_ERR;				
	}

	// ǐՏ̏ꍇ
	if(direction == FORWARD){
		f = 1/f;
	}
	// ǐՋt̏ꍇ
	else if(direction == INVERSE){
		f = -1/f;
	}

	double du = -f*phi_v*ds;		// l
	double dv = f*phi_u*ds;			// l

	// j[g@pu,v^lɎ
	int k=0;
	if(fabs(dv) > fabs(du)){				// dv>dȕꍇdv萔ƂČŒ肷
		while(!CheckZero(du,MID_ACCURACY)){		// du܂ŌJԂvZ
			phi = CalcInnerProduct(nvec,CalcNurbsSCoord(nurb,*u,*v));
			phi_u = CalcInnerProduct(nvec,CalcDiffuNurbsS(nurb,*u,*v));
			phi_v = CalcInnerProduct(nvec,CalcDiffvNurbsS(nurb,*u,*v));
			du = (d-phi-phi_v*dv)/phi_u;
			*u += du;
			if(!CheckRange(nurb->U[0],nurb->U[1],*u,0) || k > LOOPCOUNTMAX){
                //GuiIF.SetMessage("NURBS KOD_ERROR:fail to calculate convergence");
				return KOD_FALSE;
			}
			k++;
		}
		*v += dv;
		if(!CheckRange(nurb->V[0],nurb->V[1],*v,0)){
			return KOD_FALSE;
		}
	}
	else{									// dv<dȕꍇdu萔ƂČŒ肷
		while(!CheckZero(dv,MID_ACCURACY)){		// dv܂ŌJԂvZ
			phi = CalcInnerProduct(nvec,CalcNurbsSCoord(nurb,*u,*v));
			phi_u = CalcInnerProduct(nvec,CalcDiffuNurbsS(nurb,*u,*v));
			phi_v = CalcInnerProduct(nvec,CalcDiffvNurbsS(nurb,*u,*v));
			dv = (d-phi-phi_u*du)/phi_v;
			*v += dv;
			if(!CheckRange(nurb->V[0],nurb->V[1],*v,0) || k>LOOPCOUNTMAX){
                //GuiIF.SetMessage("NURBS KOD_ERROR:fail to calculate convergence");
				return KOD_FALSE;
			}
			k++;
		}
		*u += du;
		if(!CheckRange(nurb->U[0],nurb->U[1],*u,0))
			return KOD_FALSE;
	}
	return KOD_TRUE;
}


// NURBSȖʂNURBSȐƂ̌_QǐՖ@ŋ߂
//   *NurbsS,*NurbsC:NURBSȖʂNURBSȐւ̃|C^   Divnum:_T[`̋Ȑ   *ans:  ans_size:ansz̔z
// Ԓl  _̐
int NURBS_Func::CalcIntersecPtsNurbsSNurbsC(NURBSS *NurbsS,NURBSC *NurbsC,int Divnum,Coord *ans,int ans_size)
{
	Coord d = SetCoord(100,100,100);		// NURBSȐS(u,v)̔ω(du,dv)AN(t)̔ωdti[
	Coord F,Fu,Fv,Ft;						// F(u,v,t) = S(u,v) - N(t)    Fu = dF/du     Fv = dF/dv     Ft = dF/dt
	double u = NurbsS->U[0];				// NURBSȖS(u,v)up[^̌ݒl
	double v = NurbsS->V[0];				// NURBSȖS(u,v)vp[^̌ݒl
	double t = NurbsC->V[0];				// NURBSȐC(t)tp[^
	Matrix A = NewMatrix(3,3);				// Fu,Fv,Ft\3x3s
	Matrix A_ = NewMatrix(3,3);				// A̋tsi[
	bool flag = false;						// tO
	double dt = (NurbsC->V[1] - NurbsC->V[0])/(double)Divnum;	// Zptp[^̃C^[ol
	int loopcount = 0;						// vZ
	int anscount = 0;						// Zoꂽ_̐

	// t loop
	for(int i=0;i<Divnum;i++){
		t = NurbsC->V[0] + (double)i*dt;	// Xebvp[^t̏lZbg
		u = NurbsS->U[0];					// Xebvp[^ȕlZbg
		v = NurbsS->V[0];					// Xebvp[^v̏lZbg
		flag = false;						// tOOFF
		loopcount = 0;						// [vJEg
		// ̔ωdt(=d.z)APPROX_ZERO܂Ńj[g@ɂvZs
		while(loopcount < LOOPCOUNTMAX){
			F = SubCoord(CalcNurbsSCoord(NurbsS,u,v),CalcNurbsCCoord(NurbsC,t));	// F(u,v,t) = S(u,v) - C(t)
			Fu = CalcDiffuNurbsS(NurbsS,u,v);			// Fu = dF/du = dS/du
			Fv = CalcDiffvNurbsS(NurbsS,u,v);			// Fv = dF/dv = dS/dv
			Ft = CalcDiffNurbsC(NurbsC,t);				// Ft = dF/dt = dC/dt
			A[0][0] = Fu.x;				// Fu,Fv,Ft3x3sAɑ
			A[0][1] = Fv.x;				//     |Fu.x Fv.x Ft.x|       |du|       |F.x|
			A[0][2] = Ft.x;				// A = |Fu.y Fv.y Ft.y| , d = |dv| , F = |F.y|
			A[1][0] = Fu.y;				//     |Fu.z Fv.z Ft.z|       |dt|       |F.z|
			A[1][1] = Fv.y;
			A[1][2] = Ft.y;				// AEd = F   --->   d = A_EF
			A[2][0] = Fu.z;
			A[2][1] = Fv.z;
			A[2][2] = Ft.z;	
			if(MatInv3(A,A_) == KOD_FALSE)	break;		// ts߂
			d = MulCoord(MulMxCoord(A_,F),-1);			// dZo

			if(fabs(d.x) <= APPROX_ZERO && fabs(d.y) <= APPROX_ZERO && fabs(d.z) <= APPROX_ZERO){	// ^lɎloop𔲂
				flag = true;		// tOtrue
				break;
			}

			// ^lɒBĂȂu,v,tXV
			u += d.x;
			v += d.y;
			t += d.z;

			if(u < NurbsS->U[0] || u > NurbsS->U[1] || v < NurbsS->V[0] || v > NurbsS->V[1] || t < NurbsC->V[0] || t > NurbsC->V[1]){	// u,v̂ǂ炩Uloop𔲂
				flag = false;		// tOfalse
				break;
			}

			loopcount++;
		}// end of while

		// ĂƂēo^
		if(flag == true){
			ans[anscount] = SetCoord(u,v,t);
			anscount++;
			if(anscount == ans_size){
                GuiIF.SetMessage("NURBS_Func ERROR: Ans_size overflow");
				return KOD_ERR;
			}
		}
	}// end of i loop

	FreeMatrix(A,3);
	FreeMatrix(A_,3);

	anscount = CheckTheSamePoints(ans,anscount);		// _͏

	return anscount;
}

// NURBSȖS(u,v)NURBSȖR(w,t)̌(_Q)_ǐՖ@ɂċ߂
// @nurbsS:NURBSȖS(u,v) nurbsR:NURBSȖR(w,t) div:_T[`̋Ȗʕ  ds:(_Q)̑e(0.1`2a)  ans:  ans_size:ansz̔z
// Ԓl@FALSE:NURBSȖʓmĂȂ@ERR:ٓ_܂͔Uɂ菈𒆒f
int NURBS_Func::CalcIntersecPtsNurbsSSearch(NURBSS *nurbR,NURBSS *nurbS,int div,double ds,Coord *ansR,Coord *ansS,int ans_size)
{
	int ans_count=0;		// ǐՓ_̑
	int loop_count=0;		// vZ̃[v
	int pnow=0;
	Coord init_pt_R[INTERSECPTNUMMAX];		// _(u,vp[^l)
	Coord init_pt_S[INTERSECPTNUMMAX];		// _(u,vp[^l)
	Coord init_pt_Coord_R[INTERSECPTNUMMAX];	// _(x,y,zWl)
	Coord init_pt_Coord_S[INTERSECPTNUMMAX];
	int  init_pt_flag[INTERSECPTNUMMAX];		// e_ʂI𔻕ʂtO
	int  init_allpt_flag=KOD_FALSE;			// _SĒʂI𔻕ʂtO
	int   init_pt_num = 0;				// _̐
	int  conform_flag = KOD_FALSE;			// _vtO
	int  search_flag = KOD_TRUE;			// ǐՕtO(KOD_TRUE:,KOD_FALSE:t)
	int  inverse_flag = KOD_FALSE;			// ǐՕt]tO
	double u,v,w,t;					// ǐՒu,vp[^Ԓl
//	FILE *fp=fopen("debug.csv","w");
//	double color[3] = {0,1,1};
	
	// _ʉߔʃtO
//	init_pt_flag[0] = KOD_TRUE;
	for(int i=0;i<INTERSECPTNUMMAX;i++){
		init_pt_flag[i] = KOD_FALSE;
	}
	init_pt_flag[0] = KOD_TRUE;

	// ǐՂ邽߂̏_ƂȂ_T
	// :@̌[vꍇASĂ̌[v̏_Ȃ΂ȂȂ
	//@@@@@̂߁A܂蕪Ȃƈꕔ̌[vɌ(_Q)ȂȂꍇ
	init_pt_num = CalcIntersecPtsNurbsSGeom(nurbR,nurbS,div,div,init_pt_R,init_pt_S,INTERSECPTNUMMAX);
	//if(!init_pt_num){
	//	init_pt_num = CalcIntersecPtsNurbsSGeom(nurbR,nurbS,5,5,init_pt_R,init_pt_S,INTERSECPTNUMMAX);
	//}
	//if(!init_pt_num){
	//	init_pt_num = CalcIntersecPtsNurbsSGeom(nurbR,nurbS,7,7,init_pt_R,init_pt_S,INTERSECPTNUMMAX);
	//}
	//if(!init_pt_num){
	//	init_pt_num = CalcIntersecPtsNurbsSGeom(nurbR,nurbS,10,10,init_pt_R,init_pt_S,INTERSECPTNUMMAX);
	//}
	if(!init_pt_num){		// łȂꍇ́AĂȂƂ݂Ȃ
		return KOD_FALSE;					
	}
	
	for(int i=0;i<init_pt_num;i++){
		init_pt_Coord_R[i] = CalcNurbsSCoord(nurbR,init_pt_R[i].x,init_pt_R[i].y);		// _uvp[^xyzWlɕϊ̂ێĂ
		init_pt_Coord_S[i] = CalcNurbsSCoord(nurbS,init_pt_S[i].x,init_pt_S[i].y);		// _uvp[^xyzWlɕϊ̂ێĂ
	//	DrawPoint(init_pt_Coord_R[i],1,5,color);
	//	DrawPoint(init_pt_Coord_S[i],1,5,color);
	}
	ansR[ans_count] = SetCoord(init_pt_R[0]);
	ansS[ans_count] = SetCoord(init_pt_S[0]);
	
	// _SĒʉ߂܂ŌǐՖ@JԂ
	while(init_allpt_flag == KOD_FALSE){
		// ǐՂ̂߂̎n_R(w,t),S(u,v)Zbg
		w = ansR[ans_count].x = init_pt_R[pnow].x;
		t = ansR[ans_count].y = init_pt_R[pnow].y;
		u = ansS[ans_count].x = init_pt_S[pnow].x;
		v = ansS[ans_count].y = init_pt_S[pnow].y;
 		if(inverse_flag == KOD_FALSE){		// ǐՕtɕςƂȊO
			ans_count++;			// JEg
			init_pt_flag[pnow] = KOD_TRUE;	// _ʉ߃tO𗧂Ă
		}
		else if(inverse_flag == KOD_TRUE)		// ǐՕtɕςƂ
			inverse_flag = KOD_FALSE;		// ǐՕ(t)tOɖ߂
		
		// ǐՊJn
		while(1){
			// ǐՕ̏ꍇ
			if(search_flag == KOD_TRUE){
				search_flag = SearchIntersectPt(nurbR,nurbS,ds,&w,&t,&u,&v,FORWARD);	// Ɍǐ
				if(search_flag != KOD_TRUE)						// uvp[^Oɏo
 					inverse_flag = KOD_TRUE;						// ǐՕ(t)tO𗧂Ă
			}
			// ǐՕt̏ꍇ
			else if(search_flag == KOD_FALSE){
				int flag = SearchIntersectPt(nurbR,nurbS,ds,&w,&t,&u,&v,INVERSE);
				if(flag == KOD_FALSE)	// uvp[^Oɏo
					search_flag = KOD_TRUE;						// ǐՕtO
 			}
			// ٓ_oȂǂɂ菈płȂꍇ
			else if(search_flag == KOD_ERR){
				return KOD_ERR;
			}

			Coord pr = CalcNurbsSCoord(nurbR,w,t);			// ꂽu,vxyzWlɕϊ
			Coord ps = CalcNurbsSCoord(nurbS,u,v);			// ꂽu,vxyzWlɕϊ
			double distr = CalcDistance(init_pt_Coord_R[pnow],pr);	// ꂽxyzWlƏ_Ƃ̋Zo
			double dists = CalcDistance(init_pt_Coord_S[pnow],ps);	// ꂽxyzWlƏ_Ƃ̋Zo
			
			// _̌~bgz
			if(ans_count >= ans_size-1){
                GuiIF.SetMessage("NURBS KOD_ERROR:Intersection points exceeded the allocated array length");
				return ans_count;
			}

			// ŏɋ߂_ǐՖ@ɂđSĒʉ߂ׂ
			for(int i=0;i<init_pt_num;i++){
				if(CalcDistance(init_pt_Coord_R[i],pr) < ds){
					if(init_pt_flag[i] == KOD_TRUE && i < pnow){
						conform_flag = KOD_TRUE;
						break;
					}
					init_pt_flag[i] = KOD_TRUE;
				}
			}
			
			// u,v蓾p[^͈́i0`1j𒴂ꍇ܂́APĖ߂Ăꍇ̓[v𔲂
			if(!CheckRange(nurbR->U[0],nurbR->U[1],w,0) || !CheckRange(nurbR->V[0],nurbR->V[1],t,0) || (distr < ds/2 && loop_count > 0)){
				break;
			}
			
			if(!CheckRange(nurbS->U[0],nurbS->U[1],u,0) || !CheckRange(nurbS->V[0],nurbS->V[1],v,0) || (dists < ds/2 && loop_count > 0)){
				break;
			}
			
			// ꂽu,v(_Q)Ƃēo^
			ansR[ans_count] = SetCoord(w,t,0);
			ansS[ans_count] = SetCoord(u,v,0);
			ans_count++;

			if(conform_flag == KOD_TRUE){
				conform_flag = KOD_FALSE;
				break;
			}

			loop_count++;		// [v񐔂CNg

 		}// ǐՂ܂

		// c_΁Aʂ̌̂ŁA̓_n_ƂčēxǐՂs
		if(search_flag == KOD_TRUE){
			init_allpt_flag = KOD_TRUE;
			for(int i=0;i<init_pt_num;i++){
				if(init_pt_flag[i] == KOD_FALSE){
					init_allpt_flag = KOD_FALSE;
					pnow = i;
					break;
				}
			}
		}
	}
	
	//fclose(fp);
	return ans_count;
}

// NURBSȖS(u,v)NURBSȖR(w,t)̌(_Q)􉽊wIɋ߂(⏕ʂp@)
//   *nurbS:NURBSȖS(u,v) *nurbR:NURBSȖR(w,t) u_divnum:up[^@v_divnum:vp[^
//       *ans:Zoꂽ_u,vp[^lꂼans.x,ans.yɊi[,  ans_size:ans̔z
// Ԓl  _̌(_̐ans_size𒴂FERR)
int NURBS_Func::CalcIntersecPtsNurbsSGeom(NURBSS *nurbR,NURBSS *nurbS,int u_divnum,int v_divnum,Coord *ansR,Coord *ansS,int ans_size)
{
	int ansnum=0;
	
	// eȖʂw̕uvA̓_ɂ⏕ʂ𐶐Č̔Cӂ1_Ɏ
	for(int w=0;w<u_divnum;w++){
		for(int t=0;t<v_divnum;t++){
			for(int u=0;u<u_divnum;u++){
				for(int v=0;v<v_divnum;v++){
					// eȖʂɕ_𐶐
					double w0 = nurbR->U[0] + (nurbR->U[1] - nurbR->U[0])*(double)w/(double)u_divnum;
					double t0 = nurbR->V[0] + (nurbR->V[1] - nurbR->V[0])*(double)t/(double)v_divnum;
					double u0 = nurbS->U[0] + (nurbS->U[1] - nurbS->U[0])*(double)u/(double)u_divnum;
					double v0 = nurbS->V[0] + (nurbS->V[1] - nurbS->V[0])*(double)v/(double)v_divnum;
					for(int i=0;i<10;i++){
						// ep[^Zo
						Coord p0 = CalcNurbsSCoord(nurbR,w0,t0);					// R(w0,t0)ƂȂ_(_)̍W
						Coord q0 = CalcNurbsSCoord(nurbS,u0,v0);					// S(u0,v0)ƂȂ_(_)̍W
						Coord rw = CalcDiffuNurbsS(nurbR,w0,t0);					// _R(w0,t0)uΔ({xNg)
						Coord rt = CalcDiffvNurbsS(nurbR,w0,t0);					// _R(w0,t0)vΔ({xNg)
						double rwt = CalcEuclid(CalcOuterProduct(rw,rt));
						if(rwt==0.0) break;
						Coord np = DivCoord(CalcOuterProduct(rw,rt),rwt);			// _R(w0,t0)̒Pʖ@xNg
						Coord su = CalcDiffuNurbsS(nurbS,u0,v0);					// _S(u0,v0)uΔ({xNg)
						Coord sv = CalcDiffvNurbsS(nurbS,u0,v0);					// _S(u0,v0)vΔ({xNg)
						double suv = CalcEuclid(CalcOuterProduct(su,sv));
						if(suv==0.0) break;
						Coord nq = DivCoord(CalcOuterProduct(su,sv),suv);			// _S(u0,v0)̒Pʖ@xNg
						double npq = CalcEuclid(CalcOuterProduct(np,nq));
						if(npq==0.0) break;
						Coord nn = DivCoord(CalcOuterProduct(np,nq),npq);			// FpƕFqɒ镽Fn̒Pʖ@xNg
						double dp = CalcInnerProduct(p0,np);						// _畽Fp܂ł̋
						double dq = CalcInnerProduct(q0,nq);						// _畽Fq܂ł̋
						double dn = CalcInnerProduct(p0,nn);						// _畽Fn܂ł̋
						Coord cross_nqn = CalcOuterProduct(nq,nn);					// Pʖ@xNgnq,nñxNg
						Coord cross_nnp = CalcOuterProduct(nn,np);					// Pʖ@xNgnn,np̃xNg
						Coord cross_npq = CalcOuterProduct(np,nq);					// Pʖ@xNgnp,nq̃xNg
						Coord nume_p_sub =  AddCoord(MulCoord(cross_nqn,dp),MulCoord(cross_nnp,dq));	// 3Fp,Fq,Fň_p̕q̍ŏ2vZ
						Coord nume_p = AddCoord(nume_p_sub,MulCoord(cross_npq,dn));			// p̕qZo
						double denom_p = CalcScalarTriProduct(np,nq,nn);			// p̕Zo
						Coord p = DivCoord(nume_p,denom_p);							// pZo
						Coord deltap0 = SubCoord(p,p0);								// _pƓ_p0̍xNgZo
						Coord deltaq0 = SubCoord(p,q0);								// _pƓ_q0̍xNgZo
						Coord rw_sub = CalcOuterProduct(rw,np);						// {xNgrwƖ@xNgnpɒxNg
						Coord rt_sub = CalcOuterProduct(rt,np);						// {xNgrtƖ@xNgnpɒxNg
						Coord su_sub = CalcOuterProduct(su,nq);						// {xNgsuƖ@xNgnqɒxNg
						Coord sv_sub = CalcOuterProduct(sv,nq);						// {xNgsvƖ@xNgnqɒxNg
						double dw = CalcInnerProduct(rt_sub,deltap0)/CalcInnerProduct(rt_sub,rw);	// V_r(w0+dw,t0+dt)^邽߂dwZo
						double dt = CalcInnerProduct(rw_sub,deltap0)/CalcInnerProduct(rw_sub,rt);	// V_r(w0+dw,t0+dt)^邽߂dtZo
						double du = CalcInnerProduct(sv_sub,deltaq0)/CalcInnerProduct(sv_sub,su);	// V_r(w0+dw,t0+dt)^邽߂dwZo
						double dv = CalcInnerProduct(su_sub,deltaq0)/CalcInnerProduct(su_sub,sv);	// V_r(w0+dw,t0+dt)^邽߂dtZo
						w0 += dw;									// V_wp[^𓾂
						t0 += dt;									// V_tp[^𓾂
						u0 += du;									// V_up[^𓾂
						v0 += dv;									// V_vp[^𓾂
						
						// Ȗʂ͈̔͊OɏoĂ܂烋[v𔲂
						if(!CheckRange(nurbR->U[0],nurbR->U[1],w0,1) || !CheckRange(nurbR->V[0],nurbR->V[1],t0,1)){
							break;
						}
						if(!CheckRange(nurbS->U[0],nurbS->U[1],u0,1) || !CheckRange(nurbS->V[0],nurbS->V[1],v0,1)){
							break;
						}
						
						Coord deltapq = SubCoord(p0,q0);						// _p0Ɠ_q0̍xNgZo
						double deltapq_dis = CalcEuclid(deltapq);					// |p0-q0|̋Zo

						// \o^
						if(deltapq_dis < CONVERG_GAP){								
							if(!ansnum || (!CheckZero(ansR[ansnum-1].x-w0,MID_ACCURACY) && !CheckZero(ansR[ansnum-1].y-t0,MID_ACCURACY))){// OɎZoƓ̉łȂ
								ansR[ansnum] = SetCoord(w0,t0,0);						// Ƃēo^
								ansS[ansnum] = SetCoord(u0,v0,0);
								ansnum++;								// JEg
								if(ansnum == ans_size)					// ̐z
									return ansnum;
							}
							break;
						}
					}
				}
			}
		}
	}
	return ansnum;
}


// j[g@ɂ_^lɎ(NURBSȖʓm)
int NURBS_Func::SearchIntersectPt(NURBSS *nurbR,NURBSS *nurbS,double ds,double *w,double *t,double *u,double *v,int direction)
{
	double **J;
	double D[3];
	double ans[3];
	int flag = KOD_TRUE;

	// m
	if((J = NewMatrix(3,3)) == NULL){
        GuiIF.SetMessage("NURBS ERROR: fail to malloc\n");
		return KOD_ERR;
	}

	// ܂lƂĂdw,dt,du,dv߂
	Coord r = CalcNurbsSCoord(nurbR,*w,*t);					// _R(w,t)NURBSȖʂ̍Wl߂
	Coord s = CalcNurbsSCoord(nurbS,*u,*v);					// _S(u,v)NURBSȖʂ̍Wl߂
	Coord rw = CalcDiffuNurbsS(nurbR,*w,*t);					// _R(w,t)uΔ({xNg)
	Coord rt = CalcDiffvNurbsS(nurbR,*w,*t);					// _R(w,t)vΔ({xNg)
	Coord su = CalcDiffuNurbsS(nurbS,*u,*v);					// _S(u,v)uΔ({xNg)
	Coord sv = CalcDiffvNurbsS(nurbS,*u,*v);					// _S(u,v)vΔ({xNg)
	Coord n1 = DivCoord(CalcOuterProduct(rw,rt),CalcEuclid(CalcOuterProduct(rw,rt)));	// _R(w0,t0)̒Pʖ@xNg
	Coord n2 = DivCoord(CalcOuterProduct(su,sv),CalcEuclid(CalcOuterProduct(su,sv)));	// _S(u0,v0)̒Pʖ@xNg
	double f1 = CalcInnerProduct(n2,rt);
	double g1 = CalcInnerProduct(n2,rw);
	double f2 = CalcInnerProduct(n1,sv);
	double g2 = CalcInnerProduct(n1,su);
	double E1 = CalcInnerProduct(rw,rw);
	double F1 = CalcInnerProduct(rw,rt);
	double G1 = CalcInnerProduct(rt,rt);
	double E2 = CalcInnerProduct(su,su);
	double F2 = CalcInnerProduct(su,sv);
	double G2 = CalcInnerProduct(sv,sv);
	double phi1 = sqrt(E1*f1*f1 - 2*F1*f1*g1 + G1*g1*g1);
	double phi2 = sqrt(E2*f2*f2 - 2*F2*f2*g2 + G2*g2*g2);
	if(!phi1 && !phi2){			// ٓ_
        GuiIF.SetMessage("NURBS KOD_ERROR:The process is stoped by detected singular point.");
		FreeMatrix(J,3);
		return KOD_ERR;				
	}
	
	// ǐՏ̏ꍇ
	if(direction == FORWARD){
		phi1 = 1/phi1;
		phi2 = -1/phi2;
	}
	// ǐՋt̏ꍇ
	else if(direction == INVERSE){
		phi1 = -1/phi1;
		phi2 = 1/phi2;
	}
	
	// p[^̏lݒ
	double dw = -f1*phi1*ds;		
	double dt = g1*phi1*ds;		
	double du = -f2*phi2*ds;
	double dv = g2*phi2*ds;
	double sort[4] = {fabs(dw),fabs(dt),fabs(du),fabs(dv)};	// \[gpϐp
	BubbleSort(sort,4);					// Ƀ\[g
	double max_delta = sort[3];				// ep[^̒ōől𓾂

	// j[g@pw,t,u,v^lɎ
	int k=0;	// vZ񐔂
	// dw,dt,du,dv̐Βldwő̎Adw萔ƂČŒ肷
	if(max_delta == fabs(dw)){
		while(fabs(dt) > CONVERG_GAP || fabs(du) > CONVERG_GAP || fabs(dv) > CONVERG_GAP){	
			r = CalcNurbsSCoord(nurbR,*w,*t);						// _R(w,t)NURBSȖʂ̍Wl߂
			s = CalcNurbsSCoord(nurbS,*u,*v);						// _S(u,v)NURBSȖʂ̍Wl߂
			rw = CalcDiffuNurbsS(nurbR,*w,*t);						// _R(w,t)uΔ({xNg)
			rt = CalcDiffvNurbsS(nurbR,*w,*t);						// _R(w,t)vΔ({xNg)
			su = CalcDiffuNurbsS(nurbS,*u,*v);						// _S(u,v)uΔ({xNg)
			sv = CalcDiffvNurbsS(nurbS,*u,*v);						// _S(u,v)vΔ({xNg)
			
			// 3A߂Ɋep[^zɊi[
			double sol[3] = {s.x-r.x-rw.x*dw, s.y-r.y-rw.y*dw, s.z-r.z-rw.z*dw};
			double coef[3][3] = {{rt.x,-su.x,-sv.x},{rt.y,-su.y,-sv.y},{rt.z,-su.z,-sv.z}};
			
			for(int i=0;i<3;i++){
				D[i] = sol[i];
				ans[i] = 0;
				for(int j=0;j<3;j++){
					J[i][j] = coef[i][j];
				}
			}

			// AAp[^XV
			Gauss(3,J,D,ans);
			dt = ans[0];
			du = ans[1];
			dv = ans[2];
			*t += dt;
			*u += du;
			*v += dv;
			
			// uvp[^͈͊Oɏo
			if(!CheckRange(nurbR->V[0],nurbR->V[1],*t,0) || !CheckRange(nurbS->U[0],nurbS->U[1],*u,0) || !CheckRange(nurbS->V[0],nurbS->V[1],*v,0) || k>LOOPCOUNTMAX){
				flag = KOD_FALSE;
				goto EXIT;
			}
			k++;
		}
		*w += dw;	// Œ肵Ăp[^XV
		if(!CheckRange(nurbR->U[0],nurbR->U[1],*w,0)){
			flag = KOD_FALSE;
			goto EXIT;
		}
	}
	
	// dw,dt,du,dv̐Βldtő̎Adt萔ƂČŒ肷
	else if(max_delta == fabs(dt)){	
		while(fabs(dw) > CONVERG_GAP || fabs(du) > CONVERG_GAP || fabs(dv) > CONVERG_GAP){	
			r = CalcNurbsSCoord(nurbR,*w,*t);					// _R(w,t)NURBSȖʂ̍Wl߂
			s = CalcNurbsSCoord(nurbS,*u,*v);					// _S(u,v)NURBSȖʂ̍Wl߂
			rw = CalcDiffuNurbsS(nurbR,*w,*t);					// _R(w,t)uΔ({xNg)
			rt = CalcDiffvNurbsS(nurbR,*w,*t);					// _R(w,t)vΔ({xNg)
			su = CalcDiffuNurbsS(nurbS,*u,*v);					// _S(u,v)uΔ({xNg)
			sv = CalcDiffvNurbsS(nurbS,*u,*v);					// _S(u,v)vΔ({xNg)
			
			// 3A߂Ɋep[^zɊi[
			double sol[3] = {s.x-r.x-rt.x*dt, s.y-r.y-rt.y*dt, s.z-r.z-rt.z*dt};
			double coef[3][3] = {{rw.x,-su.x,-sv.x},{rw.y,-su.y,-sv.y},{rw.z,-su.z,-sv.z}};
			for(int i=0;i<3;i++){
				D[i] = sol[i];
				ans[i] = 0;
				for(int j=0;j<3;j++){
					J[i][j] = coef[i][j];
				}
			}
			
			// AAp[^XV
			Gauss(3,J,D,ans);
			dw = ans[0];
			du = ans[1];
			dv = ans[2];
			*w += dw;
			*u += du;
			*v += dv;
				
			// uvp[^͈͊Oɏo
			if(!CheckRange(nurbR->U[0],nurbR->U[1],*w,0) || !CheckRange(nurbS->U[0],nurbS->U[1],*u,0) || !CheckRange(nurbS->V[0],nurbS->V[1],*v,0) || k>LOOPCOUNTMAX){
				flag = KOD_FALSE;
				goto EXIT;
			}
			k++;
		}
		*t += dt;	// Œ肵Ăp[^XV
		if(!CheckRange(nurbR->V[0],nurbR->V[1],*t,0)){
			flag = KOD_FALSE;
			goto EXIT;
		}
	}
			
	// dw,dt,du,dv̐Βlduő̎Adu萔ƂČŒ肷
	else if(max_delta == fabs(du)){	
		while(fabs(dw) > CONVERG_GAP || fabs(dt) > CONVERG_GAP || fabs(dv) > CONVERG_GAP){	
			r = CalcNurbsSCoord(nurbR,*w,*t);					// _R(w,t)NURBSȖʂ̍Wl߂
			s = CalcNurbsSCoord(nurbS,*u,*v);					// _S(u,v)NURBSȖʂ̍Wl߂
			rw = CalcDiffuNurbsS(nurbR,*w,*t);					// _R(w,t)uΔ({xNg)
			rt = CalcDiffvNurbsS(nurbR,*w,*t);					// _R(w,t)vΔ({xNg)
			su = CalcDiffuNurbsS(nurbS,*u,*v);					// _S(u,v)uΔ({xNg)
			sv = CalcDiffvNurbsS(nurbS,*u,*v);					// _S(u,v)vΔ({xNg)
			
			// 3A߂Ɋep[^zɊi[
			double sol[3] = {s.x-r.x+su.x*du, s.y-r.y+su.y*du, s.z-r.z+su.z*du};
			double coef[3][3] = {{rw.x,rt.x,-sv.x},{rw.y,rt.y,-sv.y},{rw.z,rt.z,-sv.z}};
			for(int i=0;i<3;i++){
				D[i] = sol[i];
				ans[i] = 0;
				for(int j=0;j<3;j++){
					J[i][j] = coef[i][j];
				}
			}
			
			// AAp[^XV
			Gauss(3,J,D,ans);
			dw = ans[0];
			dt = ans[1];
			dv = ans[2];
			*w += dw;
			*t += dt;
			*v += dv;
			
			// uvp[^͈͊Oɏo
			if(!CheckRange(nurbR->U[0],nurbR->U[1],*w,0) || !CheckRange(nurbR->V[0],nurbR->V[1],*t,0) || !CheckRange(nurbS->V[0],nurbS->V[1],*v,0) || k>LOOPCOUNTMAX){
				flag = KOD_FALSE;
				goto EXIT;
			}
			k++;
		}
		*u += du;	// Œ肵Ăp[^XV
		if(!CheckRange(nurbS->U[0],nurbS->U[1],*u,0)){
			flag = KOD_FALSE;
			goto EXIT;
		}
	}
	
	// dw,dt,du,dv̐Βldvő̎Adv萔ƂČŒ肷
	else if(max_delta == fabs(dv)){	
		while(fabs(dt) > CONVERG_GAP || fabs(dw) > CONVERG_GAP || fabs(du) > CONVERG_GAP){	
			r = CalcNurbsSCoord(nurbR,*w,*t);					// _R(w,t)NURBSȖʂ̍Wl߂
			s = CalcNurbsSCoord(nurbS,*u,*v);					// _S(u,v)NURBSȖʂ̍Wl߂
			rw = CalcDiffuNurbsS(nurbR,*w,*t);					// _R(w,t)uΔ({xNg)
			rt = CalcDiffvNurbsS(nurbR,*w,*t);					// _R(w,t)vΔ({xNg)
			su = CalcDiffuNurbsS(nurbS,*u,*v);					// _S(u,v)uΔ({xNg)
			sv = CalcDiffvNurbsS(nurbS,*u,*v);					// _S(u,v)vΔ({xNg)
			
			// 3A߂Ɋep[^zɊi[
			double sol[3] = {s.x-r.x+sv.x*dv, s.y-r.y+sv.y*dv, s.z-r.z+sv.z*dv};
			double coef[3][3] = {{rw.x,rt.x,-su.x},{rw.y,rt.y,-su.y},{rw.z,rt.z,-su.z}};
			for(int i=0;i<3;i++){
				D[i] = sol[i];
				ans[i] = 0;
				for(int j=0;j<3;j++){
					J[i][j] = coef[i][j];
				}
			}
			
			// AAp[^XV
			Gauss(3,J,D,ans);
			dw = ans[0];
			dt = ans[1];
			du = ans[2];
			*w += dw;
			*t += dt;
			*u += du;
			
			// uvp[^͈͊Oɏo
			if(!CheckRange(nurbR->U[0],nurbR->U[1],*w,0) || !CheckRange(nurbR->V[0],nurbR->V[1],*t,0) || !CheckRange(nurbS->U[0],nurbS->U[1],*u,0) || k>LOOPCOUNTMAX){
				flag = KOD_FALSE;
				goto EXIT;
			}
			k++;
		}
		*v += dv;	// Œ肵Ăp[^XV
		if(!CheckRange(nurbS->V[0],nurbS->V[1],*v,0)){
			flag = KOD_FALSE;
			goto EXIT;
		}
	}

EXIT:
	// 
	FreeMatrix(J,3);
	
	return flag;
}


// NURBSȐC(u) or C(v)̌W߂
void NURBS_Func::GetNurbsSCoef(int M,double **coef,double *a,Coord *b,int i,Coord *P,double *Q)
{
	for(int k=0;k<M;k++){
		Q[k] = 0;
		InitCoord(&P[k]);
		for(int j=0;j<M;j++){
			Q[k] += coef[j][k]*a[i+j];
			P[k] = AddCoord(P[k],MulCoord(b[i+j],coef[j][k]));
		}
	}
}


// NURBSȐm̌_߂(j[g@)
//    *NurbA, *NurbB: NURBSȐ     Divnum:lݒp̕     *ans:_i[pz   ans_size:ans̔z
int NURBS_Func::CalcIntersecPtsNurbsCNurbsCParam(NURBSC *NurbA,NURBSC *NurbB,int Divnum,Coord *ans,int ans_size)
{
	double t = NurbA->V[0];		// ݂NurbÃp[^l
	double u = 0;				// ݂NurbB̃p[^l
	double dt = 0;				// j[g@ɂtp[^̍XV
	double du = 0;				// j[g@ɂup[^̍XV
	Coord F;					// j[g@̑ΏۂƂ(F(t,u) = NurbA(t) - NurbB(u))
	Coord Ft;					// Ftɂl
	Coord Fu;					// Fuɂl
	double d = (NurbA->V[1] - NurbA->V[0])/(double)Divnum;	// _̑l
	int loopcount = 0;			// [v
	bool flag = false;			// tO
	int anscount = 0;			// _̐JEg
	Matrix A = NewMatrix(2,2);	// Ft,Fu𐬕ƂɊi[s
	Matrix A_ = NewMatrix(2,2);	// A̋tsi[
	

	for(int i=0;i<Divnum;i++){
		flag = false;
		loopcount = 0;
		t = NurbA->V[0] + (double)i*d;		// lXV
		while(loopcount < LOOPCOUNTMAX){
			F = SubCoord(CalcNurbsCCoord(NurbA,t),CalcNurbsCCoord(NurbB,u));
			Ft = CalcDiffNurbsC(NurbA,t);
			Fu = CalcDiffNurbsC(NurbB,u);
			A[0][0] = Ft.x;
			A[0][1] = Fu.x;
			A[1][0] = Ft.y;
			A[1][1] = Fu.y;
			MatInv2(A,A_);
			dt = -(A_[0][0]*F.x + A_[0][1]*F.y);
			du = -(A_[1][0]*F.x + A_[1][1]*F.y);

			if(CheckZero(dt,HIGH_ACCURACY) == KOD_TRUE && CheckZero(du,HIGH_ACCURACY) == KOD_TRUE){		// XVl臒lȉɂȂAwhile𔲂AƂēo^
				flag = true;
				break;
			}
			t += dt;		// p[^lXV
			u += du;
			if(t < NurbA->V[0] || t > NurbA->V[1] || u < NurbB->V[0] || u > NurbB->V[1]){		// p[^͈͂𒴂Awhile𔲂Ȁlֈڍs
				flag = false;
				break;
			}
			loopcount++;
		}// end of wihle
		if(flag == true){
			ans[anscount].x = t;		// Ƃēo^
			ans[anscount].y = u;
			anscount++;
			if(anscount == ans_size){	// ̌ans_size𒴂AERR^[
                GuiIF.SetMessage("NURBS_Func ERROR: Ans_size overflow");
				return KOD_ERR;
			}
		}
	}// end of i loop

	anscount = CheckTheSamePoints2D(ans,anscount);		// _͏

	FreeMatrix(A,2);
	FreeMatrix(A_,2);

	return anscount;


}


// NURBSȐƕʂƂ̌_߂(j[g@)
//   *nurb:NURBSȐ  pt:ʏ̈_  nvec:ʂ̖@xNg   Divnum:NURBSȐ̃p[^  *ans:Zoꂽ_tp[^li[,  ans_size:ans̔z
//       LoD:ڍדxij[g@̍XVp[^𑫂ނƂɁCLoDŊ邱ƂŁC}ȃp[^ύXDʏ1ł悢CȂꍇ͒l傫D2Ƃ3Ƃj
// Ԓl  _̌     KOD_ERR:_̐ans_size𒴂
// F(t) = nvecE(C(t)-pt) = 0j[g@pċ߂
// _͍ő(M-1)*(K-M+1)_.  (F4KŃRg[|Cg̐8̏ꍇA(4-1)*(8-4+1)=15_)
// Ĉ*ans(M-1)*(K-M+1)̔zpӂ邱Ƃ]܂.
int NURBS_Func::CalcIntersecCurve(NURBSC *nurb,Coord pt,Coord nvec,int Divnum,double *ans,int ans_size,int LoD)
{
	double t = nurb->V[0];		// ݂NURBSȐ̃p[^l
	double d = 0;				// j[g@ɂp[^̍XV
	double F;					// j[g@̑ΏۂƂ
	double Ft;					// Ftɂl
	double dt = (nurb->V[1] - nurb->V[0])/(double)Divnum;	// _̑l
	int loopcount = 0;			// [v
	bool flag = false;			// tO
	int anscount = 0;			// _̐JEg

	if(!LoD){
		GuiIF.SetMessage("NURBS_Func ERROR: LoD is changed 0 to 1");
		LoD = 1;
	}

	for(int i=0;i<=Divnum;i++){
		flag = false;
		loopcount = 0;
		t = nurb->V[0] + (double)i*dt;		// lXV
		while(loopcount < LOOPCOUNTMAX){
			F = CalcInnerProduct(nvec,SubCoord(CalcNurbsCCoord(nurb,t),pt));
			Ft = CalcInnerProduct(nvec,CalcDiffNurbsC(nurb,t));
			d = -F/Ft;		// XVl
			//fprintf(stderr,"   %d:%.14lf,%lf\n",i,d,t);	// for debug
			if(CheckZero(d,HIGH_ACCURACY) == KOD_TRUE){		// XVl臒lȉɂȂAwhile𔲂AƂēo^
				flag = true;
				break;
			}
			t += d/(double)LoD;		// p[^lXV
			
			if(t < nurb->V[0] || t > nurb->V[1]){		// p[^͈͂𒴂Awhile𔲂Ȁlֈڍs
				flag = false;
				break;
			}
			loopcount++;
		}// end of wihle
		if(flag == true){
			if(anscount == ans_size){	// ̌ans_size𒴂AERR^[
				GuiIF.SetMessage("NURBS_Func ERROR: Ans_size overflow");
				return KOD_ERR;
			}
			ans[anscount] = t;		// Ƃēo^
			anscount++;
		}
	}// end of i loop

	anscount = CheckTheSamePoints(ans,anscount);		// _͏

	return anscount;
}

// NURBSȖʂUAC\pȐ(Vp[^Œ)ƕʂƂ̌_߂(j[g@)
//   *nurb:NURBSȖ  V:v̌Œl  pt:ʏ̈_  nvec:ʂ̖@xNg  
//       Divnum:NURBSȐ̃p[^  *ans:Zoꂽ_tp[^li[,  ans_size:ans̔z
// Ԓl  _̌     KOD_ERR:_̐ans_size𒴂
// F(t) = nvecE(C(t)-pt) = 0j[g@pċ߂
// _͍ő(M-1)*(K-M+1)_.  (F4KŃRg[|Cg̐8̏ꍇA(4-1)*(8-4+1)=15_)
// Ĉ*ans(M-1)*(K-M+1)̔zpӂ邱Ƃ]܂.
int NURBS_Func::CalcIntersecIsparaCurveU(NURBSS *nurb,double V,Coord pt,Coord nvec,int Divnum,double *ans,int ans_size)
{
	double d = 0;				// j[g@ɂp[^̍XV
	double F;					// j[g@̑ΏۂƂ
	double Fu;					// Fuɂl
	int loopcount = 0;			// [v
	bool flag = false;			// tO
	int anscount = 0;			// _̐JEg
	double u = nurb->U[0];		// ݂NURBSȐ̃p[^l
	double du = (nurb->U[1] - nurb->U[0])/(double)Divnum;	// _̑l

	for(int i=0;i<=Divnum;i++){
		flag = false;
		loopcount = 0;
		u = nurb->U[0] + (double)i*du;		// lXV
		while(loopcount < LOOPCOUNTMAX){
			F = CalcInnerProduct(nvec,SubCoord(CalcNurbsSCoord(nurb,u,V),pt));
			Fu = CalcInnerProduct(nvec,CalcDiffuNurbsS(nurb,u,V));
			if(CheckZero(Fu,MID_ACCURACY) == KOD_TRUE)	break;
			d = -F/Fu;		// XVl
			if(CheckZero(d,MID_ACCURACY) == KOD_TRUE){		// XVl臒lȉɂȂAwhile𔲂AƂēo^
				flag = true;
				break;
			}
			u += d;		// p[^lXV
			if(u < nurb->U[0] || u > nurb->U[1]){		// p[^͈͂𒴂Awhile𔲂Ȁlֈڍs
				flag = false;
				break;
			}
			loopcount++;
		}// end of wihle
		if(flag == true){
			if(anscount == ans_size){	// ̌ans_size𒴂AERR^[
				GuiIF.SetMessage("NURBS_Func ERROR: Ans_size overflow");
				return KOD_ERR;
			}
			ans[anscount] = u;		// Ƃēo^
			anscount++;
		}
	}// end of i loop

	anscount = CheckTheSamePoints(ans,anscount);		// _͏

	return anscount;
}
// NURBSȖʂVAC\pȐ(Up[^Œ)ƕʂƂ̌_߂(j[g@)
//   *nurb:NURBSȖ  U:ǔŒl   pt:ʏ̈_  nvec:ʂ̖@xNg
//       Divnum:NURBSȐ̃p[^  *ans:Zoꂽ_tp[^li[,  ans_size:ans̔z
// Ԓl  _̌     KOD_ERR:_̐ans_size𒴂
// F(t) = nvecE(C(t)-pt) = 0j[g@pċ߂
// _͍ő(M-1)*(K-M+1)_.  (F4KŃRg[|Cg̐8̏ꍇA(4-1)*(8-4+1)=15_)
// Ĉ*ans(M-1)*(K-M+1)̔zpӂ邱Ƃ]܂.
int NURBS_Func::CalcIntersecIsparaCurveV(NURBSS *nurb,double U,Coord pt,Coord nvec,int Divnum,double *ans,int ans_size)
{
	double d = 0;				// j[g@ɂp[^̍XV
	double F;					// j[g@̑ΏۂƂ
	double Fv;					// Fvɂl
	int loopcount = 0;			// [v
	bool flag = false;			// tO
	int anscount = 0;			// _̐JEg
	double v = nurb->V[0];		// ݂NURBSȐ̃p[^l
	double dv = (nurb->V[1] - nurb->V[0])/(double)Divnum;	// _̑l

	for(int i=0;i<=Divnum;i++){
		flag = false;
		loopcount = 0;
		v = nurb->V[0] + (double)i*dv;		// lXV
		while(loopcount < LOOPCOUNTMAX){
			F = CalcInnerProduct(nvec,SubCoord(CalcNurbsSCoord(nurb,U,v),pt));
			Fv = CalcInnerProduct(nvec,CalcDiffvNurbsS(nurb,U,v));
			if(CheckZero(Fv,MID_ACCURACY) == KOD_TRUE)	break;
			d = -F/Fv;		// XVl
			if(CheckZero(d,MID_ACCURACY) == KOD_TRUE){		// XVl臒lȉɂȂAwhile𔲂AƂēo^
				flag = true;
				break;
			}
			//fprintf(stderr,"   %lf,%lf,%lf,%lf\n",v,d,F,Fv); //for debug
			v += d;		// p[^lXV
			if(v < nurb->V[0] || v > nurb->V[1]){		// p[^͈͂𒴂Awhile𔲂Ȁlֈڍs
				flag = false;
				break;
			}
			loopcount++;
		}// end of wihle
		if(flag == true){
			if(anscount == ans_size){	// ̌ans_size𒴂AERR^[
				GuiIF.SetMessage("NURBS_Func ERROR: Ans_size overflow");
				return KOD_ERR;
			}
			ans[anscount] = v;		// Ƃēo^
			anscount++;
		}
	}// end of i loop

	anscount = CheckTheSamePoints(ans,anscount);		// _͏

	return anscount;
}

// NURBSȐƕʂƂ̌_߂(3܂őΉ)
//   *nurb:NURBSȐ  pt:ʏ̈_  nvec:ʂ̖@xNg  *ans:Zoꂽ_tp[^li[,  ans_size:ans̔z
// Ԓl  _̌
// _͍ő(M-1)*(K-M+1)_.  (F4KŃRg[|Cg̐8̏ꍇA(4-1)*(8-4+1)=15_)
// Ĉ*ans(M-1)*(K-M+1)̔zpӂ邱Ƃ]܂.
int NURBS_Func::CalcIntersecCurve3(NURBSC *nurb,Coord pt,Coord nvec,double *ans,int ans_size)
{
	double **coef;
	double Q[4];	// NURBSȐ̌̕W
	Coord  P[4];	// NURBSȐ̕q̌W
	double a[4];
	double t[3];
	int ansnum;
	int k=0;

	if((coef = NewMatrix(nurb->M,nurb->M)) == NULL){
        GuiIF.SetMessage("NURBS KOD_ERROR: CalcIntersecPlane3()");
		return KOD_ERR;
	}

	// 1{NURBSȐK-M+1{̋Ȑ\Bꂼ̍\Ȑɑ΂ĕ𓱏oA𓾂B
	for(int i=0;i<nurb->K-nurb->M+1;i++){
		if(nurb->M-1 == 3){			// 3			
			GetBSplCoef3(nurb->M,nurb->K,i,nurb->T,coef);	// eRg[|Cgɂ3BXvC֐̌W(coef)߂
		}
		else if(nurb->M-1 == 2){	// 2
			GetBSplCoef2(nurb->M,nurb->K,i,nurb->T,coef);	// eRg[|Cgɂ2BXvC֐̌W߂
		}
		else if(nurb->M-1 == 1){	// 1	
			GetBSplCoef1(nurb->M,nurb->K,i,nurb->T,coef);	// eRg[|Cgɂ1BXvC֐̌W߂
		}
		else{
			char mes[256];
			sprintf(mes,"NURBS KOD_ERROR:Ther order of equation is unsupported. (order = %d)",nurb->M-1);
            GuiIF.SetMessage(mes);
			goto EXIT;
		}
		GetNurbsCCoef(nurb,coef,i,P,Q);						// NURBSȐ̌W(P,Q)߂
		GetIntersecEquation(nurb->M,P,Q,pt,nvec,a);			// NURBSȐƕʂ̌op𓾂
		ansnum = CalcEquation(a,t,nurb->M-1);					// A_̃p[^l𓾂

		for(int j=0;j<ansnum;j++){
			if(t[j] >= nurb->T[i+nurb->M-1] && t[j] <= nurb->T[i+nurb->M]){	// mbgxNg̒lƓK̂̂݉ƂĒo
				if(k == ans_size){
                    GuiIF.SetMessage("NURBS KOD_ERROR:Intersection points exceeded the allocated array length");
					goto EXIT;
				}
				ans[k] = t[j];		// 擾
				k++;				// ̐CNg
			}
		}
	}

	return k;

EXIT:
	FreeMatrix(coef,nurb->M);
	return KOD_ERR;
}

// 3܂ł
int NURBS_Func::CalcEquation(double *a,double *t,int M)
{
	int flag;

	if(M == 3)		flag = CalcCubicEquation(a,t);
	else if(M == 2)	flag = CalcQuadraticEquation(a,t);
	else if(M == 1) flag = CalcLinearEquation(a,t);
	else			return KOD_ERR;

	return flag;
}

// NURBSȐƕʂ̌op𓾂
void NURBS_Func::GetIntersecEquation(int M,Coord *P,double *Q,Coord pt,Coord nvec,double *a)
{
	for(int i=0;i<M;i++){
		a[i] = (Q[i]*pt.x-P[i].x)*nvec.x + (Q[i]*pt.y-P[i].y)*nvec.y + (Q[i]*pt.z-P[i].z)*nvec.z;
	}
}

// NURBSȐ̌W߂(ō3)
int NURBS_Func::GetNurbsCCoef(NURBSC *nurb,double **coef,int i,Coord *P,double *Q)
{
	for(int j=0;j<nurb->M;j++){
		InitCoord(&P[j]);
		Q[j] = 0;
	}

	for(int j=0;j<nurb->M;j++){
		for(int k=0;k<nurb->M;k++){
			Q[j] += coef[k][j]*nurb->W[i+k];
			P[j] = AddCoord(P[j],MulCoord(nurb->cp[i+k],coef[k][j]*nurb->W[i+k]));
		}
	}
	
	return KOD_TRUE;
}

// 3BXvCȐ̊eW߂
//  M:K  K:Rg[|Cg̐  i:ڒ̃Rg[|Cg *t:mbgxNg  *coef:ZoWi[
// coef[j][0]t^3 + coef[j][1]t^2 + coef[j][2]t + coef[j][3]   (Nj,4)
int NURBS_Func::GetBSplCoef3(int M,int K,int i,double *t,double **coef)
{
	double bunbo[8];
	double t10,t20,t21,t30,t31,t32,t41,t42,t43;

	for(int j=0;j<4;j++){

		t10 = t[i+j+1] - t[i+j];
		t20 = t[i+j+2] - t[i+j];
		t21 = t[i+j+2] - t[i+j+1];
		t30 = t[i+j+3] - t[i+j];
		t31 = t[i+j+3] - t[i+j+1];
		t32 = t[i+j+3] - t[i+j+2];
		t41 = t[i+j+4] - t[i+j+1];
		t42 = t[i+j+4] - t[i+j+2];
		t43 = t[i+j+4] - t[i+j+3];

		bunbo[0] = t30*t20*t10;
		bunbo[1] = t30*t20*t21;
		bunbo[2] = t30*t31*t21;
		bunbo[3] = t30*t31*t32;
		bunbo[4] = t41*t31*t21;
		bunbo[5] = t41*t31*t32;
		bunbo[6] = t41*t42*t32;
		bunbo[7] = t41*t42*t43;

		double coef_sub[8][4] = 
		{{1,-3*t[i+j],3*t[i+j]*t[i+j],-t[i+j]*t[i+j]*t[i+j]},
		{-1,t[i+j+2]+2*t[i+j],-2*t[i+j]*t[i+j+2]-t[i+j]*t[i+j],t[i+j]*t[i+j]*t[i+j+2]},
		{-1,t[i+j+3]+t[i+j+1]+t[i+j],-(t[i+j+1]+t[i+j])*t[i+j+3]-t[i+j]*t[i+j+1],t[i+j]*t[i+j+1]*t[i+j+3]},
		{1,-2*t[i+j+3]-t[i+j],t[i+j+3]*t[i+j+3]+2*t[i+j]*t[i+j+3],-t[i+j]*t[i+j+3]*t[i+j+3]},
		{-1,t[i+j+4]+2*t[i+j+1],-2*t[i+j+1]*t[i+j+4]-t[i+j+1]*t[i+j+1],t[i+j+1]*t[i+j+1]*t[i+j+4]},
		{1,-t[i+j+4]-t[i+j+3]-t[i+j+1],(t[i+j+3]+t[i+j+1])*t[i+j+4]+t[i+j+1]*t[i+j+3],-t[i+j+1]*t[i+j+3]*t[i+j+4]},
		{1,-2*t[i+j+4]-t[i+j+2],t[i+j+4]*t[i+j+4]+2*t[i+j+2]*t[i+j+4],-t[i+j+2]*t[i+j+4]*t[i+j+4]},
		{-1,3*t[i+j+4],-3*t[i+j+4]*t[i+j+4],t[i+j+4]*t[i+j+4]*t[i+j+4]}};

		for(int p=0;p<8;p++){
			if(bunbo[p] != 0){
				for(int q=0;q<4;q++){
					coef_sub[p][q] /= bunbo[p];
				}
			}
			else{
				for(int q=0;q<4;q++){
					coef_sub[p][q] = 0;
				}
			}
		}

		InitVector(coef[j],4);
		for(int k=0;k<4;k++){
			if(j==0)
				coef[0][k] += coef_sub[7][k];
			else if(j==1)
				coef[1][k] += coef_sub[3][k] + coef_sub[5][k] + coef_sub[6][k];
			else if(j==2)
				coef[2][k] += coef_sub[1][k] + coef_sub[2][k] + coef_sub[4][k];
			else
				coef[3][k] += coef_sub[0][k];
		}
	}

	return KOD_TRUE;
}


// 2BXvCȐ̊eW߂
//  M:K  K:Rg[|Cg̐  i:ڒ̃Rg[|Cg *t:mbgxNg  *coef:ZoWi[
// coef[j][0]t^2 + coef[j][1]t + coef[j][2]
int NURBS_Func::GetBSplCoef2(int M,int K,int i,double *t,double **coef)
{
	double t20,t10,t21,t31,t32;
	double bunbo[4];

	for(int j=0;j<3;j++){

		t20 = t[i+j+2] - t[i+j];
		t10 = t[i+j+1] - t[i+j];
		t21 = t[i+j+2] - t[i+j+1];
		t31 = t[i+j+3] - t[i+j+1];
		t32 = t[i+j+3] - t[i+j+2];

		bunbo[0] = t20*t10;
		bunbo[1] = t20*t21;
		bunbo[2] = t31*t21;
		bunbo[3] = t31*t32;

		double coef_sub[4][3] = {{1,-2*t[i+j],t[i+j]*t[i+j]},{-1,t[i+j]+t[i+j+2],-t[i+j]*t[i+j+2]},
		{-1,t[i+j+1]+t[i+j+3],-t[i+j+1]*t[i+j+3]},{1,-2*t[i+j+3],t[i+j+3]*t[i+j+3]}};

		for(int p=0;p<4;p++){
			if(bunbo[p] != 0){
				for(int q=0;q<3;q++){
					coef_sub[p][q] /= bunbo[p];
				}
			}
			else{
				for(int q=0;q<3;q++){
					coef_sub[p][q] = 0;
				}
			}
		}

		InitVector(coef[j],3);
		for(int k=0;k<3;k++){
			if(j==0)
				coef[0][k] += coef_sub[3][k];
			else if(j==1)
				coef[1][k] += coef_sub[1][k] + coef_sub[2][k];
			else
				coef[2][k] += coef_sub[0][k];
		}
	}

	return KOD_TRUE;
}

// 1BXvCȐ̊eW߂
//  M:K  K:Rg[|Cg̐  i:ڒ̃Rg[|Cg *t:mbgxNg  *coef:ZoWi[
// coef[j][0]t + coef[j][1]
int NURBS_Func::GetBSplCoef1(int M,int K,int i,double *t,double **coef)
{
	double bunbo[2];

	for(int j=0;j<2;j++){

		bunbo[0] = t[i+j+1] - t[i+j];
		bunbo[1] = t[i+j+2] - t[i+j+1];

		double coef_sub[2][2] = {{1,-t[i+j]},{-1,t[i+j+2]}};

		for(int p=0;p<2;p++){
			if(bunbo[p] != 0){
				for(int q=0;q<2;q++){
					coef_sub[p][q] /= bunbo[p];
				}
			}
			else{
				for(int q=0;q<2;q++){
					coef_sub[p][q] = 0;
				}
			}
		}

		InitVector(coef[j],2);
		for(int k=0;k<2;k++){
			if(j==0)
				coef[0][k] += coef_sub[1][k];
			else
				coef[1][k] += coef_sub[0][k];
		}
	}

	return KOD_TRUE;
}


// NURBSȖʂ̃Vtg
//   *nurbs:ύXNURBSȖ  shift:Vtg
void NURBS_Func::ShiftNurbsS(NURBSS *nurbs,Coord shift)
{
	for(int i=0;i<nurbs->K[0];i++){
		for(int j=0;j<nurbs->K[1];j++){
			nurbs->cp[i][j] = AddCoord(nurbs->cp[i][j],shift);
		}
	}
}

// NURBSȐ̃Vtg
//   *nurbs:ύXNURBSȐ  shift:Vtg
void NURBS_Func::ShiftNurbsC(NURBSC *nurbs,Coord shift)
{
	for(int i=0;i<nurbs->K;i++){
		nurbs->cp[i] = AddCoord(nurbs->cp[i],shift);
	}
}

// NURBSȖʂDxNgdeg()]
// @*nurbs:ύXNURBSȖʁ@axis:]̒PʃxNg@deg:px(degree)
void NURBS_Func::RotNurbsS(NURBSS *nurbs,Coord axis,double deg)
{
	double rad;			// WAi[p
	QUATERNION QFunc;	// NH[^jI֘Å֐W߂NX̃IuWFNg𐶐
	Quat StartQ;		// ]O̍Wi[NH[^jI
	Quat RotQ;			// ]NH[^jI
	Quat ConjuQ;		// NH[^jI
	Quat TargetQ;		// ]̍Wi[NH[^jI
	
	for(int i=0;i<nurbs->K[0];i++){			// ũRg[|Cg[v
		for(int j=0;j<nurbs->K[1];j++){		// ṽRg[|Cg[v
			StartQ = QFunc.QInit(1,nurbs->cp[i][j].x,nurbs->cp[i][j].y,nurbs->cp[i][j].z);		// NURBSȖʂ\cp̍Wo^
			rad = DegToRad(deg);										// degreeradianɕϊ
			RotQ = QFunc.QGenRot(rad,axis.x,axis.y,axis.z);				// ]NH[^jIɉ]ʂo^(̐ΔCӂɉ]ł)
			ConjuQ = QFunc.QConjugation(RotQ);							// RotQ̋NH[^jIo^
			TargetQ = QFunc.QMult(QFunc.QMult(RotQ,StartQ),ConjuQ);		// ]
			nurbs->cp[i][j] = SetCoord(TargetQ.x,TargetQ.y,TargetQ.z);	// ]̍Wo^
		}
	}
}

// NURBSȖʂDxNgdeg()]
// @*nurbs:ύXNURBSȐ@axis:]̒PʃxNg@deg:px(degree)
void NURBS_Func::RotNurbsC(NURBSC *nurbs,Coord axis,double deg)
{
	double rad;			// WAi[p
	QUATERNION QFunc;	// NH[^jI֘Å֐W߂NX̃IuWFNg𐶐
	Quat StartQ;		// ]O̍Wi[NH[^jI
	Quat RotQ;			// ]NH[^jI
	Quat ConjuQ;		// NH[^jI
	Quat TargetQ;		// ]̍Wi[NH[^jI
	
	for(int i=0;i<nurbs->K;i++){		// Rg[|Cg[v
		StartQ = QFunc.QInit(1,nurbs->cp[i].x,nurbs->cp[i].y,nurbs->cp[i].z);		// NURBSȖʂ\cp̍Wo^
		rad = DegToRad(deg);									// degreeradianɕϊ
		RotQ = QFunc.QGenRot(rad,axis.x,axis.y,axis.z);			// ]NH[^jIɉ]ʂo^(̐ΔCӂɉ]ł)
		ConjuQ = QFunc.QConjugation(RotQ);						// RotQ̋NH[^jIo^
		TargetQ = QFunc.QMult(QFunc.QMult(RotQ,StartQ),ConjuQ);	// ]
		nurbs->cp[i] = SetCoord(TargetQ.x,TargetQ.y,TargetQ.z);	// ]̍Wo^
	}
}

// NURBSȖʂ̔{ύX
//   *nurbs:ύXNURBSȖ  ratio:{
void NURBS_Func::ChRatioNurbsS(NURBSS *nurbs,Coord ratio)
{
	for(int i=0;i<nurbs->K[0];i++){
		for(int j=0;j<nurbs->K[1];j++){
			nurbs->cp[i][j] = MulCoord(nurbs->cp[i][j],ratio);
		}
	}
}

// NURBSȐ̔{ύX
//   *nurbs:ύXNURBSȐ  ratio:{
void NURBS_Func::ChRatioNurbsC(NURBSC *nurbs,Coord ratio)
{
	for(int i=0;i<nurbs->K;i++){
		nurbs->cp[i] = MulCoord(nurbs->cp[i],ratio);
	}
}

// NURBSȖʊԂ̃Rg[|Cg̑
//   *nurbs:  Nurbs:
int NURBS_Func::SetCPNurbsS(NURBSS *nurbs,NURBSS Nurbs)
{
	if(nurbs->K[0] != Nurbs.K[0] || nurbs->K[1] != Nurbs.K[1]){
        GuiIF.SetMessage("NURBS KOD_ERROR:Control point count is different");
		return KOD_ERR;
	}

	for(int i=0;i<Nurbs.K[0];i++){
		for(int j=0;j<Nurbs.K[1];j++){
			nurbs->cp[i][j] = SetCoord(Nurbs.cp[i][j]);
		}
	}

	return KOD_TRUE;
}

// ^ꂽ_ԂnKNURBSȐ𐶐
// [^Ȃo[W
//    *Nurbs:NURBSȐ̃AhX   *P:_   PNum:_̐   M:K
int NURBS_Func::GenInterpolatedNurbsC1(NURBSC *Nurbs,Coord *P,int PNum,int M)
{
	int retflag = KOD_TRUE;

	if(PNum <= 1){			// ^ꂽ_1̏ꍇ́ANURBSȐ𐶐łȂ
        GuiIF.SetMessage("NURBS KOD_ERROR:Few Point. You should set over 2 points at least");
		return KOD_ERR;
	}
	if(PNum == 2 || PNum == 3)	M = PNum;	// ^ꂽ_23̏ꍇ́AKI23ɂ

	int K = PNum;			// Rg[|Cg̐
	int N = M+K;			// mbgxNg̐
	int prop[4] = {0,0,1,0};// p[^
	double V[2] = {0,1};	// mbgxNg̊Jnl,Il

	Vector T_ = NewVector(K);	// ʉߓ_̋Ȑp[^
	Vector T = NewVector(N);	// mbgxNg
	Matrix B = NewMatrix(K,K);	// BXvC֐s
	Matrix B_ = NewMatrix(K,K);	// BXvC֐s̋tsi[p
	Vector W = NewVector(K);	// d
	Coord *Q = NewCoord1(K);	// Rg[|Cg

	// ʉߓ_̋Ȑp[^𓾂
	GetCurveKnotParam2(P,PNum,T_);

	// mbgxNg𓾂
	GetInterpolatedKnot(T_,N,K,M,T);

	// BXvC֐s𐶐
	for(int i=0;i<K;i++){
		for(int j=0;j<K;j++){
			B[i][j] = CalcBSbasis(T_[i],T,N,j,M);
		}
	}

	// BXvC֐s̋ts߂
	double det = Gauss(K,B,P,Q);
	if(det == 0){
        GuiIF.SetMessage("NURBS ERROR:Determinant is 0");
		retflag = KOD_ERR;
		goto EXIT;
	}

	// Rg[|CgƏd݂𓾂
	for(int i=0;i<K;i++){
		//MulMxVec(B_,K,K,P,Q);
		W[i] = 1.0;
	}

	// NURBSȐ𐶐
	if(M == 2)
		GenNurbsC(Nurbs,K,M,N,T,W,P,V,prop,0);
	else
		GenNurbsC(Nurbs,K,M,N,T,W,Q,V,prop,0);

EXIT:
	FreeVector(T_);
	FreeVector(T);
	FreeVector(W);
	FreeMatrix(B,K);
	FreeMatrix(B_,K);
	FreeCoord1(Q);

	return retflag;
}

// ^ꂽ_ԂnKNURBSȐ𐶐
// [:n_C2ňv
//    *Nurbs:NURBSȐ̃AhX   *P_:ʉߓ_   PNum:ʉߓ_̐   M:K
// P_[0]P_[PNum-1]͈vĂ邱
// Ԓl   KOD_TRUE:I
//		  KOD_FALSE:_̎n_ƏI_vĂȂ
//		  KOD_ERR:_̐1
int NURBS_Func::GenInterpolatedNurbsC2(NURBSC *Nurbs,Coord *P_,int PNum,int M)
{
	if(DiffCoord(P_[0],P_[PNum-1]) == KOD_FALSE){
        GuiIF.SetMessage("NURBS KOD_ERROR:Given points P0 and Pn are not unmuched");
		return KOD_FALSE;
	}
	if(PNum <= 1){			// ^ꂽ_1̏ꍇ́ANURBSȐ𐶐łȂ
        GuiIF.SetMessage("NURBS KOD_ERROR:Few Point. You should set over 2 points at least");
		return KOD_ERR;
	}
	if(PNum == 2 || PNum == 3)	M = PNum;	// ^ꂽ_23̏ꍇ́AKI23ɂ

	int K = PNum+M-2;			// Rg[|Cg̐
	int N = M+K;				// mbgxNg̐
	int prop[4] = {0,0,1,0};	// p[^
	double V[2] = {0,1};		// mbgxNg̊Jnl,Il

	Vector T_ = NewVector(PNum);	// ʉߓ_̋Ȑp[^
	Vector T = NewVector(N);		// mbgxNg
	Coord *P = NewCoord1(N);		// ʉߓ_i[
	Coord *Q = NewCoord1(K);		// Rg[|Cg
	Matrix B = NewMatrix(K,K);		// BXvC֐s
	Vector W = NewVector(K);		// d

	// ʉߓ_xNg𐶐
	for(int i=0;i<PNum;i++){
		P[i] = SetCoord(P_[i]);
	}
	P[PNum] = SetCoord(0,0,0);
	P[PNum+1] = SetCoord(0,0,0);

	// ʉߓ_̋Ȑp[^𓾂
	GetCurveKnotParam1(P_,PNum,T_);

	// mbgxNg𓾂
	for(int i=0;i<N;i++){
		if(i < M)	T[i] = 0;
		else if(i >= K)	T[i] = 1;
		else{
			T[i] = T_[i-M+1];
		}
	}

	// BXvC֐s𐶐
	for(int i=0;i<K;i++){
		for(int j=0;j<K;j++){
			B[i][j] = 0;
			if(i<K-2 && (j==i || j==i+1 || j==i+2))
				B[i][j] = CalcBSbasis(T_[i],T,N,j,M);
		}
	}
	B[K-2][0] = CalcDiffBSbasis(T_[0],T,N,0,M);
	B[K-2][1] = CalcDiffBSbasis(T_[0],T,N,1,M);
	B[K-2][K-2] = -CalcDiffBSbasis(T_[PNum-1],T,N,K-2,M);
	B[K-2][K-1] = -CalcDiffBSbasis(T_[PNum-1],T,N,K-1,M);
	B[K-1][0] = CalcDiffBSbasisN(T_[0],T,N,0,M,2);
	B[K-1][1] = CalcDiffBSbasisN(T_[0],T,N,1,M,2);
	B[K-1][2] = CalcDiffBSbasisN(T_[0],T,N,2,M,2);
	B[K-1][K-3] = -CalcDiffBSbasisN(T_[PNum-1],T,N,K-3,M,2);
	B[K-1][K-2] = -CalcDiffBSbasisN(T_[PNum-1],T,N,K-2,M,2);
	B[K-1][K-1] = -CalcDiffBSbasisN(T_[PNum-1],T,N,K-1,M,2);

	// Rg[|Cg𓾂
	Gauss(K,B,P,Q);

	//for(int i=0;i<K;i++)
	//	fprintf(stderr,"%lf,%lf,%lf\n",Q[i].x,Q[i].y,Q[i].z);

	// d݂𓾂
	for(int i=0;i<K;i++){
		W[i] = 1.0;
	}

	// NURBSȐ𐶐
	if(M == 2)
		GenNurbsC(Nurbs,K,M,N,T,W,P,V,prop,0);
	else
		GenNurbsC(Nurbs,K,M,N,T,W,Q,V,prop,0);

	FreeVector(T_);
	FreeVector(T);
	FreeVector(W);
	FreeMatrix(B,K);
	FreeCoord1(Q);
	FreeCoord1(P);
	
	return KOD_TRUE;
}


// ^ꂽ_ߎnKNURBSȐ𐶐
//    *Nurbs:NURBSȐ̃AhX   *P:_   PNum:_̐   M:K
int NURBS_Func::GenApproximationNurbsC(NURBSC *Nurbs,Coord *P,int PNum,int M)
{
	if(PNum <= 1){			// ^ꂽ_1̏ꍇ́ANURBSȐ𐶐łȂ
        GuiIF.SetMessage("NURBS KOD_ERROR:Few Point. You should set over 2 points at least");
		return KOD_ERR;
	}

	int K = SetApproximationCPnum(PNum);		// ^ꂽ_񂩂Rg[|Cg̐߂(Rg[|Cg̐ŋߎȐς)
	int Nnum = M+K;					// mbgxNg̐
	int prop[4] = {0,0,1,0};		// p[^
	double V[2] = {0,1};			// mbgxNg̊Jnl,Il

	Vector T_ = NewVector(PNum);	// ʉߓ_̋Ȑp[^
	Vector T = NewVector(Nnum);		// mbgxNg
	Coord *Q = NewCoord1(K);		// Rg[|Cg
	Vector W = NewVector(K);		// d

	GetCurveKnotParam1(P,PNum,T_);		// ʉߓ_̋Ȑp[^𓾂

	GetApproximatedKnot(T_,PNum,M,K,T);	// mbgxNgݒ肷

	CalcApproximationCP_LSM(P,T_,T,PNum,Nnum,M,K,Q);	// ŏ2@ŋߎRg[|Cg߂

	for(int i=0;i<K;i++){	// d݂1ŌŒ
		W[i] = 1;
	}

	GenNurbsC(Nurbs,K,M,Nnum,T,W,Q,V,prop,0);	// NURBSȐ

	FreeCoord1(Q);
	FreeVector(T);
	FreeVector(T_);
	FreeVector(W);

	return KOD_TRUE;
}

// Rg[|CgNURBSȐ𐶐
// mbgxNg͓Ԋuɐݒ肳
// d݂͑S1Ƃ
//    *Nurbs:NURBSȐ̃AhX   *P:_   PNum:_̐   M:K
int NURBS_Func::GenNurbsCfromCP(NURBSC *Nurbs,Coord *P,int PNum,int M)
{
	if(PNum <= 1){			// ^ꂽ_1̏ꍇ́ANURBSȐ𐶐łȂ
        GuiIF.SetMessage("NURBS KOD_ERROR:Few Point. You should set over 2 points at least");
		return KOD_ERR;
	}

	int Nnum = M+PNum;				// mbgxNg̐
	int prop[4] = {0,0,1,0};		// p[^
	double V[2] = {0,1};			// mbgxNg̊Jnl,Il
	Vector T = NewVector(Nnum);		// mbgxNg
	Vector W = NewVector(PNum);		// d

	GetEqIntervalKont(PNum,M,T);	// mbgxNg𓾂

	for(int i=0;i<PNum;i++){	// d݂1ŌŒ
		W[i] = 1;
	}

	GenNurbsC(Nurbs,PNum,M,Nnum,T,W,P,V,prop,0);	// NURBSȐ

	FreeVector(T);
	FreeVector(W);

	return KOD_TRUE;
}

// ܂𐶐
//    *Nurbs:NURBSȐ̃AhX   *P:Rg[|Cg   PNum:Rg[|Cg̐
int NURBS_Func::GenPolygonalLine(NURBSC *Nurbs,Coord *P,int PNum)
{
	if(PNum <= 1){			// ^ꂽ_1̏ꍇ́ANURBSȐ𐶐łȂ
        GuiIF.SetMessage("NURBS KOD_ERROR:Few Point. You should set over 2 points at least");
		return KOD_ERR;
	}

	int M=2;					// K2
	int K=PNum;					// Rg[|Cg̐
	int N=PNum+2;				// mbgxNg̐
	int prop[4] = {0,0,1,0};	// p[^
	double V[2] = {0,1};		// mbgxNg̊Jnl,Il
	Vector T = NewVector(N);	// mbgxNg
	Vector W = NewVector(K);	// d

	// mbgxNg߂
	T[0] = T[1] = 0.0;
	T[K] = T[K+1] = 1.0;
	double d_sum=0;
	for(int i=1;i<K;i++)
		d_sum += CalcDistance(P[i],P[i-1]);
	for(int i=2;i<K;i++){
		double d = CalcDistance(P[i-1],P[i-2]);
		T[i] = T[i-1] + d/d_sum;
	}

	// EFCg
	for(int i=0;i<K;i++){
		W[i] = 1.0;
	}

	// NURBSȐ𐶐
	GenNurbsC(Nurbs,K,M,N,T,W,P,V,prop,0);

	FreeVector(T);
	FreeVector(W);

	return KOD_TRUE;
}

// ^ꂽ_ԂnKNURBSȖʂ𐶐
// [^Ȃo[W
//    *Nurbs:NURBSȖʂ̃AhX   **P:^ꂽ_   PNum_u,PNum_v:_̐@ Mu,Mv:K
int NURBS_Func::GenInterpolatedNurbsS1(NURBSS *Nurbs,Coord **P,int PNum_u,int PNum_v,int Mu,int Mv)
{
	if(PNum_u <= 1 || PNum_v <= 1){			// ^ꂽ_e1̏ꍇ́ANURBSȖʂ𐶐łȂ
        GuiIF.SetMessage("NURBS ERROR:Few Point. You should set over 2 points at least");
		return KOD_ERR;
	}
	if(PNum_u == 2 || PNum_u == 3)	Mu = PNum_u;	// uɗ^ꂽ_23̏ꍇ́AůKI23ɂ
	if(PNum_v == 2 || PNum_v == 3)	Mv = PNum_v;	// vɗ^ꂽ_23̏ꍇ́Av̊KI23ɂ

	int K[2] = {PNum_u,PNum_v};		// Rg[|Cg̐
	int N[2] = {Mu+PNum_u,Mv+PNum_v};	// mbgxNg̐
	int prop[5] = {0,0,1,0,0};		// p[^
	double U[2] = {0,1};			// umbgxNg̊JnlAIl
	double V[2] = {0,1};			// vmbgxNg̊JnlAIl

	Vector S_ = NewVector(K[0]);		// u̒ʉߓ_̋Ȑp[^
	Vector S = NewVector(N[0]);			// ũmbgxNg
	Vector T_ = NewVector(K[1]);		// v̒ʉߓ_̋Ȑp[^
	Vector T = NewVector(N[1]);			// ṽmbgxNg
	Matrix Bu = NewMatrix(K[0],K[0]);	// uBXvC֐s
	Matrix Bu_ = NewMatrix(K[0],K[0]);	// uBXvC֐s̋tsi[p
	Matrix Bv = NewMatrix(K[1],K[1]);	// vBXvC֐s
	Matrix Bv_ = NewMatrix(K[1],K[1]);	// vBXvC֐s̋tsi[p
	Matrix W = NewMatrix(K[0],K[1]);	// d
	Coord **PT = NewCoord2(K[1],K[0]);	// ]u_P
	Coord **R = NewCoord2(K[0],K[1]);	// AC\pȐ̃Rg[|Cg
	Coord **RT = NewCoord2(K[1],K[0]);	// ]uRg[|CgR
	Coord **Q = NewCoord2(K[0],K[1]);	// NURBSȖʂ̃Rg[|Cg


	GetSurfaceKnotParam(S_,T_,P,PNum_u,PNum_v);		// ԋȖʗpu,vp[^𓾂

	GetInterpolatedKnot(S_,N[0],K[0],Mu,S);			// mbgxNgS𓾂

	GetInterpolatedKnot(T_,N[1],K[1],Mv,T);			// mbgxNgT𓾂

	// uBXvC֐s𐶐
	for(int i=0;i<K[0];i++){
		for(int j=0;j<K[0];j++){
			Bu[i][j] = CalcBSbasis(S_[i],S,N[0],j,Mu);
		}
	}

	// vBXvC֐s𐶐
	for(int i=0;i<K[1];i++){
		for(int j=0;j<K[1];j++){
			Bv[i][j] = CalcBSbasis(T_[i],T,N[1],j,Mv);
		}
	}

	// uBXvC֐s̋ts߂
	MatInv(K[0],Bu,Bu_);

	// vBXvC֐s̋ts߂
	MatInv(K[1],Bv,Bv_);

	// AC\pȐ̃Rg[|Cg𓾂
	TranMx(P,K[0],K[1],PT);
	for(int i=0;i<K[1];i++){
		MulMxVec(Bu_,K[0],K[0],PT[i],RT[i]);
	}

	// NURBSȖʂ̃Rg[|Cg𓾂
	TranMx(RT,K[1],K[0],R);
	for(int i=0;i<K[0];i++){
 		MulMxVec(Bv_,K[1],K[1],R[i],Q[i]);
 	}

	// d݂𓾂
	for(int i=0;i<K[0];i++){
		for(int j=0;j<K[1];j++){
			W[i][j] = 1;
		}
	}

	// NURBSȖʂ𐶐
	if(Mu == 2 && Mv == 2)
		GenNurbsS(Nurbs,Mu,Mv,K[0],K[1],S,T,W,P,U[0],U[1],V[0],V[1]);
	else
		GenNurbsS(Nurbs,Mu,Mv,K[0],K[1],S,T,W,Q,U[0],U[1],V[0],V[1]);

	FreeVector(S_);
	FreeVector(S);
	FreeVector(T_);
	FreeVector(T);
	FreeMatrix(Bu,K[0]);
	FreeMatrix(Bu_,K[0]);
	FreeMatrix(Bv,K[1]);
	FreeMatrix(Bv_,K[1]);
	FreeMatrix(W,K[0]);
	FreeCoord2(PT,K[1]);
	FreeCoord2(R,K[0]);
	FreeCoord2(RT,K[1]);
	FreeCoord2(Q,K[0]);

	return KOD_TRUE;
}

// ^ꂽ_ߎnKNURBSȖʂ𐶐
//    *Nurbs:NURBSȖʂ̃AhX   **P:^ꂽ_   PNum_u,PNum_v:_̐@ Mu,Mv:K
int NURBS_Func::GenApproximationNurbsS(NURBSS *Nurbs,Coord **P,int PNum_u,int PNum_v,int Mu,int Mv)
{
	if(PNum_u <= 1 || PNum_v <= 1){			// ^ꂽ_e1̏ꍇ́ANURBSȖʂ𐶐łȂ
        GuiIF.SetMessage("NURBS ERROR:Few Point. You should set over 2 points at least");
		return KOD_ERR;
	}
	if(PNum_u == 2 || PNum_u == 3)	Mu = PNum_u;	// uɗ^ꂽ_23̏ꍇ́AůKI23ɂ
	if(PNum_v == 2 || PNum_v == 3)	Mv = PNum_v;	// vɗ^ꂽ_23̏ꍇ́Av̊KI23ɂ

	// ^ꂽ_񂩂Rg[|Cg̐߂
	int K[2];
	K[0] = SetApproximationCPnum(PNum_u);
	K[1] = SetApproximationCPnum(PNum_v);

	int N[2] = {Mu+K[0],Mv+K[1]};	// mbgxNg̐
	int prop[5] = {0,0,1,0,0};		// p[^
	double U[2] = {0,1};			// umbgxNg̊JnlAIl
	double V[2] = {0,1};			// vmbgxNg̊JnlAIl

	Vector S_ = NewVector(PNum_u);		// u̒ʉߓ_̋Ȑp[^
	Vector S = NewVector(N[0]);			// ũmbgxNg
	Vector T_ = NewVector(PNum_v);		// v̒ʉߓ_̋Ȑp[^
	Vector T = NewVector(N[1]);			// ṽmbgxNg
	Coord **Q1 = NewCoord2(PNum_u,K[1]);	// NURBSȖʂ̃Rg[|Cg
	Coord **Q2 = NewCoord2(K[1],PNum_u);	
	Coord **Q3 = NewCoord2(K[1],K[0]);
	Coord **Q4 = NewCoord2(K[0],K[1]);
	Coord **P_ = NewCoord2(K[1],K[0]);
	Matrix W = NewMatrix(K[0],K[1]);	// d

	GetSurfaceKnotParam(S_,T_,P,PNum_u,PNum_v);		// ԋȖʗpu,vp[^𓾂

	GetApproximatedKnot(S_,PNum_u,Mu,K[0],S);		// mbgxNgSݒ肷
	GetApproximatedKnot(T_,PNum_v,Mv,K[1],T);		// mbgxNgTݒ肷

	// v̓_񂩂ߎNURBSȐPNum_u쐬
	for(int i=0;i<PNum_u;i++){
		CalcApproximationCP_LSM(P[i],T_,T,PNum_v,N[1],Mv,K[1],Q1[i]);	// ŏ2@ŋߎRg[|Cg߂
	}
	TranMx(Q1,PNum_u,K[1],Q2);					// Q̓]u

	for(int i=0;i<K[1];i++){
		CalcApproximationCP_LSM(Q2[i],S_,S,PNum_u,N[0],Mu,K[0],Q3[i]);	// ŏ2@ŋߎRg[|Cg߂
	}
	TranMx(Q3,K[1],K[0],Q4);					// Q̓]u

	// d݂𓾂
	for(int i=0;i<K[0];i++){
		for(int j=0;j<K[1];j++){
			W[i][j] = 1;
		}
	}

	// NURBSȖʂ𐶐
	if(Mu == 2 && Mv == 2)
		GenNurbsS(Nurbs,Mu,Mv,K[0],K[1],S,T,W,P,U[0],U[1],V[0],V[1]);
	else
		GenNurbsS(Nurbs,Mu,Mv,K[0],K[1],S,T,W,Q4,U[0],U[1],V[0],V[1]);

	FreeVector(S);
	FreeVector(T);
	FreeVector(S_);
	FreeVector(T_);
	FreeCoord2(Q1,PNum_u);
	FreeCoord2(Q2,K[1]);
	FreeCoord2(Q3,K[1]);
	FreeCoord2(Q4,K[0]);
	FreeCoord2(P_,K[1]);
	FreeMatrix(W,K[0]);

	return KOD_TRUE;
}

// ^ꂽRg[|CgnKNURBSȖʂ𐶐
// mbgxNg͓Ԋuɐݒ肳
// d݂͑S1Ƃ
//    *Nurbs:NURBSȖʂ̃AhX   **P:^ꂽRg[|Cg   PNum_u,PNum_v:_̐@ Mu,Mv:K
int NURBS_Func::GenNurbsSfromCP(NURBSS *Nurbs,Coord **P,int PNum_u,int PNum_v,int Mu,int Mv)
{
	if(PNum_u <= 1 || PNum_v <= 1){			// ^ꂽ_e1̏ꍇ́ANURBSȖʂ𐶐łȂ
        GuiIF.SetMessage("NURBS ERROR:Few Point. You should set over 2 points at least");
		return KOD_ERR;
	}
	if(PNum_u == 2 || PNum_u == 3)	Mu = PNum_u;	// uɗ^ꂽ_23̏ꍇ́AůKI23ɂ
	if(PNum_v == 2 || PNum_v == 3)	Mv = PNum_v;	// vɗ^ꂽ_23̏ꍇ́Av̊KI23ɂ

	int K[2] = {PNum_u,PNum_v};			// Rg[|Cg̐		
	int N[2] = {Mu+K[0],Mv+K[1]};		// mbgxNg̐
	int prop[5] = {0,0,1,0,0};			// p[^
	double U[2] = {0,1};				// umbgxNg̊JnlAIl
	double V[2] = {0,1};				// vmbgxNg̊JnlAIl
	Vector S = NewVector(N[0]);			// ũmbgxNg
	Vector T = NewVector(N[1]);			// ṽmbgxNg
	Matrix W = NewMatrix(K[0],K[1]);	// d

	GetEqIntervalKont(K[0],Mu,S);		// umbgxNg𓾂
	GetEqIntervalKont(K[1],Mv,T);		// vmbgxNg𓾂

	// d݂𓾂
	for(int i=0;i<K[0];i++){
		for(int j=0;j<K[1];j++){
			W[i][j] = 1;
		}
	}

	GenNurbsS(Nurbs,Mu,Mv,K[0],K[1],S,T,W,P,U[0],U[1],V[0],V[1]);		// NURBSȖʂ𐶐

	FreeVector(S);
	FreeVector(T);
	FreeMatrix(W,K[0]);

	return KOD_TRUE;
}

// ܂ʂ𐶐
//    *Nurbs:NURBSȖʂ̃AhX   **P:Rg[|Cg   PNum_u,PNum_v:Rg[|Cg̐
int NURBS_Func::GenPolygonalSurface(NURBSS *Nurbs,Coord **P,int PNum_u,int PNum_v)
{
	int Mu=2;						// K2
	int Mv=2;
	int K[2] = {PNum_u,PNum_v};		// Rg[|Cg̐
	int N[2] = {PNum_u+2,PNum_v+2};	// mbgxNg̐
	int prop[4] = {0,0,1,0};		// p[^
	double U[2] = {0,1};			// umbgxNg̊JnlAIl
	double V[2] = {0,1};			// vmbgxNg̊JnlAIl
	Vector S = NewVector(N[0]);			// ũmbgxNg
	Vector T = NewVector(N[1]);			// ṽmbgxNg
	Matrix W = NewMatrix(K[0],K[1]);	// d

	// umbgxNg߂
	Vector du_sum = NewVector(K[1]);
	InitVector(du_sum,K[1]);
	for(int i=0;i<K[1];i++){
		for(int j=1;j<K[0];j++){
			du_sum[i] += CalcEuclid(SubCoord(P[j][i],P[j-1][i]));
		}
	}
	S[0] = S[1] = 0.0;
	for(int i=2;i<K[0];i++){
		S[i] = 0;
		for(int j=0;j<K[1];j++){
			double du = CalcEuclid(SubCoord(P[i-1][j],P[i-2][j]));
			S[i] += S[i-1] + du/du_sum[j];
		}
		S[i] /= K[1];
	}
	S[K[0]] = S[K[0]+1] = 1.0;
	
	// vmbgxNg߂
	Vector dv_sum = NewVector(K[0]);
	InitVector(dv_sum,K[0]);
	for(int i=0;i<K[0];i++){
		for(int j=1;j<K[1];j++){
			dv_sum[i] += CalcEuclid(SubCoord(P[i][j],P[i][j-1]));
		}
	}
	T[0] = T[1] = 0.0;
	for(int i=2;i<K[1];i++){
		T[i] = 0;
		for(int j=0;j<K[0];j++){
			double dv = CalcEuclid(SubCoord(P[j][i-1],P[j][i-2]));
			T[i] += T[i-1] + dv/dv_sum[j];
		}
		T[i] /= K[0];
	}
	T[K[1]] = T[K[1]+1] = 1.0;

	// EFCg
	for(int i=0;i<K[0];i++){
		for(int j=0;j<K[1];j++){
			W[i][j] = 1.0;
		}
	}

	// NURBSȖʂ𐶐
	GenNurbsS(Nurbs,Mu,Mv,K[0],K[1],S,T,W,P,U[0],U[1],V[0],V[1]);

	FreeVector(S);
	FreeVector(T);
	FreeMatrix(W,K[0]);
	FreeVector(du_sum);
	FreeVector(dv_sum);

	return KOD_TRUE;
}


// 2NURBSȖʂA(UɒȂ)(S1_U1S2_U0A)
//     *S1:1,   *S2:2,    *S_:A̖ʂi[
// Ԓl    FKOD_TRUE,  sFKOD_FALSE
int NURBS_Func::ConnectNurbsSU(NURBSS *S1,NURBSS *S2,NURBSS *S_)			
{
	// AGbWVRg[|Cg̐Sē
	if(S1->K[1] != S2->K[1]){
		fprintf(stderr,"ERROR: Number of control point on V direction is not equal.");
		return KOD_ERR;
	}
	// AGbWVRg[|CgSē
	for(int i=0;i<S1->K[1];i++){
		if(DiffCoord(S1->cp[S1->K[0]-1][i],S2->cp[0][i]) == KOD_FALSE){
			fprintf(stderr,"ERROR: Knot value on V direction is not equal.");
			return KOD_ERR;
		}
	}
	// Ȗʂ̊KU,Vɓ
	if(S1->M[0] != S2->M[0] || S1->M[1] != S2->M[1]){
		fprintf(stderr,"ERROR: Rank is not equal.");
		return KOD_ERR;
	}

	int K[2],N[2];

	K[0] = S1->K[0] + S2->K[0] - 1;				// S_URg[|Cg̐
	K[1] = S1->K[1];							// S_VRg[|Cg̐
	N[0] = S1->N[0] + S2->N[0] - S2->M[0] - 1;	// S_UmbgxNg̐
	N[1] = S1->N[1];							// S_VmbgxNg̐

	New_NurbsS(S_,K,N);							// S_̃[m

	SetKnotVecSU_ConnectS(S1,S2,S_);			// S_umbg`w

	SetCPSU_ConnectS(S1,S2,S_);					// S_uRg[|CgƃEFCgw

	S_->M[0] = S1->M[0];						// S_̊Kw
	S_->M[1] = S1->M[1];

	return KOD_TRUE;
}

// 2NURBSȖʂA(VɒȂ)(S1_V1S2_V0A)
//     *S1:1,   *S2:2,    *S_:A̖ʂi[
// Ԓl    FKOD_TRUE,  sFKOD_FALSE
int NURBS_Func::ConnectNurbsSV(NURBSS *S1,NURBSS *S2,NURBSS *S_)			
{
	// AGbWURg[|Cg̐Sē
	if(S1->K[0] != S2->K[0]){
		fprintf(stderr,"ERROR: Number of control point on U direction is not equal.");
		return KOD_ERR;
	}
	// AGbWURg[|CgSē
	for(int i=0;i<S1->K[0];i++){
		if(DiffCoord(S1->cp[i][S1->K[0]-1],S2->cp[i][0]) == KOD_FALSE){
			fprintf(stderr,"ERROR: Knot value on U direction is not equal.");
			return KOD_ERR;
		}
	}
	// Ȗʂ̊KU,Vɓ
	if(S1->M[0] != S2->M[0] || S1->M[1] != S2->M[1]){
		fprintf(stderr,"ERROR: Rank is not equal.");
		return KOD_ERR;
	}

	int K[2],N[2];

	K[0] = S1->K[0];							// S_URg[|Cg̐
	K[1] = S1->K[1] + S2->K[1] - 1;				// S_VRg[|Cg̐
	N[0] = S1->N[0];							// S_UmbgxNg̐
	N[1] = S1->N[1] + S2->N[1] - S2->M[1] - 1;	// S_VmbgxNg̐

	New_NurbsS(S_,K,N);							// S_̃[m

	SetKnotVecSV_ConnectS(S1,S2,S_);			// S_vmbg`w

	SetCPSV_ConnectS(S1,S2,S_);					// S_vRg[|CgƃEFCgw

	S_->M[0] = S1->M[0];						// S_̊Kw
	S_->M[1] = S1->M[1];

	return KOD_TRUE;
}

// S_uRg[|CgƃEFCgw
void NURBS_Func::SetCPSU_ConnectS(NURBSS *S1,NURBSS *S2,NURBSS *S_)
{
	S_->K[0] = S1->K[0] + S2->K[0] - 1;
	S_->K[1] = S1->K[1];

	for(int i=0;i<S1->K[0];i++){
		for(int j=0;j<S_->K[1];j++){
			S_->cp[i][j] = SetCoord(S1->cp[i][j]);
			S_->W[i][j] = S1->W[i][j];
		}
	}
	for(int i=1;i<S2->K[0];i++){
		for(int j=0;j<S_->K[1];j++){
			S_->cp[S1->K[0]+i-1][j] = SetCoord(S2->cp[i][j]);
			S_->W[S1->K[0]+i-1][j] = S2->W[i][j];
		}
	}
}

// S_umbg`w
void NURBS_Func::SetKnotVecSU_ConnectS(NURBSS *S1,NURBSS *S2,NURBSS *S_)
{
	// V
	S_->N[1] = S1->N[1];				// S_VmbgxNg̐
	CopyVector(S1->T,S1->N[1],S_->T);	// S_VmbgxNg(VS1̂̂܂ܗp)
	S_->V[0] = S1->V[0];				// S_VmbgxNg͈̔
	S_->V[1] = S1->V[1];

	// U
	// R[h𒲂ׂ
	double us=0,ue=NORM_KNOT_VAL,uc=0;		// UJnCICAmbgxNg
	double l1=0,l2=0;						// eȖʂUmbgxNg̃R[h
	for(int i=0;i<S1->N[0]-1;i++)
		l1 += CalcDistance(CalcNurbsSCoord(S1,S1->S[i+1],S1->T[0]),CalcNurbsSCoord(S1,S1->S[i],S1->T[0]));	// S1̃R[h
	for(int i=0;i<S2->N[0]-1;i++)
		l2 += CalcDistance(CalcNurbsSCoord(S2,S2->S[i+1],S2->T[0]),CalcNurbsSCoord(S2,S2->S[i],S2->T[0]));	// S2̃R[h
	uc = l1/(l1+l2);	// _̃mbgxNgl

	// S_̃mbgxNg͈͂𓾂
	Vector U1 = NewVector(S1->N[0]);	
	Vector U2 = NewVector(S2->N[0]);	
	CopyVector(S1->S,S1->N[0],U1);		// S1̃mbgxNgU1ɃRs[
	CopyVector(S2->S,S2->N[0],U2);		// S2̃mbgxNgU2ɃRs[
	ChangeKnotVecRange(U1,S1->N[0],S1->M[0],S1->K[0],us,uc);	// S1(U1)̃mbgxNg͈̔͂ύX
	ChangeKnotVecRange(U2,S2->N[0],S2->M[0],S2->K[0],uc,ue);	// S2(U2)̃mbgxNg͈̔͂ύX
	S_->U[0] = us;						// S_UmbgxNg͈̔
	S_->U[1] = ue;
	S_->N[0] = S1->N[0] + S2->N[0] - S2->M[0] - 1;	// S_̃mbgxNg

	// S_̃mbgxNg𓾂
	for(int i=0;i<S1->K[0];i++)
		S_->S[i] = U1[i];
	for(int i=1;i<S2->N[0];i++)
		S_->S[S1->K[0]+i-1] = U2[i];

	FreeVector(U1);
	FreeVector(U2);
}


// S_vRg[|CgƃEFCgw
void NURBS_Func::SetCPSV_ConnectS(NURBSS *S1,NURBSS *S2,NURBSS *S_)
{
	S_->K[0] = S1->K[0];
	S_->K[1] = S1->K[1] + S2->K[1] - 1;

	for(int i=0;i<S_->K[0];i++){
		for(int j=0;j<S1->K[1];j++){
			S_->cp[i][j] = SetCoord(S1->cp[i][j]);
			S_->W[i][j] = S1->W[i][j];
		}
	}
	for(int i=0;i<S_->K[0];i++){
		for(int j=1;j<S2->K[1];j++){
			S_->cp[i][S1->K[1]+j-1] = SetCoord(S2->cp[i][j]);
			S_->W[i][S1->K[1]+j-1] = S2->W[i][j];
		}
	}
}

// S_vmbg`w
void NURBS_Func::SetKnotVecSV_ConnectS(NURBSS *S1,NURBSS *S2,NURBSS *S_)
{
	// U
	S_->N[0] = S1->N[0];				// S_UmbgxNg̐
	CopyVector(S1->S,S1->N[0],S_->S);	// S_UmbgxNg(US1̂̂܂ܗp)
	S_->U[0] = S1->U[0];				// S_UmbgxNg͈̔
	S_->U[1] = S1->U[1];

	// V
	// R[h𒲂ׂ
	double vs=0,ve=NORM_KNOT_VAL,vc=0;		// UJnCICAmbgxNg
	double l1=0,l2=0;						// eȖʂUmbgxNg̃R[h
	for(int i=0;i<S1->N[1]-1;i++)
		l1 += CalcDistance(CalcNurbsSCoord(S1,S1->S[0],S1->T[i+1]),CalcNurbsSCoord(S1,S1->S[0],S1->T[i]));	// S1̃R[h
	for(int i=0;i<S2->N[1]-1;i++)
		l2 += CalcDistance(CalcNurbsSCoord(S2,S2->S[0],S2->T[i+1]),CalcNurbsSCoord(S2,S2->S[0],S2->T[i]));	// S2̃R[h
	vc = l1/(l1+l2);	// _̃mbgxNgl

	// S_̃mbgxNg͈͂𓾂
	Vector V1 = NewVector(S1->N[1]);	
	Vector V2 = NewVector(S2->N[1]);	
	CopyVector(S1->T,S1->N[1],V1);		// S1̃mbgxNgV1ɃRs[
	CopyVector(S2->T,S2->N[1],V2);		// S2̃mbgxNgV2ɃRs[
	ChangeKnotVecRange(V1,S1->N[1],S1->M[1],S1->K[1],vs,vc);	// S1(V1)̃mbgxNg͈̔͂ύX
	ChangeKnotVecRange(V2,S2->N[1],S2->M[1],S2->K[1],vc,ve);	// S2(V2)̃mbgxNg͈̔͂ύX
	S_->V[0] = vs;						// S_VmbgxNg͈̔
	S_->V[1] = ve;
	S_->N[1] = S1->N[1] + S2->N[1] - S2->M[1] - 1;	// S_̃mbgxNg

	// S_̃mbgxNg𓾂
	for(int i=0;i<S1->K[1];i++)
		S_->T[i] = V1[i];
	for(int i=1;i<S2->N[1];i++)
		S_->T[S1->K[1]+i-1] = V2[i];

	FreeVector(V1);
	FreeVector(V2);
}

// NURBSȖʂƒ̌_Zo
//     *Nurb:NURBSȖS(u,v)ւ̃|C^,  r:N(t)1_,  p:N(t)̕,  DivNum:NURBSȖʂ̕,
//         *ans:_u,v,tp[^i[pz, anssize:ans̔z
//         Divnum傫قǁA_Zo̎肱ڂ͏ȂȂ
//         anssizeDivNum*DivNumȏɂ̂D܂.
// Ԓl    _̐,   KOD_ERR:_̐w肵z񒷂𒴂
int NURBS_Func::CalcuIntersecPtNurbsLine(NURBSS *Nurb,Coord r,Coord p,int Divnum,Coord *ans,int anssize)
{
	Coord d = SetCoord(100,100,100);		// NURBSȐS(u,v)̔ω(du,dv)AN(t)̔ωdti[
	Coord F,Fu,Fv,Ft;						// F(u,v,t) = S(u,v) - N(t)    Fu = dF/du     Fv = dF/dv     Ft = dF/dt
	double u = Nurb->U[0];					// NURBSȖS(u,v)up[^̌ݒl
	double v = Nurb->V[0];					// NURBSȖS(u,v)vp[^̌ݒl
	double t = 0;							// N(t)tp[^
	Matrix A = NewMatrix(3,3);				// Fu,Fv,Ft\3x3s
	Matrix A_ = NewMatrix(3,3);				// A̋tsi[
	int flag = KOD_FALSE;						// tO
	double dv = (Nurb->V[1] - Nurb->V[0])/(double)Divnum;	// Zpvp[^̃C^[ol
	double du = (Nurb->U[1] - Nurb->U[0])/(double)Divnum;	// Zpup[^̃C^[ol
	int loopcount = 0;						// vZ
	int anscount = 0;						// Zoꂽ_̐

	// u loop
	for(int i=0;i<Divnum;i++){
		// v loop
		for(int j=0;j<Divnum;j++){
			u = Nurb->U[0] + (double)i*du;			// Xebvp[^ȕlZbg
			v = Nurb->V[0] + (double)j*dv;		// Xebvp[^v̏lZbg
			t = 0;								// Xebvp[^t̏lZbg
			flag = KOD_FALSE;						// tOOFF
			loopcount = 0;						// [vJEg
			// ̔ωdt(=d.z)APPROX_ZERO܂Ńj[g@ɂvZs
			while(loopcount < LOOPCOUNTMAX){
				F = SubCoord(CalcNurbsSCoord(Nurb,u,v),AddCoord(r,MulCoord(p,t)));	// F(u,v,t) = S(u,v) - N(t) = S(u,v) - (r+tp)
				Fu = CalcDiffuNurbsS(Nurb,u,v);			// Fu = dF/du = dS/du
				Fv = CalcDiffvNurbsS(Nurb,u,v);			// Fv = dF/dv = dS/dv
				Ft = MulCoord(p,-1);					// Ft = dF/dt = -dN/dt = -p
				A[0][0] = Fu.x;				// Fu,Fv,Ft3x3sAɑ
				A[0][1] = Fv.x;				//     |Fu.x Fv.x Ft.x|       |du|       |F.x|
				A[0][2] = Ft.x;				// A = |Fu.y Fv.y Ft.y| , d = |dv| , F = |F.y|
				A[1][0] = Fu.y;				//     |Fu.z Fv.z Ft.z|       |dt|       |F.z|
				A[1][1] = Fv.y;
				A[1][2] = Ft.y;				// AEd = F   --->   d = A_EF
				A[2][0] = Fu.z;
				A[2][1] = Fv.z;
				A[2][2] = Ft.z;	
				//fprintf(stderr,"   %lf,%lf,%lf,%lf,%lf\n",u,v,Fu.x,Fu.y,Fu.z);
				if(MatInv3(A,A_) == KOD_FALSE){		// ts߂
					flag = KOD_ERR;
					break;		
				}
				d = MulCoord(MulMxCoord(A_,F),-1);			// dZo
				
				if(fabs(d.x) <= APPROX_ZERO && fabs(d.y) <= APPROX_ZERO && fabs(d.z) <= APPROX_ZERO){	// ^lɎloop𔲂
					flag = KOD_TRUE;		// tOtrue
					break;
				}

				// ^lɒBĂȂu,v,tXV
				u += d.x;
				v += d.y;
				t += d.z;

				//if(u < Nurb->U[0] || u > Nurb->U[1] || v < Nurb->V[0] || v > Nurb->V[1]){	// u,v̂ǂ炩Uloop𔲂
				//	flag = KOD_FALSE;		// tOfalse
				//	break;
				//}

				loopcount++;
			}// end of while

			// LOOPCOUNTMAX񃋁[vĂĂȂx
			if(loopcount == LOOPCOUNTMAX)
                GuiIF.SetMessage("NURBS_Func ERROR: fail to converge");

			// ĂƂēo^
			if(flag == KOD_TRUE){
				ans[anscount] = SetCoord(u,v,t);
				anscount++;
				if(anscount > anssize){
                    GuiIF.SetMessage("NURBS_Func ERROR: Ans_size overflow");
					return KOD_ERR;
				}
			}
		}// end of j loop
	}// end of i loop

	FreeMatrix(A,3);
	FreeMatrix(A_,3);

	anscount = CheckTheSamePoints(ans,anscount);		// _͏

	return anscount;
}

// NURBSȖSɂԏ1_P̍ŋߖT_Q߂(j[g@)
//
// ̕L(t) = P + tN
// NS̖@xNgƈv邩N=Su~Sv
// FS(u,v) = P + tN(u,v)
// F(u,v,t) = S(u,v) - P - tN(u,v)   ƂāAj[g@p
// Fu = Su - tNu	Fv = Sv - tNv	Ft = -N
// |Fu.x Fv.x Ft.x||du|    |F.x|
// |Fu.y Fv.y Ft.y||dv| = -|F.y|    =>     dFEd = -F     =>     d = -FEdF^-1  
// |Fu.z Fv.z Ft.z||dt|    |F.z|
// 
// DivnumFj[g@lwp̋Ȗʕ
// StepsizeFj[gp[^XṼXebvTCY(1 <= Stepsize < 0)
// QFiS̓_u,v,tp[^Coord\̂Ɋi[j
// Ԓl@@KOD_TRUEF    KOD_FALSE:Ȃ
int NURBS_Func::CalcIntersecPtNurbsPt(NURBSS *S,Coord P,int Divnum,double Stepsize,Coord *Q)
{
	Matrix dF = NewMatrix(3,3);		// Fu,Fv,Ft\3x3s
	Matrix dF_ = NewMatrix(3,3);	// dF̋tsi[
	Coord F,Fu,Fv,Ft;				// F(u,v,t) = S(u,v) - P - tEN(u,v)	j[g@ɂ֐
	Coord N,Nu,Nv;					// N(u,v):S(u,v)̖@xNg
	Coord d = InitCoord();			// j[g@ɂčXVXebvTCYp[^
	int loopcount=0;				// while()[ṽJEg
	double u,v,t;					// u,v,ťݒl
	double dv = (S->V[1] - S->V[0])/(double)Divnum;	// Zpvp[^̃C^[ol
	double du = (S->U[1] - S->U[0])/(double)Divnum;	// Zpup[^̃C^[ol
	int flag = KOD_FALSE;			// while()pʃtO
	Coord *Q_ = NewCoord1(Divnum*Divnum);			// ̈ꎞi[p

	// elɑ΂ăj[g@Kp
	for(int i=0;i<Divnum;i++){
		for(int j=0;j<Divnum;j++){
			u = S->U[0] + (double)i*du;			// Xebvp[^ȕlZbg
			v = S->V[0] + (double)j*dv;			// Xebvp[^v̏lZbg
			t = 0;								// Xebvp[^t̏lZbg
			loopcount = 0;
			flag = KOD_FALSE;

			// vZ
			while(loopcount < LOOPCOUNTMAX/Stepsize){
				N = CalcNormVecOnNurbsS(S,u,v);									// S(u,v)̖@xNgN(u,v)Zo
				Nu = CalcDiffuNormVecOnNurbsS(S,u,v);								// N(u,v)uΔ
				Nv = CalcDiffvNormVecOnNurbsS(S,u,v);								// N(u,v)vΔ
				F = SubCoord(SubCoord(CalcNurbsSCoord(S,u,v),P),MulCoord(N,t));	// j[g@ɂ֐
				Fu = SubCoord(CalcDiffuNurbsS(S,u,v),MulCoord(Nu,t));				// FuΔ
				Fv = SubCoord(CalcDiffvNurbsS(S,u,v),MulCoord(Nv,t));				// FvΔ
				Ft = MulCoord(N,-1);												// FtΔ
				dF[0][0] = Fu.x;		// 3x3}gbNXFu,Fv,Ft
				dF[0][1] = Fv.x;
				dF[0][2] = Ft.x;
				dF[1][0] = Fu.y;
				dF[1][1] = Fv.y;
				dF[1][2] = Ft.y;
				dF[2][0] = Fu.z;
				dF[2][1] = Fv.z;
				dF[2][2] = Ft.z;

				if((flag = MatInv3(dF,dF_)) == KOD_FALSE){		// tsZo det0Ȃ玟̏l
					//fprintf(stderr,"%d:det = 0\n",loopcount);	// debug
					break;
				}

				d = MulCoord(MulMxCoord(dF_,F),-1);		// XebvTCYp[^̍XVlZo

				if(fabs(d.x) <= APPROX_ZERO_L && fabs(d.y) <= APPROX_ZERO_L && fabs(d.z) <= APPROX_ZERO_L){	// ^lɎloop𔲂
					flag = KOD_TRUE;		// tOtrue
					break;
				}

				// ^lɒBĂȂu,v,tXV
				u += d.x*Stepsize;
				v += d.y*Stepsize;
				t += d.z*Stepsize;
				//fprintf(stderr,"%d:%lf,%lf,%lf,%lf,%lf,%lf\n",loopcount,u,v,t,d.x,d.y,d.z);	// debug

				loopcount++;
			}// end of while

			if(flag == KOD_TRUE)	Q_[i*Divnum+j] = SetCoord(u,v,t);		// Ă

			else Q_[i*Divnum+j] = SetCoord(KOD_ERR,KOD_ERR,KOD_ERR);		// ĂȂ

		}// end of loop j
	}// end of loop i

	flag = GetMinDist(S,P,Q_,Divnum*Divnum,Q);		// ɏɂȂȂ悤CSẲ̂Cŏ̂̂^̉ƂđIяo

	FreeMatrix(dF,3);
	FreeMatrix(dF_,3);
	FreeCoord1(Q_);

	return flag;
}

// ŏ𒲂ׂ
int NURBS_Func::GetMinDist(NURBSS *S,Coord P,Coord *Q,int N,Coord *Ans)
{
	double min = 1.0E+12;
	int flag = KOD_FALSE;

	for(int i=0;i<N;i++){
		if(Q[i].z == KOD_ERR)	continue;
		Coord Q_ = CalcNurbsSCoord(S,Q[i].x,Q[i].y);
		double d = CalcDistance(Q_,P);
		if(d < min){
			min = d;
			*Ans = SetCoord(Q[i]);
		}
		flag = KOD_TRUE;
	}

	return flag;
}

// ڒNURBSȖʏ1_(u,v)g~Öɂ̂𔻒肷
// Ԓl  KOD_TRUE:ʏ  KOD_ONEDGE:GbW  KOD_FALSE:ʊO   KOD_ERR:G[
int NURBS_Func::DetermPtOnTRMSurf(TRMS *Trim,double u,double v)
{
	int flag;

	// Og
	if(Trim->n1){
		flag = DetermPtOnTRMSurf_sub(Trim->pTO,u,v);
		if(flag == KOD_ERR)
			return KOD_ERR;
		else if(flag == KOD_FALSE)		// O
			return KOD_FALSE;
		else if(flag == KOD_ONEDGE)		// GbW
			return KOD_ONEDGE;
	}

	// g
	if(Trim->n2){
		for(int i=0;i<Trim->n2;i++){		// ̃g~ÖSĂɑ΂
			flag = DetermPtOnTRMSurf_sub(Trim->pTI[i],u,v);
			if(flag == KOD_ERR)
				return KOD_ERR;
			else if(flag == KOD_TRUE)	// 
				return KOD_FALSE;
		}
	}

	return KOD_TRUE;
}


// ʏ̃^CvȐ̏ꍇ̃g~ÖO
int NURBS_Func::DetermPtOnTRMSurf_sub(CONPS *Conps,double u,double v)
{
	// ʏȐɂȂĂ邱
	if(Conps->BType != COMPOSITE_CURVE){
        GuiIF.SetMessage("NURBS_Func ERROR:TRIM!");
		return KOD_ERR;
	}

	COMPC *CompC=(COMPC *)Conps->pB;	// NURBSȖʂ̃p[^ԏɍ\Ă镡Ȑւ̃|C^o
	Coord *P;							// gEɐ_(p`ߎp̓_)i[
	int ptnum;							// gE_QߎƂ̓_

	// m
	if((P = (Coord *)malloc(sizeof(Coord)*(CompC->N*TRM_BORDERDIVNUM))) == NULL){
		return KOD_ERR;
	}

	// gE_QPŋߎ
	if((ptnum = ApproxTrimBorder(CompC,P)) == KOD_ERR){
			GuiIF.SetMessage("NURBS_Func ERROR:gENURBSȐȊOō\Ă܂.!");
			FreeCoord1(P);
			return KOD_ERR;
	}
	
	int trm_flag = KOD_FALSE;							// g~ÖOptO
	Coord TargetPoint = SetCoord(u,v,0);				// ^[QbgƂȂʏ̓_(u,v)CoordɊi[
	trm_flag = IsPointInPolygon(TargetPoint,P,ptnum);	// O

	return trm_flag;
}

// Ogʓ̓_̂ݎc
//    *Trm:gʂւ̃|C^    *Pt:ʑΏۂ(u,v)Q      N:(u,v)Q̐
// Ԓl   c_̐@(Og݂ȂFKOD_FALSE)
int NURBS_Func::GetPtsOnOuterTRMSurf(TRMS *Trm,Coord *Pt,int N)
{
	// Og݂Ȃꍇ0^[
	if(!Trm->n1)
		return KOD_FALSE;

	COMPC *CompC = (COMPC *)Trm->pTO->pB;	// NURBSȖʂ̃p[^ԏɍ\Ă镡Ȑւ̃|C^o
	Coord *P;								// gEɐ_(p`ߎp̓_)i[
	int ptnum;								// gE_QߎƂ̓_

	// m
	if((P = (Coord *)malloc(sizeof(Coord)*(CompC->N*TRM_BORDERDIVNUM))) == NULL){
		return KOD_ERR;
	}

	// gE_QPŋߎ
	if((ptnum = ApproxTrimBorder(CompC,P)) == KOD_ERR){
			GuiIF.SetMessage("NURBS_Func ERROR:gENURBSȐȊOō\Ă܂.!");
			FreeCoord1(P);
			return KOD_ERR;
	}

	Coord *ans = NewCoord1(N);		// c_̊i[
	int trm_flag = KOD_FALSE;		// g~ÖOptO
	int n=0;

	// Og̓c
	for(int i=0;i<N;i++){
		trm_flag = IsPointInPolygon(Pt[i],P,ptnum);		// O
		if(trm_flag > 0){
			ans[n] = SetCoord(Pt[i]);
			n++;
		}
	}
	CopyCoord(ans,n,Pt);

	FreeCoord1(ans);
	FreeCoord1(P);

	return n;
}

// gʊO̓_̂ݎc
//    *Trm:gʂւ̃|C^    *Pt:ʑΏۂ(u,v)Q      N:(u,v)Q̐
// Ԓl   c_̐@(g݂ȂFKOD_FALSE)
int NURBS_Func::GetPtsOnInnerTRMSurf(TRMS *Trm,Coord *Pt,int N)
{
	// g݂Ȃꍇ0^[
	if(!Trm->n2){
		return KOD_FALSE;
	}

	COMPC *CompC;				// NURBSȖʂ̃p[^ԏɍ\Ă镡Ȑւ̃|C^o
	Coord *P;					// gEɐ_(p`ߎp̓_)i[
	int ptnum;					// gE_QߎƂ̓_
	Coord *ans = NewCoord1(N);	// c_̊i[
	int trm_flag = KOD_FALSE;	// g~ÖOptO
	int N_ = N;

	// g̐[v
	for(int k=0;k<Trm->n2;k++){

		CompC = (COMPC *)Trm->pTI[k]->pB;	

		// m
		if((P = (Coord *)malloc(sizeof(Coord)*(CompC->N*TRM_BORDERDIVNUM))) == NULL){
			return KOD_ERR;
		}

		// gE_QPŋߎ
		if((ptnum = ApproxTrimBorder(CompC,P)) == KOD_ERR){
			GuiIF.SetMessage("NURBS_Func ERROR:gENURBSȐȊOō\Ă܂.!");
			FreeCoord1(P);
			return KOD_ERR;
		}

		// g̊Oc
		int n=0;
		for(int i=0;i<N_;i++){
			trm_flag = IsPointInPolygon(Pt[i],P,ptnum);		// O
			if(trm_flag == KOD_FALSE || trm_flag == KOD_ONEDGE){
				ans[n] = SetCoord(Pt[i]);
				n++;
			}
		}
		CopyCoord(ans,n,Pt);		// ans -> Pt
		N_ = n;

		FreeCoord1(P);
	}

	FreeCoord1(ans);

	return N_;
}

// Ogʓ̓_̂ݎc
int NURBS_Func::GetPtsOnInnerOuterTRMSurf(TRMS *Trm,Coord *Pt,int N)
{
	int n=0;

	n = GetPtsOnInnerTRMSurf(Trm,Pt,N);		// g

	if(n == KOD_FALSE)
		n = N;

	n = GetPtsOnOuterTRMSurf(Trm,Pt,n);		// Og

	return n;
}

// gE_Qŋߎ
int NURBS_Func::ApproxTrimBorder(COMPC *CompC,Coord *P)
{
	double ent_dev=0;				// _p[^
	NURBSC *NurbsC;					// gE(NURBSȐ)̃|C^ƗpɊi[
	int trm_flag = KOD_FALSE;		// g~ÖOptO
	int divnum = TRM_BORDERDIVNUM;	// eE̕
	int ptnum=0;					// Ŝ̓_JEg

	// gEɓ_𐶐igE𑽊p`ߎj
	for(int i=0;i<CompC->N;i++){
		// gENURBSȐō\Ă
		if(CompC->DEType[i] == NURBS_CURVE){
			NurbsC = (NURBSC *)CompC->pDE[i];	// ڒNurbsȐ̃|C^擾
			if(NurbsC->K == 2 && CompC->DegeFlag == KOD_TRUE)	divnum = 2;		// Rg[|Cg2̏ꍇ͒Ȃ̂ŁA_𐶐ȂĂ悭
			else divnum = TRM_BORDERDIVNUM;
			for(int j=0;j<divnum-1;j++){
				ent_dev = NurbsC->T[NurbsC->M-1]+(NurbsC->T[NurbsC->K]-NurbsC->T[NurbsC->M-1])*(double)j/((double)divnum-1);	// _t߂
				P[ptnum] = CalcNurbsCCoord(NurbsC,ent_dev);	// NURBSȖʂ̃p[^ԓNURBSȐ̕_t̍Wl(u,v)𓾂
				ptnum++;
			}
		}
		// ȊO
		else{
			GuiIF.SetMessage("NURBS_Func ERROR:gENURBSȐȊOō\Ă܂.!");
			return KOD_ERR;
		}
	}

	return ptnum;
}

// w肵NURBSȐ̍Wlo͂
// 
// *Nurb:NURBSւ̃|C^  D:  *Pts:o͂Wli[
// Ԓl   _
int NURBS_Func::CalcDeltaPtsOnNurbsC(NURBSC *Nurb,int D,Coord *Pts)
{
	double T = (Nurb->V[1] - Nurb->V[0])/D;	// pgbNԓł̐𓾂

	for(int i=0;i<=D;i++){
		Pts[i] = CalcNurbsCCoord(Nurb, Nurb->V[0] + T*(double)i);
	}

	return D+2;
}

// w肵ԊuNURBSȐ̍Wlo͂
// 
// *Nurb:NURBSւ̃|C^  D:Ԋu  *Pts:o͂Wli[
// Ԓl   _
int NURBS_Func::CalcDeltaPtsOnNurbsC(NURBSC *Nurb,double D,Coord *Pts)
{
	if(D == 0){
		GuiIF.SetMessage("NURBS_Func ERROR: Set Correct Interval Value");
		return KOD_ERR;
	}

	double L = CalcNurbsCLength(Nurb);		// NURBSȐ̐𓾂
	if(D > L){
		GuiIF.SetMessage("NURBS_Func ERROR: Arc Length > Whole Lenth of the Curve");
	}
	//fprintf(stderr,"L = %lf\n",L);		// debug
	//fprintf(stderr,"D = %lf\n",D);		// debug

	int k=1;			// JE^
	double t = (Nurb->V[1] - Nurb->V[0])/(L/D);	// t̏lZbg

	while(t <= Nurb->V[1]){
		t = CalcParamLengthOnNurbsC(Nurb,(double)k*D,t);	// T
		Pts[k-1] = CalcNurbsCCoord(Nurb,t);		// o^
		k++;
		t = k*(Nurb->V[1] - Nurb->V[0])/(L/D);	// t̏lZbg
	}

	return k-1;
}

// NURBSȐɂĈ[̎w苗ɂp[^lԂ
//     *CFNURBSȐC   LFw苗C    Init_tFT̏p[^
double NURBS_Func::CalcParamLengthOnNurbsC(NURBSC *C,double L,double Init_t)
{
	double dt = 1E+12;			// XebvTCYp[^̏l
	double t = Init_t;
	int count = 0;

	while(fabs(dt) > APPROX_ZERO){
		dt = (L - CalcNurbsCLength(C,0,t))/CalcEuclid(CalcDiffNurbsC(C,t))/2;		// j[g@ɂvZ
		t += dt;
		if(count > LOOPCOUNTMAX || t > C->V[1]){
			GuiIF.SetMessage("NURBS_Func ERROR: Cannot find a anser");
			break;
		}
		//fprintf(stderr,"%d:  t = %lf,    dt = %lf\n",k,t,dt);	// debug
	}

	return t;
}


// w肵NURBSȖʏ̍Wl߂
// 
// *S:NURBSSւ̃|C^  Du,Dv:uCv̕  **Pts:o͂Wli[
// Ԓl   _
int NURBS_Func::CalcDeltaPtsOnNurbsS(NURBSS *S,int Du,int Dv,Coord **Pts)
{
	double u_val = (S->U[1] - S->U[0])/Du;		// pgbNԓłu𓾂
	double v_val = (S->V[1] - S->V[0])/Dv;		// pgbNԓłv𓾂

	// uCv̊e_ɂWl߂
	int num=0;
	for(int i=0;i<=Du;i++){
		for(int j=0;j<=Dv;j++){
			Pts[i][j] = CalcNurbsSCoord(S,S->U[0]+u_val*i,S->V[0]+v_val*j);	// w肵(u,v)̍Wl߂
			num++;
		}
	}
	
	return num;
}

// _
//    *S:Ȗ *Q:Ȗʏ(u,v)p[^Q(ύX̓_QɊi[)   N:_
// Ԓl   ύX̓_
int NURBS_Func::RemoveTheSamePoints(NURBSS *S,Coord *Q,int N)
{
	Coord *P = NewCoord1(N);

	for(int i=0;i<N;i++){
		P[i] = CalcNurbsSCoord(S,Q[i].x,Q[i].y);
		P[i].dmy = KOD_FALSE;
	}
	for(int i=0;i<N;i++){
		if(P[i].dmy == KOD_FALSE){
			for(int j=i+1;j<N;j++){
				if(DiffCoord(P[i],P[j],1.0e-3) == KOD_TRUE){
					P[j].dmy = KOD_TRUE;
				}
			}
		}
	}
	int k=0;
	for(int i=0;i<N;i++){
		if(P[i].dmy != KOD_TRUE){
			Q[k] = SetCoord(Q[i]);
			k++;
		}
	}

	return k;
}


// NURBSȐ̎w肵ɂɒl̍Wl𓾂
//     *CFɒlW߂NURBSȐւ̃|C^   nf:xNg     *pt:ꂽɒlNurbsȐp[^l    ptnum:*pt̔z
// Ԓl    ꂽɒlp[^̐   KOD_FALSE:Ȃ      KOD_ERR:ɒlp[^̐ptnum𒴂
int NURBS_Func::CalcExtremumNurbsC(NURBSC *C,Coord nf,double *pt,int ptnum)
{
	int anscount=0;			// ɒl̐

	// NURBSȐ̃p[^ԂCONVDIVNUMŋ؂Aꂼɑ΂ăj[g@ɂvZs
	for(int i=0;i<=CONVDIVNUM;i++){
		double t = C->V[0] + (C->V[1] - C->V[0])/CONVDIVNUM*(double)i;	// TJnp[^l
		double dt=0;					// j[g@p̑l
		int lpcount=0;					// vZ
		bool flag = false;				// OtO

		// vZ
		while(lpcount < LOOPCOUNTMAX){
			double f_ = CalcInnerProduct(nf,CalcDiffNurbsC(C,t));
			double f__ = CalcInnerProduct(nf,CalcDiff2NurbsC(C,t));
			if(f__ == 0.0)	break;
			dt = f_/f__;

			if(CheckZero(dt,MID_ACCURACY)){			// 
				flag = true;
				break;
			}
			t -= dt;	// j[gp[^XV
			if(t < C->V[0] || t > C->V[1])	break;		// ͈͊Oɏo
			lpcount++;
		}// End while

		// Ă
		if(flag == true){
			pt[anscount] = t;	// Ƃēo^
			anscount++;
			if(anscount == ptnum){
                GuiIF.SetMessage("NURBS_ERROR:range over");
				return KOD_ERR;
			}
		}

	}// End for i

	anscount = CheckTheSamePoints(pt,anscount);		// _

	return anscount;
}


// ɒnT𓾂
// ɒnT2
int NURBS_Func::CalcExtSearchCurve(NURBSS *S,Coord n,Coord pt,double ds,NURBSC *C1,NURBSC *C2)
{
	// H
	return KOD_TRUE;
}

// ɒnXΐ𓾂
// ɒnXΐ2
int NURBS_Func::CalcExtGradCurve(NURBSS *S,Coord n,Coord pt,double ds,NURBSC *C1,NURBSC *C2)
{
	// H
	return KOD_TRUE;
}

// NURBSȖʂ𕽖ʂŃg
int NURBS_Func::TrimNurbsSPlane(TRMS *Trm,Coord pt,Coord nvec)
{
	Coord t[2000];					// 
	int   num;						// ̐
	double pcolor[3] = {0,1,0};		// \̐F
	double tcolor[3] = {1,0,0};


	num = CalcIntersecPtsPlaneSearch(Trm->pts,pt,nvec,0.5,5,t,2000,RUNGE_KUTTA);		// NURBSȖʂƕʂƂ̌_QǐՖ@ŋ߂
	
	// pgbN̈Œߎ(ŏ2@ŋߎ̌W2߂)
	Matrix A = NewMatrix(2,2);
	Matrix A_ = NewMatrix(2,2);
	Vector B = NewVector(2);
	Vector B_ = NewVector(2);
	InitMatrix(A,2,2);
	InitVector(B,2);
	for(int i=0;i<num;i++){
		A[0][0] += t[i].x*t[i].x;
		A[0][1] += t[i].x;
		B[0] += t[i].x*t[i].y;
		B[1] += t[i].y;
	}
	A[1][0] = A[0][1];
	A[1][1] = (double)num;
	MatInv2(A,A_);
	MulMxVec(A_,2,2,B,2,B_);		// ̌WB_Ɋi[By = B_[0]x + B_[1]

	// [_o
	// pgbN̈U-V͈̔͂߂4_瓾4{̒ƁA߂ߎƂ̌_4߂
	Coord P[4];
	P[0] = TrimNurbsSPlaneSub1(B_[0],B_[1],Trm->pts->U[0],Trm->pts->V[0],Trm->pts->U[1],Trm->pts->V[0]);
	P[1] = TrimNurbsSPlaneSub1(B_[0],B_[1],Trm->pts->U[1],Trm->pts->V[0],Trm->pts->U[1],Trm->pts->V[1]);
	P[2] = TrimNurbsSPlaneSub1(B_[0],B_[1],Trm->pts->U[1],Trm->pts->V[1],Trm->pts->U[0],Trm->pts->V[1]);
	P[3] = TrimNurbsSPlaneSub1(B_[0],B_[1],Trm->pts->U[0],Trm->pts->V[1],Trm->pts->U[0],Trm->pts->V[0]);
	// ꂽ4̌_PAU-V͈͓ɂ2_𒊏o
	Coord Q[2];
	int j=0;
	for(int i=0;i<4;i++){
		if(P[i].x >= Trm->pts->U[0] && P[i].x <= Trm->pts->U[1] && P[i].y >= Trm->pts->V[0] && P[i].y <= Trm->pts->V[1]){
			Q[j] = SetCoord(P[i]);
			j++;
		}
	}
	// ꂽ2̓_QNURBSȐ()𐶐
	double T[4] = {0,0,1,1};
	double W[2] = {1,1};
	double V[2] = {0,1};
	int prop[4] = {0,0,1,0};
	Coord cp[2];
	InitCoord(&cp[0]);
	InitCoord(&cp[1]);
	//GenNurbsC(&body->CompC[i].DegeNurbs,2,2,4,T,W,cp,V,prop,1);	

	// łɓo^ĂOgȐƁAVɓoOgpQAVȕȐ`
	

	FILE *fp = fopen("Debug.csv","w");
	for(int i=0;i<num;i++){
		Coord p = CalcNurbsSCoord(Trm->pts,t[i].x,t[i].y);			// _p[^lWl֕ϊ
		DrawPoint(p,1,3,pcolor);			// _`
		fprintf(fp,"%lf,%lf\n",t[i].x,t[i].y);
	}
	fclose(fp);

	return KOD_TRUE;
}

// Bulirsch-Stoer@ɂɒnTs(Fdu(s)/ds = fu(u,v) ƁAdv(s)/ds = fv(u,v)̉T)
//   *S:ɒlTNURBSȖʂւ̃|C^, nf:ʂ̖@xNg, u0,v0:Jn_,  H:T
//       param:u1K0ƂȂɒl̒T(PARAM_U) or vT(PARAM_V)̑I, direction:TortT
//       *ans:XVꂽu,vp[^(ans.x = u, ans.y = v)
// Ԓl  KOD_TRUE:I,  KOD_FALSE:ٓ_ɂ菈𒆒f,  KOD_ERR:p[^̎w~Xɂ菈𒆒f
int NURBS_Func::SearchExtremum_BS(NURBSS *S,Coord nf,double u0,double v0,double H,int param,int direction,Coord *ans)
{
	// w~X
	if(direction != FORWARD && direction != INVERSE){
        GuiIF.SetMessage("NURBS ERROR: selected wrong direction");
		return KOD_ERR;
	}

	int    n[11] = {2,4,6,8,12,16,24,32,48,64,96};		// B-S@̕Qw
	Coord  z[97];							// C_@̒Ԓli[(z.x = u, z.y = v)
	Coord  f;								// f.x = fu(u,v), f.y = fv(u,v)
	Coord  D[10][10],C[10][10],P[11];		// B-S@̒ԃp[^
	double h[11];							// B-S@̍ݕ
	Coord  R;								// h=0̊O}l
	int    conv_flag = KOD_FALSE;			// tO

	// eɂ鍏ݕ߂Ă
	for(int i=0;i<11;i++)
		h[i] = H/n[i];
	
	// ݕ珇ɕύXȂAB-S@ɂO}lvZĂ
	for(int i=0;i<11;i++){

		// ܂Au(s+H)̒lC_@ɂvZ
		z[0] = SetCoord(u0,v0,0);										// z0z1̎Zo͕ʏ
		if(GetSECParam1(S,u0,v0,nf,param,direction,&f) == KOD_FALSE)	// z0ł̔̉EӂvZ
			return KOD_FALSE;
			//fprintf(stderr,"f%d=(%lf,%lf)\n",i,f.x,f.y);
		z[1] = AddCoord(z[0],MulCoord(f,h[i]));							// z0z1̎Zo͕ʏ
		for(int j=1;j<n[i];j++){
			if(GetSECParam1(S,z[j].x,z[j].y,nf,param,direction,&f) == KOD_FALSE)	// zjł̔̉EӂvZ
				return KOD_FALSE;
			z[j+1] = AddCoord(z[j-1],MulCoord(f,2*h[i]));				// z2`zn܂łZo
		}
		if(GetSECParam1(S,z[n[i]].x,z[n[i]].y,nf,param,direction,&f) == KOD_FALSE)	// znł̔̉EӂvZ
			return KOD_FALSE;
		P[i] = DivCoord(AddCoord(AddCoord(z[n[i]],z[n[i]-1]),MulCoord(f,h[i])),2);		// u(s+H)
			//fprintf(stderr,"P%d=(%lf,%lf)\n",i,P[i].x,P[i].y);

		// B-S@̍\߂Ă
		if(i > 0)	R = SetCoord(P[i-1]);
		for(int k=i-1;k>=0;k--){
			double x1 = h[k]*h[k];
			double x2 = h[k+1]*h[k+1];
			if(k == i-1){
				C[k][i-1-k] = MulCoord(SubCoord(P[k+1],P[k]),x1/(x1-x2));
				D[k][i-1-k] = MulCoord(SubCoord(P[k+1],P[k]),x2/(x1-x2));
			}
			else{
				C[k][i-1-k] = MulCoord(SubCoord(C[k+1][i-2-k],D[k][i-2-k]),x1/(x1-x2));
				D[k][i-1-k] = MulCoord(SubCoord(C[k+1][i-2-k],D[k][i-2-k]),x2/(x1-x2));
			}
			R = AddCoord(R,D[k][i-1-k]);		// O}l
			//fprintf(stderr,"%d,D%d=(%lf,%lf)\n",i,k,D[k][i-1-k].x,D[k][i-1-k].y);
		}

		// fprintf(stderr,"%d,%lf,%.16lf\n",i,h[i],CalcEuclid2D(D[0][i-1].x,D[0][i-1].y));

		// D[0][i-1]臒lȂÂƂ̊O}lƂĉZI
		if(i > 0 && CalcEuclid2D(D[0][i-1].x,D[0][i-1].y) < APPROX_ZERO_L){
			ans->x = R.x;
			ans->y = R.y;
			conv_flag = KOD_TRUE;
			break;
		}
	}

	return conv_flag;
}

// ɒlTSub֐1
int NURBS_Func::GetSECParam1(NURBSS *S,double u,double v,Coord nf,int param,int direction,Coord *f)
{
	double fuu = CalcInnerProduct(nf,CalcDiffNNurbsS(S,2,0,u,v));	// nfESuu
	double fuv = CalcInnerProduct(nf,CalcDiffNNurbsS(S,1,1,u,v));	// nfESuv
	double fvv = CalcInnerProduct(nf,CalcDiffNNurbsS(S,0,2,u,v));	// nfESvv
	Coord Su = CalcDiffuNurbsS(S,u,v);		// Ȗʂu1K
	Coord Sv = CalcDiffvNurbsS(S,u,v);		// Ȗʂv1K
	double E = CalcInnerProduct(Su,Su);		// 1Ki
	double F = CalcInnerProduct(Su,Sv);		// 1Ki
	double G = CalcInnerProduct(Sv,Sv);		// 1Ki
	if(param == PARAM_U){
		double f__ = E*fvv*fvv - 2*F*fuv*fvv + G*fuv*fuv;
		if(f__==0.0){
            GuiIF.SetMessage("NURBS KOD_ERROR:The process is stoped by detecting singular point.");
			return KOD_FALSE;				
		}
		double f_ = 1/sqrt(f__);
		*f = SetCoord(-f_*fvv*(double)direction,f_*fuv*(double)direction,0);
	}
	else if(param == PARAM_V){
		double f__ = E*fuv*fuv - 2*F*fuv*fuu + G*fuu*fuu; 
		if(f__==0.0){
            GuiIF.SetMessage("NURBS KOD_ERROR:The process is stoped by detecting singular point.");
			return KOD_FALSE;				
		}
		double f_ = 1/sqrt(f__);
		*f = SetCoord(-f_*fuv*(double)direction,f_*fuu*(double)direction,0);
	}

	return KOD_TRUE;
}

// TrimNurbsSPlanẽTu֐(2̌_Ƃ߂)
Coord NURBS_Func::TrimNurbsSPlaneSub1(double a,double b,double x0,double y0,double x1,double y1)
{
	Coord c;

	if(x1-x0 == 0.0){
		c.x = x0;
		c.y = a*x0+b;
		return c;
	}

	double p = (y1-y0)/(x1-x0);
	double q = (x1*y0-x0*y1)/(x1-x0);
	c.x = (q-b)/(a-p);
	c.y = (p*b-q*a)/(p-a);

	return c;
}

// eʉߓ_̋Ȑp[^Zo(R[h̔䂩Zo)
// 		*P:ʉߓ_   PNum:ʉߓ_̐    T_:Ȑp[^i[
void NURBS_Func::GetCurveKnotParam1(Coord *P,int PNum,Vector T_)
{
	double d_sum=0;
	for(int i=1;i<PNum;i++){
		d_sum += CalcEuclid(SubCoord(P[i],P[i-1]));
	}
	T_[0] = 0;
	T_[PNum-1] = 1;
	for(int i=1;i<PNum-1;i++){
		double d = CalcEuclid(SubCoord(P[i],P[i-1]));
		T_[i] = T_[i-1] + d/d_sum;
	}
}

// eʉߓ_̋Ȑp[^Zo(R[h̔̕䂩Zo)
// 		*P:ʉߓ_   PNum:ʉߓ_̐    T_:Ȑp[^i[
void NURBS_Func::GetCurveKnotParam2(Coord *P,int PNum,Vector T_)
{
	double d_sum=0;
	for(int i=1;i<PNum;i++){
		d_sum += sqrt(CalcEuclid(SubCoord(P[i],P[i-1])));
	}
	T_[0] = 0;
	T_[PNum-1] = 1;
	for(int i=1;i<PNum-1;i++){
		double d = sqrt(CalcEuclid(SubCoord(P[i],P[i-1])));
		T_[i] = T_[i-1] + d/d_sum;
	}
}

// ԋȖʗpu,vp[^𓾂
void NURBS_Func::GetSurfaceKnotParam(Vector S,Vector T,Coord **P,int uNum,int vNum)
{
	// u̒ʉߓ_̋Ȑp[^𓾂
	Vector du_sum = NewVector(vNum);
	InitVector(du_sum,vNum);
	for(int i=0;i<vNum;i++){
		for(int j=1;j<uNum;j++){
			du_sum[i] += CalcEuclid(SubCoord(P[j][i],P[j-1][i]));
		}
	}
	S[0] = 0;
	for(int i=1;i<uNum-1;i++){
		S[i] = 0;
		for(int j=0;j<vNum;j++){
			double du = CalcEuclid(SubCoord(P[i][j],P[i-1][j]));
			S[i] += S[i-1] + du/du_sum[j];
		}
		S[i] /= (double)vNum;
	}
	S[uNum-1] = 1;
	
	// v̒ʉߓ_̋Ȑp[^𓾂
	Vector dv_sum = NewVector(uNum);
	InitVector(dv_sum,uNum);
	for(int i=0;i<uNum;i++){
		for(int j=1;j<vNum;j++){
			dv_sum[i] += CalcEuclid(SubCoord(P[i][j],P[i][j-1]));
		}
	}
	T[0] = 0;
	for(int i=1;i<vNum-1;i++){
		T[i] = 0;
		for(int j=0;j<uNum;j++){
			double dv = CalcEuclid(SubCoord(P[j][i],P[j][i-1]));
			T[i] += T[i-1] + dv/dv_sum[j];
		}
		T[i] /= (double)uNum;
	}
	T[vNum-1] = 1;

	FreeVector(du_sum);
	FreeVector(dv_sum);
}

// Ȑ/Ȗʃp[^瓙ԊuȃmbgxNgZo
//    K:Rg[|Cg̐  M:K   T:i[mbgxNg
void NURBS_Func::GetEqIntervalKont(int K,int M,Vector T)
{
	for(int i=0;i<M;i++)
		T[i] = 0;
	for(int i=M;i<K;i++)
		T[i] = ((double)i-(double)M+1)/((double)K-(double)M+1)*NORM_KNOT_VAL;
	for(int i=K;i<K+M;i++)
		T[i] = NORM_KNOT_VAL;
}

// Ȑ/Ȗʃp[^ԗpmbgxNgZo
//    T_:Ȑp[^  N:mbgxNg̐  K:Rg[|Cg̐  M:K   T:i[mbgxNg
void NURBS_Func::GetInterpolatedKnot(Vector T_,int N,int K,int M,Vector T)
{
	for(int i=0;i<M;i++)
		T[i] = 0;

	// T_Qlɂ
	for(int j=1;j<K-M+1;j++){
		double d=0;
		for(int i=j;i<j+M-1;i++){
			d += T_[i];
		}
		T[j+M-1] = d/((double)M-1);
	}

	// Ԋuɐݒ
	//for(int i=M;i<K;i++)
	//	T[i] = ((double)i-(double)M+1)/((double)K-(double)M+1);

	for(int i=K;i<K+M;i++)
		T[i] = 1;
}

// Ȑ/Ȗʃp[^ߎpmbgxNgZo
//    T_:Ȑp[^  N:Ȑp[^̐  M:K  K:Rg[|Cg̐  T:i[mbgxNg
void NURBS_Func::GetApproximatedKnot(Vector T_,int N,int M,int K,Vector T)
{
	for(int i=0;i<M;i++)	T[i] = 0;
	for(int i=K;i<K+M;i++)	T[i] = 1;
	double d = (double)N/(double)(K-M+1);
	for(int j=1;j<K-M+1;j++){
		int i = (int)(j*d);
		double a = (double)j*d - (double)i;
		T[j+M-1] = (1-a)*T_[i-1] + a*T_[i];
		T[j+M-1] += 0.0001;					// !  TT_lɂȂƁAŏQ@܂Ȃ̂ŁA֋XIɓlɂȂȂ悤ɂĂB
	}
}

// Ȑ/Ȗʃp[^̒`ύX
//  T:ύXmbgxNg, N:T̔z, M:K, K:Rg[|Cg̐, Tst:JnmbgxNg, Te:ImbgxNg
void NURBS_Func::ChangeKnotVecRange(Vector T, int N, int M, int K, double Ts, double Te)
{
	Vector T_ = NewVector(N);
	
	for(int i=0;i<N;i++)
		T_[i] = (Te-Ts)/(T[K]-T[M-1])*T[i] + (Ts*T[K]-Te*T[M-1])/(T[K]-T[M-1]);

	for(int i=0;i<N;i++)
		T[i] = T_[i];

	FreeVector(T_);
}

// ŏ2@ŋߎRg[|Cg߂
//     *P:ʉߓ_  T_:Ȑp[^  T:mbgxNg  Pnum:Ȑp[^̐  Nnum:mbgxNg̐  
//         M:K  K:Rg[|Cg̐   *Q:ZoꂽRg[|Cg
void NURBS_Func::CalcApproximationCP_LSM(Coord *P,Vector T_,Vector T,int Pnum,int Nnum,int M,int K,Coord *Q)
{
	Matrix N = NewMatrix(Pnum-2,K-2);
	for(int i=0;i<Pnum-2;i++){
		for(int j=0;j<K-2;j++){
			N[i][j] =  CalcBSbasis(T_[i+1],T,Nnum,j+1,M);
		}
	}
	
	Coord *R = NewCoord1(K-2);
	for(int i=0;i<K-2;i++){
		InitCoord(&R[i]);
		for(int j=0;j<Pnum-2;j++){
			Coord NP0 = MulCoord(P[0],CalcBSbasis(T_[j+1],T,Nnum,0,M));
			Coord NPN = MulCoord(P[Pnum-1],CalcBSbasis(T_[j+1],T,Nnum,K-1,M));
			Coord R_ = SubCoord(P[j+1],AddCoord(NP0,NPN));
			R[i] = AddCoord(R[i],MulCoord(R_,N[j][i]));
		}
	}

	Matrix N_ = NewMatrix(K-2,K-2);			// (NTN)^-1
	Matrix NTN = NewMatrix(K-2,K-2);		// NT*N
	Matrix NT = NewMatrix(K-2,Pnum-2);		// N̓]usNT
	TranMx(N,Pnum-2,K-2,NT);				// calc NT
	MulMxMx(NT,K-2,Pnum-2,N,Pnum-2,K-2,NTN);// calc NTN

	Coord *Q_ = NewCoord1(K-2);
	Gauss(K-2,NTN,R,Q_);

	// Rg[|Cg
	Q[0] = SetCoord(P[0]);
	Q[K-1] = SetCoord(P[Pnum-1]);
	for(int i=1;i<K-1;i++){
		Q[i] = SetCoord(Q_[i-1]);
	}

	FreeCoord1(Q_);
	FreeMatrix(N_,K-2);
	FreeMatrix(NTN,K-2);
	FreeMatrix(NT,K-2);
	FreeCoord1(R);
	FreeMatrix(N,Pnum-2);
}

// _񐔂琶Rg[|CgZ肷
// łB
int NURBS_Func::SetApproximationCPnum(int PNum)
{
	if(PNum < 5)		// 
		return PNum;
	else if(PNum < 10)	// 
		return PNum-1;
	else 
		return PNum/2;	// 
}

// NURBSȐfobOvg
void NURBS_Func::DebugForNurbsC(NURBSC *nurbs)
{
	fprintf(stderr,"Cp num: %d\n",nurbs->K);
	fprintf(stderr,"Rank: %d\n",nurbs->M);
	fprintf(stderr,"Knot num: %d\n",nurbs->N);
	fprintf(stderr,"Knot range: %lf - %lf\n",nurbs->V[0], nurbs->V[1]);

	// Rg[|Cg
	fprintf(stderr,"Control Point\n");
	for(int i=0;i<nurbs->K;i++){
		fprintf(stderr,"#%d: (%lf,%lf,%lf)\t",i+1,nurbs->cp[i].x,nurbs->cp[i].y,nurbs->cp[i].z);
	}
	fprintf(stderr,"\n");

	// mbgV[PX
	fprintf(stderr,"Knot Vector\t");
	for(int i=0;i<nurbs->K+nurbs->M;i++){
		fprintf(stderr,"#%d: %lf\t",i+1,nurbs->T[i]);
	}
	fprintf(stderr,"\n");

	// EFCg
	fprintf(stderr,"Weight\n");
	for(int i=0;i<nurbs->K;i++){
		fprintf(stderr,"#%d: %lf\t",i+1,nurbs->W[i]);
	}
}

// NURBSȖʏfobOvg
void NURBS_Func::DebugForNurbsS(NURBSS *nurbs)
{
	fprintf(stderr,"Cp num: %d-%d\n",nurbs->K[0],nurbs->K[1]);
	fprintf(stderr,"Rank: %d-%d\n",nurbs->M[0],nurbs->M[1]);
	fprintf(stderr,"Knot num: %d-%d\n",nurbs->N[0],nurbs->N[1]);
	fprintf(stderr,"Knot range: (%lf - %lf),(%lf - %lf)\n",nurbs->U[0],nurbs->U[1],nurbs->V[0],nurbs->V[1]);

	// Rg[|Cg
	fprintf(stderr,"Control Point\n");
	for(int i=0;i<nurbs->K[0];i++){
		for(int j=0;j<nurbs->K[1];j++){
			fprintf(stderr,"#(%d-%d): (%lf,%lf,%lf)\t",i+1,j+1,nurbs->cp[i][j].x,nurbs->cp[i][j].y,nurbs->cp[i][j].z);
		}
	}
	fprintf(stderr,"\n");

	// UmbgV[PX
	fprintf(stderr,"U Knot Vector\t");
	for(int i=0;i<nurbs->K[0]+nurbs->M[0];i++){
		fprintf(stderr,"#%d: %lf\t",i+1,nurbs->S[i]);
	}
	fprintf(stderr,"\n");

	// VmbgV[PX
	fprintf(stderr,"V Knot Vector\t");
	for(int i=0;i<nurbs->K[1]+nurbs->M[1];i++){
		fprintf(stderr,"#%d: %lf\t",i+1,nurbs->T[i]);
	}
	fprintf(stderr,"\n");

	// EFCg
	//fprintf(stderr,"Weight\n");
	//for(int i=0;i<nurbs->K[0];i++){
	//	for(int j=0;j<nurbs->K[1];j++){
	//		fprintf(stderr,"#(%d-%d): %lf\t",i+1,j+1,nurbs->W[i][j]);
	//	}
	//}
}

// NURBSȐC(t)̎wp[^[a,b]̐L߂
// L = S|C'(t)|dt	(S͐ϕL)
// ϕ͐lϕ(KEX-Wh80_)p
double NURBS_Func::CalcNurbsCLength(NURBSC *Nurb,double a,double b)
{
	double g[80] = {-0.9995538226516306298800804990945671849917
		,-0.997649864398237688899494208183122985331
		,-0.994227540965688277892063503664911698088
		,-0.989291302499755531026503167136631385282
		,-0.982848572738629070418288027709116473568
		,-0.974909140585727793385645230069136276245
		,-0.965485089043799251452273155671454998502
		,-0.954590766343634905493481517021029508783
		,-0.942242761309872674752266004500001735070
		,-0.928459877172445795953045959075453133792
		,-0.913263102571757654164733656150947478111
		,-0.896675579438770683194324071967395986307
		,-0.878722567678213828703773343639124407935
		,-0.859431406663111096977192123491656492839
		,-0.838831473580255275616623043902867064793
		,-0.816954138681463470371124994012295707742
		,-0.793832717504605449948639311738454358610
		,-0.769502420135041373865616068749026083985
		,-0.744000297583597272316540527930913673808
		,-0.717365185362099880254068258293815278566
		,-0.689637644342027600771207612438935266089
		,-0.660859898986119801735967122844317234805
		,-0.631075773046871966247928387289336863089
		,-0.600330622829751743154746299164006848430
		,-0.568671268122709784725485786624827158742
		,-0.536145920897131932019857253125400904911
		,-0.502804111888784987593672750367568003564
		,-0.468696615170544477036078364935808657294
		,-0.433875370831756093062386700363181958302
		,-0.398393405881969227024379642517533757117
		,-0.362304753499487315619043286358963588017
		,-0.325664370747701914619112943627358695037
		,-0.288528054884511853109139301434713898496
		,-0.250952358392272120493158816035004797363
		,-0.212994502857666132572388538666321823094
		,-0.174712291832646812559339048011286195718
		,-0.136164022809143886559241078000717067933
		,-0.097408398441584599063278450104936902017
		,-0.058504437152420668628993321883417794425
		,-0.019511383256793997654351234107454547933
		,0.0195113832567939976543512341074545479335
		,0.0585044371524206686289933218834177944254
		,0.0974083984415845990632784501049369020170
		,0.1361640228091438865592410780007170679331
		,0.1747122918326468125593390480112861957188
		,0.2129945028576661325723885386663218230948
		,0.2509523583922721204931588160350047973630
		,0.2885280548845118531091393014347138984964
		,0.3256643707477019146191129436273586950370
		,0.3623047534994873156190432863589635880171
		,0.3983934058819692270243796425175337571172
		,0.4338753708317560930623867003631819583021
		,0.4686966151705444770360783649358086572940
		,0.5028041118887849875936727503675680035649
		,0.5361459208971319320198572531254009049117
		,0.5686712681227097847254857866248271587420
		,0.6003306228297517431547462991640068484301
		,0.6310757730468719662479283872893368630891
		,0.6608598989861198017359671228443172348051
		,0.6896376443420276007712076124389352660897
		,0.7173651853620998802540682582938152785668
		,0.7440002975835972723165405279309136738087
		,0.7695024201350413738656160687490260839854
		,0.7938327175046054499486393117384543586106
		,0.8169541386814634703711249940122957077428
		,0.8388314735802552756166230439028670647936
		,0.8594314066631110969771921234916564928399
		,0.8787225676782138287037733436391244079359
		,0.8966755794387706831943240719673959863073
		,0.9132631025717576541647336561509474781115
		,0.9284598771724457959530459590754531337922
		,0.9422427613098726747522660045000017350708
		,0.9545907663436349054934815170210295087836
		,0.9654850890437992514522731556714549985029
		,0.9749091405857277933856452300691362762450
		,0.9828485727386290704182880277091164735687
		,0.9892913024997555310265031671366313852822
		,0.9942275409656882778920635036649116980888
		,0.9976498643982376888994942081831229853311
		,0.9995538226516306298800804990945671849917
	};
	double w[80] = {0.00114495000318694153454417194131563611869939240558
		,0.0026635335895126816692935358316684554657445542424
		,0.0041803131246948952367393042016813513235494973731
		,0.0056909224514031986492691071171620184769252638347
		,0.0071929047681173127526755708679565074765070381923
		,0.0086839452692608584264094522040342813524060429550
		,0.0101617660411030645208318503524069436640457818796
		,0.0116241141207978269164667699954326348595131815029
		,0.0130687615924013392937868258970563403104186343824
		,0.0144935080405090761169620745834605500559568721551
		,0.0158961835837256880449029092291785257709720926057
		,0.0172746520562693063585842071312909998003110293040
		,0.0186268142082990314287354141521572090084477663361
		,0.0199506108781419989288919287151135633605010642850
		,0.0212440261157820063887107372506131285464689242433
		,0.0225050902463324619262215896861687390205795883718
		,0.0237318828659301012931925246135684162923425291083
		,0.0249225357641154911051178470032198023571024898755
		,0.0260752357675651179029687436002692871256974758292
		,0.0271882275004863806744187066805442598298771757001
		,0.0282598160572768623967531979650145302942654983731
		,0.0292883695832678476927675860195791396612074311446
		,0.0302723217595579806612200100909011747473420675596
		,0.0312101741881147016424428667206035518659997208202
		,0.0321004986734877731480564902872506960895167638325
		,0.0329419393976454013828361809019595361280270376927
		,0.0337332149846115228166751630642387284458265038481
		,0.0344731204517539287943642267310298320767807967429
		,0.0351605290447475934955265923886968812291624523105
		,0.0357943939534160546028615888161544542402361352305
		,0.0363737499058359780439649910465228136600628217876
		,0.0368977146382760088391509965734052192685681011318
		,0.0373654902387304900267053770578386691648069079494
		,0.0377763643620013974897749764263210547707019240195
		,0.0381297113144776383442067915657362019141439239065
		,0.0384249930069594231852124363294901384310218762709
		,0.0386617597740764633270771102671566912609009278398
		,0.0388396510590519689317741826687871658908802293404
		,0.0389583959627695311986255247722608223149320115862
		,0.0390178136563066548112804392527540483295504740296
		,0.0390178136563066548112804392527540483295504740296
		,0.0389583959627695311986255247722608223149320115862
		,0.0388396510590519689317741826687871658908802293404
		,0.0386617597740764633270771102671566912609009278398
		,0.0384249930069594231852124363294901384310218762709
		,0.0381297113144776383442067915657362019141439239065
		,0.0377763643620013974897749764263210547707019240195
		,0.0373654902387304900267053770578386691648069079494
		,0.0368977146382760088391509965734052192685681011318
		,0.0363737499058359780439649910465228136600628217876
		,0.0357943939534160546028615888161544542402361352305
		,0.0351605290447475934955265923886968812291624523105
		,0.0344731204517539287943642267310298320767807967429
		,0.0337332149846115228166751630642387284458265038481
		,0.0329419393976454013828361809019595361280270376927
		,0.0321004986734877731480564902872506960895167638325
		,0.0312101741881147016424428667206035518659997208202
		,0.0302723217595579806612200100909011747473420675596
		,0.0292883695832678476927675860195791396612074311446
		,0.0282598160572768623967531979650145302942654983731
		,0.0271882275004863806744187066805442598298771757001
		,0.0260752357675651179029687436002692871256974758292
		,0.0249225357641154911051178470032198023571024898755
		,0.0237318828659301012931925246135684162923425291083
		,0.0225050902463324619262215896861687390205795883718
		,0.0212440261157820063887107372506131285464689242433
		,0.0199506108781419989288919287151135633605010642850
		,0.0186268142082990314287354141521572090084477663361
		,0.0172746520562693063585842071312909998003110293040
		,0.0158961835837256880449029092291785257709720926057
		,0.0144935080405090761169620745834605500559568721551
		,0.0130687615924013392937868258970563403104186343824
		,0.0116241141207978269164667699954326348595131815029
		,0.0101617660411030645208318503524069436640457818796
		,0.0086839452692608584264094522040342813524060429550
		,0.0071929047681173127526755708679565074765070381923
		,0.0056909224514031986492691071171620184769252638347
		,0.0041803131246948952367393042016813513235494973731
		,0.0026635335895126816692935358316684554657445542424
		,0.0011449500031869415345441719413156361186993924055
	};

	double A = (b+a)/2;
	double B = (b-a)/2;
	double len=0;

	for(int i=0;i<80;i++){
		double xi = A+B*g[i];
		len += w[i]*(CalcEuclid(CalcDiffNurbsC(Nurb,xi)));
	}
	return(B*len);
}
// NURBSȐC(t)̑SԂ̐L߂
// L = S|C'(t)|dt	(S͐ϕL)
// ϕ͐lϕ(KEX-Wh80_)p
double NURBS_Func::CalcNurbsCLength(NURBSC *Nurb)
{
	double g[80] = {-0.9995538226516306298800804990945671849917
		,-0.997649864398237688899494208183122985331
		,-0.994227540965688277892063503664911698088
		,-0.989291302499755531026503167136631385282
		,-0.982848572738629070418288027709116473568
		,-0.974909140585727793385645230069136276245
		,-0.965485089043799251452273155671454998502
		,-0.954590766343634905493481517021029508783
		,-0.942242761309872674752266004500001735070
		,-0.928459877172445795953045959075453133792
		,-0.913263102571757654164733656150947478111
		,-0.896675579438770683194324071967395986307
		,-0.878722567678213828703773343639124407935
		,-0.859431406663111096977192123491656492839
		,-0.838831473580255275616623043902867064793
		,-0.816954138681463470371124994012295707742
		,-0.793832717504605449948639311738454358610
		,-0.769502420135041373865616068749026083985
		,-0.744000297583597272316540527930913673808
		,-0.717365185362099880254068258293815278566
		,-0.689637644342027600771207612438935266089
		,-0.660859898986119801735967122844317234805
		,-0.631075773046871966247928387289336863089
		,-0.600330622829751743154746299164006848430
		,-0.568671268122709784725485786624827158742
		,-0.536145920897131932019857253125400904911
		,-0.502804111888784987593672750367568003564
		,-0.468696615170544477036078364935808657294
		,-0.433875370831756093062386700363181958302
		,-0.398393405881969227024379642517533757117
		,-0.362304753499487315619043286358963588017
		,-0.325664370747701914619112943627358695037
		,-0.288528054884511853109139301434713898496
		,-0.250952358392272120493158816035004797363
		,-0.212994502857666132572388538666321823094
		,-0.174712291832646812559339048011286195718
		,-0.136164022809143886559241078000717067933
		,-0.097408398441584599063278450104936902017
		,-0.058504437152420668628993321883417794425
		,-0.019511383256793997654351234107454547933
		,0.0195113832567939976543512341074545479335
		,0.0585044371524206686289933218834177944254
		,0.0974083984415845990632784501049369020170
		,0.1361640228091438865592410780007170679331
		,0.1747122918326468125593390480112861957188
		,0.2129945028576661325723885386663218230948
		,0.2509523583922721204931588160350047973630
		,0.2885280548845118531091393014347138984964
		,0.3256643707477019146191129436273586950370
		,0.3623047534994873156190432863589635880171
		,0.3983934058819692270243796425175337571172
		,0.4338753708317560930623867003631819583021
		,0.4686966151705444770360783649358086572940
		,0.5028041118887849875936727503675680035649
		,0.5361459208971319320198572531254009049117
		,0.5686712681227097847254857866248271587420
		,0.6003306228297517431547462991640068484301
		,0.6310757730468719662479283872893368630891
		,0.6608598989861198017359671228443172348051
		,0.6896376443420276007712076124389352660897
		,0.7173651853620998802540682582938152785668
		,0.7440002975835972723165405279309136738087
		,0.7695024201350413738656160687490260839854
		,0.7938327175046054499486393117384543586106
		,0.8169541386814634703711249940122957077428
		,0.8388314735802552756166230439028670647936
		,0.8594314066631110969771921234916564928399
		,0.8787225676782138287037733436391244079359
		,0.8966755794387706831943240719673959863073
		,0.9132631025717576541647336561509474781115
		,0.9284598771724457959530459590754531337922
		,0.9422427613098726747522660045000017350708
		,0.9545907663436349054934815170210295087836
		,0.9654850890437992514522731556714549985029
		,0.9749091405857277933856452300691362762450
		,0.9828485727386290704182880277091164735687
		,0.9892913024997555310265031671366313852822
		,0.9942275409656882778920635036649116980888
		,0.9976498643982376888994942081831229853311
		,0.9995538226516306298800804990945671849917
	};
	double w[80] = {0.00114495000318694153454417194131563611869939240558
		,0.0026635335895126816692935358316684554657445542424
		,0.0041803131246948952367393042016813513235494973731
		,0.0056909224514031986492691071171620184769252638347
		,0.0071929047681173127526755708679565074765070381923
		,0.0086839452692608584264094522040342813524060429550
		,0.0101617660411030645208318503524069436640457818796
		,0.0116241141207978269164667699954326348595131815029
		,0.0130687615924013392937868258970563403104186343824
		,0.0144935080405090761169620745834605500559568721551
		,0.0158961835837256880449029092291785257709720926057
		,0.0172746520562693063585842071312909998003110293040
		,0.0186268142082990314287354141521572090084477663361
		,0.0199506108781419989288919287151135633605010642850
		,0.0212440261157820063887107372506131285464689242433
		,0.0225050902463324619262215896861687390205795883718
		,0.0237318828659301012931925246135684162923425291083
		,0.0249225357641154911051178470032198023571024898755
		,0.0260752357675651179029687436002692871256974758292
		,0.0271882275004863806744187066805442598298771757001
		,0.0282598160572768623967531979650145302942654983731
		,0.0292883695832678476927675860195791396612074311446
		,0.0302723217595579806612200100909011747473420675596
		,0.0312101741881147016424428667206035518659997208202
		,0.0321004986734877731480564902872506960895167638325
		,0.0329419393976454013828361809019595361280270376927
		,0.0337332149846115228166751630642387284458265038481
		,0.0344731204517539287943642267310298320767807967429
		,0.0351605290447475934955265923886968812291624523105
		,0.0357943939534160546028615888161544542402361352305
		,0.0363737499058359780439649910465228136600628217876
		,0.0368977146382760088391509965734052192685681011318
		,0.0373654902387304900267053770578386691648069079494
		,0.0377763643620013974897749764263210547707019240195
		,0.0381297113144776383442067915657362019141439239065
		,0.0384249930069594231852124363294901384310218762709
		,0.0386617597740764633270771102671566912609009278398
		,0.0388396510590519689317741826687871658908802293404
		,0.0389583959627695311986255247722608223149320115862
		,0.0390178136563066548112804392527540483295504740296
		,0.0390178136563066548112804392527540483295504740296
		,0.0389583959627695311986255247722608223149320115862
		,0.0388396510590519689317741826687871658908802293404
		,0.0386617597740764633270771102671566912609009278398
		,0.0384249930069594231852124363294901384310218762709
		,0.0381297113144776383442067915657362019141439239065
		,0.0377763643620013974897749764263210547707019240195
		,0.0373654902387304900267053770578386691648069079494
		,0.0368977146382760088391509965734052192685681011318
		,0.0363737499058359780439649910465228136600628217876
		,0.0357943939534160546028615888161544542402361352305
		,0.0351605290447475934955265923886968812291624523105
		,0.0344731204517539287943642267310298320767807967429
		,0.0337332149846115228166751630642387284458265038481
		,0.0329419393976454013828361809019595361280270376927
		,0.0321004986734877731480564902872506960895167638325
		,0.0312101741881147016424428667206035518659997208202
		,0.0302723217595579806612200100909011747473420675596
		,0.0292883695832678476927675860195791396612074311446
		,0.0282598160572768623967531979650145302942654983731
		,0.0271882275004863806744187066805442598298771757001
		,0.0260752357675651179029687436002692871256974758292
		,0.0249225357641154911051178470032198023571024898755
		,0.0237318828659301012931925246135684162923425291083
		,0.0225050902463324619262215896861687390205795883718
		,0.0212440261157820063887107372506131285464689242433
		,0.0199506108781419989288919287151135633605010642850
		,0.0186268142082990314287354141521572090084477663361
		,0.0172746520562693063585842071312909998003110293040
		,0.0158961835837256880449029092291785257709720926057
		,0.0144935080405090761169620745834605500559568721551
		,0.0130687615924013392937868258970563403104186343824
		,0.0116241141207978269164667699954326348595131815029
		,0.0101617660411030645208318503524069436640457818796
		,0.0086839452692608584264094522040342813524060429550
		,0.0071929047681173127526755708679565074765070381923
		,0.0056909224514031986492691071171620184769252638347
		,0.0041803131246948952367393042016813513235494973731
		,0.0026635335895126816692935358316684554657445542424
		,0.0011449500031869415345441719413156361186993924055
	};

	double A = (Nurb->V[1]+Nurb->V[0])/2;
	double B = (Nurb->V[1]-Nurb->V[0])/2;
	double len=0;

	for(int i=0;i<80;i++){
		double xi = A+B*g[i];
		len += w[i]*(CalcEuclid(CalcDiffNurbsC(Nurb,xi)));
	}
	return(B*len);
}

// ŏWlԂ
Coord NURBS_Func::GetMinDistance(Coord a,Coord *b,int n)
{
	if(!n)	return SetCoord(0,0,0);

	Vector d = NewVector(n);

	for(int i=0;i<n;i++){
		d[i] = CalcDistance(a,b[i]);
	}

	double min = 1.0E+12;
	int min_num;
	for(int i=0;i<n;i++){
		if(d[i] < min){
			min = d[i];
			min_num = i;
		}
	}

	FreeVector(d);

	return b[min_num];
}

// NURBSȐw肵ʒui[̌ʒjŕ
//   *C0FNURBSȐւ̃|C^        *C1FꂽNURBSȐւ̃|C^
//       *C2FꂽNURBSȐւ̃|C^     LF[̌ʒ
int NURBS_Func::DivNurbsC(NURBSC *C0, NURBSC *C1, NURBSC *C2, double L)
{
	double t = CalcParamLengthOnNurbsC(C0,L,0);		// _̃p[^l擾

	DivNurbsCParam(C0,C1,C2,t);		// 

	return KOD_TRUE;
}

// NURBSȐw肵p[^lŕ
//   *C0FNURBSȐւ̃|C^        *C1FꂽNURBSȐւ̃|C^
//       *C2FꂽNURBSȐւ̃|C^     tFʒu\Ȑp[^
int NURBS_Func::DivNurbsCParam(NURBSC *C0, NURBSC *C1, NURBSC *C2, double t)
{
	// tp[^K͈͂
	if(t <= C0->T[0] || t >= C0->T[C0->N-1]){
		GuiIF.SetMessage("NURBS_Func ERROR: Wrong Curve Parameter is set.");
		return KOD_ERR;
	}

	int deg = C0->M - 1;		// dx

	// ̉
	// pȐC0_
	NURBSC C0_;
	C0_.K = C0->K + deg;
	C0_.N = C0->M + C0_.K;
	New_NurbsC(&C0_,C0_.K,C0_.N);

	// C0̃mbgxNgtƓlꍇ́Cdx1Ƃ
	for(int i=0;i<C0->N;i++){
		if(t == C0->T[i])	deg--;
	}

	// ʒup[^tC0_ɑ}
	int k = InsertNewKnotOnNurbsC(C0,&C0_,t,deg);

	// 2{̕Ȑ𐶐
	int N1 = k+1;
	int K1 = N1 - C0->M;
	int N2 = C0_.N - k + deg+1;
	int K2 = N2 - C0->M;

	Vector T1 = NewVector(N1);
	Vector W1 = NewVector(K1);
	Coord  *cp1 = NewCoord1(K1);
	Vector T2 = NewVector(N2);
	Vector W2 = NewVector(K2);
	Coord  *cp2 = NewCoord1(K2);

	// mbgxNgCRg[|CgCEFCgC1,C2ɕz
	for(int i=0;i<N1-1;i++)
		T1[i] = C0_.T[i];
	T1[N1-1] = t;
	for(int i=0;i<K1;i++){
		cp1[i] = SetCoord(C0_.cp[i]);
		W1[i] = C0_.W[i];
	}
	for(int i=0;i<C0->M;i++)
		T2[i] = t;
	for(int i=C0->M;i<N2;i++)
		T2[i] = C0_.T[k+i-C0->M];
	for(int i=0;i<K2;i++){
		cp2[i] = SetCoord(C0_.cp[i+K1-1]);
		W2[i] = C0_.W[i+K1-1];
	}

	// debug
	//fprintf(stderr,"C0:%d,%d\n",C0->K,C0->N);
	//fprintf(stderr,"C0_:%d,%d\n",C0_.K,C0_.N);
	//fprintf(stderr,"C1:%d,%d\n",K1,N1);
	//fprintf(stderr,"C2:%d,%d\n",K2,N2);
	//fprintf(stderr,"\n");
	//for(int i=0;i<C0_.N;i++)
	//	fprintf(stderr,"%d:%lf\n",i+1,C0_.T[i]);
	//fprintf(stderr,"\n");
	//for(int i=0;i<N1;i++)
	//	fprintf(stderr,"%d:%lf\n",i+1,T1[i]);
	//fprintf(stderr,"\n");
	//for(int i=0;i<N2;i++)
	//	fprintf(stderr,"%d:%lf\n",i+1,T2[i]);

	// mbg͈̔͂0-1ɕύX
	ChangeKnotVecRange(T1,N1,C0->M,K1,0,1);
	ChangeKnotVecRange(T2,N2,C0->M,K2,0,1);

	// C1,C2
	GenNurbsC(C1,K1,C0->M,N1,T1,W1,cp1,C0->V,C0->prop,0);
	GenNurbsC(C2,K2,C0->M,N2,T2,W2,cp2,C0->V,C0->prop,0);
	
	FreeVector(T1);
	FreeVector(W1);
	FreeCoord1(cp1);
	FreeVector(T2);
	FreeVector(W2);
	FreeCoord1(cp2);

	return KOD_TRUE;
}

// 2{NURBSȐA
//     *C1:Ȑ1,   *C2:Ȑ2,    *C_:A̋Ȑi[
// Ԓl    FKOD_TRUE,  sFKOD_FALSE
int NURBS_Func::ConnectNurbsC(NURBSC *C1,NURBSC *C2,NURBSC *C_)
{
	int flag = -1;		// AʒuʗptO

	// 2Ȑ̘Aʒu𒲂ׁCA_C1(1), C2(0)ƂȂ悤ǂ炩̋Ȑ𒲐
	if(DiffCoord(C1->cp[0],C2->cp[0]) == KOD_TRUE){
		ReverseNurbsC(C1);				// C1̌𔽓]
	}
	else if(DiffCoord(C1->cp[0],C2->cp[C2->K-1]) == KOD_TRUE){
		NURBSC *C;
		C = C2;
		C2 = C1;
		C1 = C;
	}
	else if(DiffCoord(C1->cp[C1->K-1],C2->cp[0]) == KOD_TRUE){
		// ̃P[XOKDɒKvȂ
	}
	else if(DiffCoord(C1->cp[C1->K-1],C2->cp[C2->K-1]) == KOD_TRUE){
		ReverseNurbsC(C2);				// C2̌𔽓]
	}
	else{
		GuiIF.SetMessage("NURBS_Func ERROR: Two Curves don't share the same coordinate value.");
		return KOD_ERR;
	}

	// 2Ȑ̊K
	if(C1->M != C2->M){
		GuiIF.SetMessage("NURBS_Func ERROR: Two Curves don't have the same rank.");
		return KOD_ERR;
	}

	int K = C1->K + C2->K - 1;				// C_̃Rg[|Cg̐
	int N = C1->N + C2->N - C2->M - 1;		// C_̃mbgxNg̐

	New_NurbsC(C_,K,N);						// C_̃[m

	SetKnotVecC_ConnectC(C1,C2,C_);			// C_̃mbg`w

	SetCPC_ConnectC(C1,C2,C_);				// C_̃Rg[|CgƃEFCgw

	//for(int i=0;i<C_->N;i++)
	//	fprintf(stderr,"%d,%lf\n",i+1,C_->T[i]);
	//fprintf(stderr,"\n");
	//for(int i=0;i<C_->K;i++)
	//	fprintf(stderr,"%d,%lf,%lf,%lf,%lf\n",i+1,C_->cp[i].x,C_->cp[i].y,C_->cp[i].z,C_->W[i]);

	C_->M = C1->M;							// C_̊Kw

	for(int i=0;i<4;i++)
		C_->prop[i] = C1->prop[i];
	C_->EntUseFlag = C1->EntUseFlag;

	return KOD_TRUE;
}

// NURBSȐ̃mbgxNg𔽓]
void NURBS_Func::ReverseNurbsC(NURBSC *C)
{
	Reverse(C->W,C->K);
	Reverse(C->cp,C->K);
	Reverse(C->T,C->N);
	for(int i=0;i<C->N;i++)
		C->T[i] *= -1;
}

// 2{̋ȐqƂ̃mbgxNgݒ肷
void NURBS_Func::SetKnotVecC_ConnectC(NURBSC *C1,NURBSC *C2,NURBSC *C_)
{
	// R[h𒲂ׂ
	double s=0,e=NORM_KNOT_VAL,c=0;			// JnCICAmbgxNg
	double l1=0,l2=0;						// eȐ̃mbgxNg̃R[h
	for(int i=0;i<C1->N-1;i++)
		l1 += CalcDistance(CalcNurbsCCoord(C1,C1->T[i+1]),CalcNurbsCCoord(C1,C1->T[i]));	// C1̃R[h
	for(int i=0;i<C2->N-1;i++)
		l2 += CalcDistance(CalcNurbsCCoord(C2,C2->T[i+1]),CalcNurbsCCoord(C2,C2->T[i]));	// C2̃R[h
	c = l1/(l1+l2);	// _̃mbgxNgl

	// C_̃mbgxNg͈͂𓾂
	Vector T1 = NewVector(C1->N);	
	Vector T2 = NewVector(C2->N);	
	CopyVector(C1->T,C1->N,T1);		// C1̃mbgxNgT1ɃRs[
	CopyVector(C2->T,C2->N,T2);		// C2̃mbgxNgT2ɃRs[
	ChangeKnotVecRange(T1,C1->N,C1->M,C1->K,s,c);	// C1(T1)̃mbgxNg͈̔͂ύX
	ChangeKnotVecRange(T2,C2->N,C2->M,C2->K,c,e);	// C2(U2)̃mbgxNg͈̔͂ύX
	C_->V[0] = s;						// C_̃mbgxNg͈̔
	C_->V[1] = e;
	C_->N = C1->N + C2->N - C2->M - 1;	// C_̃mbgxNg

	// C_̃mbgxNg𓾂
	for(int i=0;i<C1->K;i++)
		C_->T[i] = T1[i];
	for(int i=1;i<C2->N;i++)
		C_->T[C1->K+i-1] = T2[i];

	FreeVector(T1);
	FreeVector(T2);
}

//  2{̋ȐqƂ̃Rg[|CgƃEFCgݒ肷
void NURBS_Func::SetCPC_ConnectC(NURBSC *C1,NURBSC *C2,NURBSC *C_)
{
	C_->K = C1->K + C2->K - 1;

	for(int i=0;i<C1->K;i++){
		C_->cp[i] = SetCoord(C1->cp[i]);
		C_->W[i] = C1->W[i];
	}
	for(int i=1;i<C2->K;i++){
		C_->cp[C1->K+i-1] = SetCoord(C2->cp[i]);
		C_->W[C1->K+i-1] = C2->W[i];
	}
}


// NURBSȐɐVȃmbg}
//    *CFNURBSȐ  *C_F}ΏۂNURBSȐ     tF}mbg     degFdx
// Ԓl   kFVȃmbgxNgɂt̑}ʒu
int NURBS_Func::InsertNewKnotOnNurbsC(NURBSC *C,NURBSC *C_,double t,int deg)
{
	int k=0;					// t̑}ʒu
	int m = C->M;				// K
	int n = C->K;				// Rg[|Cg̐

	double *T_buf = NewVector(C->K+C->M+deg);	// mbgxNgꎞi[pobt@
	Coord *cp_buf = NewCoord1(C->K+deg);			// Rg[|Cgꎞi[pobt@
	double *W_buf = NewVector(C->K+deg);		// EFCgꎞi[pobt@
	//double T_buf[C->K+C->M+deg];
	//Coord  cp_buf[C->K+deg];
	//double W_buf[C->K+deg];


	// C_ɌNURBSȐT,cp,WlƂđ
	for(int i=0;i<m+n;i++)
		C_->T[i] = C->T[i];
	for(int i=0;i<n;i++)
		C_->cp[i] = SetCoord(C->cp[i]);
	for(int i=0;i<n;i++)
		C_->W[i] = C->W[i];

	// dxCt̑}JԂ
	for(int count=0;count<deg;count++){
		// ebufC_T,cp,W
		for(int i=0;i<n+m;i++)
			T_buf[i] = C_->T[i];
		for(int i=0;i<n;i++)
			cp_buf[i] = SetCoord(C_->cp[i]);
		for(int i=0;i<n;i++)
			W_buf[i] = C_->W[i];

		// t̑}ʒuk𒲂ׂ
		k=0;
		for(int i=0;i<n+m-1;i++){
			if(t >= T_buf[i] && t < T_buf[i+1]){
				k = i;
				break;
			}
		}

		// C_̃mbgxNgXV
		for(int i=0;i<=k;i++)
			C_->T[i] = T_buf[i];
		C_->T[k+1] = t;
		for(int i=k+2;i<=n+m;i++)
			C_->T[i] = T_buf[i-1];

		// Rg[|CgƃEFCg̍XV
		for(int i=0;i<=k-m+1;i++){
			C_->cp[i] = SetCoord(cp_buf[i]);
			C_->W[i] = W_buf[i];
		}
		for(int i=k-m+2;i<=k;i++){
			double a = (t-T_buf[i])/(T_buf[i+m-1]-T_buf[i]);
			C_->cp[i] = AddCoord(MulCoord(cp_buf[i-1],1-a),MulCoord(cp_buf[i],a));
			C_->W[i] = (1-a)*W_buf[i-1] + a*W_buf[i];
		}
		for(int i=k+1;i<=n;i++){
			C_->cp[i] = SetCoord(cp_buf[i-1]);
			C_->W[i] = W_buf[i-1];
		}

		n++;
	}

	FreeVector(T_buf);
	FreeVector(W_buf);
	FreeCoord1(cp_buf);

	return k+2;
}
